=== modified file 'DBUS-API'
--- DBUS-API	2010-09-26 18:32:58 +0000
+++ DBUS-API	2011-09-18 16:04:23 +0000
@@ -86,15 +86,17 @@
    | CheckerRunning (c)      | b    | Read/Write | N/A                 |
    | Created (d)             | s    | Read       | N/A                 |
    | Enabled (e)             | b    | Read/Write | N/A                 |
+   | Expires (f)             | s    | Read       | N/A                 |
+   | ExtendedTimeout (a)     | t    | Read/Write | extended_timeout    |
    | Fingerprint             | s    | Read       | fingerprint         |
    | Host                    | s    | Read/Write | host                |
    | Interval (a)            | t    | Read/Write | interval            |
-   | LastApprovalRequest (f) | s    | Read       | N/A                 |
-   | LastCheckedOK (g)       | s    | Read/Write | N/A                 |
-   | LastEnabled (h)         | s    | Read       | N/A                 |
+   | LastApprovalRequest (g) | s    | Read       | N/A                 |
+   | LastCheckedOK (h)       | s    | Read/Write | N/A                 |
+   | LastEnabled (i)         | s    | Read       | N/A                 |
    | Name                    | s    | Read       | (Section name)      |
    | ObjectPath              | o    | Read       | N/A                 |
-   | Secret (i)              | ay   | Write      | secret (or secfile) |
+   | Secret (j)              | ay   | Write      | secret (or secfile) |
    | Timeout (a)             | t    | Read/Write | timeout             |
    
    a) Represented as milliseconds.
@@ -104,25 +106,28 @@
    c) Setting this property is equivalent to calling StartChecker() or
       StopChecker().
    
-   d) The creation time of this client object, as a RFC 3339 string.
+   d) The creation time of this client object, as an RFC 3339 string.
    
    e) Setting this property is equivalent to calling Enable() or
       Disable().
    
-   f) The time of the last approval request, as a RFC 3339 string, or
-      an empty string if this has not happened.
-   
-   g) The last time a checker was successful, as a RFC 3339 string, or
-      an empty string if this has not happened.  Setting this property
-      is equivalent to calling CheckedOK(), i.e. the current time is
-      set, regardless of the string sent.  Please always use an empty
-      string when setting this property, to allow for possible future
-      expansion.
-   
-   h) The last time this client was enabled, as a RFC 3339 string, or
-      an empty string if this has not happened.
-   
-   i) A raw byte array, not hexadecimal digits.
+   f) The date and time this client will be disabled, as an RFC 3339
+      string, or an empty string if this has not happened.
+   
+   g) The date and time of the last approval request, as an RFC 3339
+      string, or an empty string if this has not happened.
+   
+   h) The date and time a checker was last successful, as an RFC 3339
+      string, or an empty string if this has not happened.  Setting
+      this property is equivalent to calling CheckedOK(), i.e. the
+      current time is set, regardless of the string sent.  Please
+      always use an empty string when setting this property, to allow
+      for possible future expansion.
+   
+   i) The date and time this client was last enabled, as an RFC 3339
+      string, or an empty string if this has not happened.
+   
+   j) A raw byte array, not hexadecimal digits.
 
 ** Signals
 *** CheckerCompleted(n: Exitcode, x: Waitstatus, s: Command)
@@ -140,17 +145,17 @@
     This client will be approved or denied in exactly Timeout
     milliseconds, depending on ApprovedByDefault.  Approve() can now
     usefully be called on this client object.
-
+    
 *** PropertyChanged(s: Property, v: Value)
     The Property on this client has changed to Value.
-
+    
 *** Rejected(s: Reason)
     This client was not given its secret for a specified Reason.
 
 * Copyright
 
-    Copyright © 2010 Teddy Hogeborn
-    Copyright © 2010 Björn Påhlsson
+    Copyright © 2010-2011 Teddy Hogeborn
+    Copyright © 2010-2011 Björn Påhlsson
   
 ** License:
    

=== modified file 'INSTALL'
--- INSTALL	2009-02-15 09:28:06 +0000
+++ INSTALL	2011-03-08 19:09:03 +0000
@@ -4,14 +4,14 @@
   
 ** Operating System
    
-   Debian 5.0 "lenny" or Ubuntu 8.04 "Hardy Heron".
+   Debian 6.0 "squeeze" or Ubuntu 10.10 "Maverick Meerkat".
    
    This is mostly for the support scripts which make sure that the
    client is installed and started in the initial RAM disk environment
    and that the initrd.img file is automatically made unreadable.  The
    server and client programs themselves *could* be run in other
    distributions, but they *are* specific to GNU/Linux systems, and
-   are not intended to be portable to other Unixes.
+   are not written with portabillity to other Unixes in mind.
   
 ** Libraries
    
@@ -39,18 +39,18 @@
 *** Mandos Server
     + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
     + Avahi 0.6.16        http://www.avahi.org/
-    + Python 2.5          http://www.python.org/
+    + Python 2.6          http://www.python.org/
     + Python-GnuTLS 1.1.5 http://pypi.python.org/pypi/python-gnutls/
     + dbus-python 0.82.4  http://dbus.freedesktop.org/doc/dbus-python/
-    + python-ctypes 1.0.0 http://pypi.python.org/pypi/ctypes
     + PyGObject 2.14.2    http://library.gnome.org/devel/pygobject/
+    + Urwid 0.9.8.3       http://excess.org/urwid/
     
     Strongly recommended:
     + fping 2.4b2-to-ipv6 http://www.fping.com/
     
     Package names:
     python-gnutls avahi-daemon python python-avahi python-dbus
-    python-ctypes python-gobject
+    python-gobject python-urwid
    
 *** Mandos Client
     + initramfs-tools 0.85i
@@ -99,16 +99,20 @@
      server computer*.
   
   4. Configure the client to use the correct network interface.  The
-     default is "eth0", and if this needs to be adjusted, it will be
-     necessary to edit /etc/mandos/plugin-runner.conf to uncomment and
-     change the line there.  If that file is changed, the initrd.img
-     file must be updated, possibly using the following command:
+     interface to use is automatically chosen at boot, and if this
+     needs to be adjusted, it will be necessary to edit
+     /etc/initramfs-tools/initramfs.conf to change the DEVICE setting
+     there.  Alternatively, the file /etc/mandos/plugin-runner.conf
+     can be edited to add a "--device" parameter for the
+     mandos-client(8) plugin.  Please note: If any of those files are
+     changed, the initrd.img file must be updated, possibly using the
+     following command:
      
 	# update-initramfs -k all -u
   
   5. On the server computer, start the server by running the command
      For Debian: su -c 'invoke-rc.d mandos start'
-     For Ubuntu: sudo invoke-rc.d mandos start
+     For Ubuntu: sudo service mandos start
      
      At this point, it is possible to verify that the correct password
      will be received by the client by running the command:

=== modified file 'Makefile'
--- Makefile	2010-10-11 17:45:21 +0000
+++ Makefile	2011-08-17 22:46:35 +0000
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.2.3
+version=1.3.1
 SED=sed
 
 ## Use these settings for a traditional /usr/local install
@@ -54,7 +54,7 @@
 CFLAGS=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
 	$(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS) \
 	-DVERSION='"$(version)"'
-LDFLAGS=$(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
+LDFLAGS=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
 
 # Commands to format a DocBook <refentry> document into a manual page
 DOCBOOKTOMAN=$(strip cd $(dir $<); xsltproc --nonet --xinclude \
@@ -92,7 +92,7 @@
 	plugins.d/mandos-client.8mandos \
 	plugins.d/password-prompt.8mandos plugins.d/usplash.8mandos \
 	plugins.d/splashy.8mandos plugins.d/askpass-fifo.8mandos \
-	plugins.d/plymouth.8mandos
+	plugins.d/plymouth.8mandos intro.8mandos
 
 htmldocs=$(addsuffix .xhtml,$(DOCS))
 
@@ -119,6 +119,11 @@
 %.8mandos.xhtml: %.xml common.ent legalnotice.xml
 	$(DOCBOOKTOHTML)
 
+intro.8mandos: intro.xml common.ent legalnotice.xml
+	$(DOCBOOKTOMAN)
+intro.8mandos.xhtml: intro.xml common.ent legalnotice.xml
+	$(DOCBOOKTOHTML)
+
 mandos.8: mandos.xml common.ent mandos-options.xml overview.xml \
 		legalnotice.xml
 	$(DOCBOOKTOMAN)
@@ -210,8 +215,8 @@
 		$@)
 
 plugins.d/mandos-client: plugins.d/mandos-client.c
-	$(LINK.c) $(GNUTLS_LIBS) $(AVAHI_LIBS) $(GPGME_LIBS) $(strip\
-		) $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
+	$(LINK.c) $^ -lrt $(GNUTLS_LIBS) $(AVAHI_LIBS) $(strip\
+		) $(GPGME_LIBS) $(LOADLIBES) $(LDLIBS) -o $@
 
 .PHONY : all doc html clean distclean run-client run-server install \
 	install-server install-client uninstall uninstall-server \

=== modified file 'NEWS'
--- NEWS	2010-10-11 17:45:21 +0000
+++ NEWS	2011-07-27 17:58:27 +0000
@@ -1,6 +1,19 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
+Version 1.3.1 (2011-07-27)
+* Client:
+** Client now retries all Mandos servers periodically.
+** Work around Debian bug #633582 - fixes "Permission denied" problem.
+
+Version 1.3.0 (2011-03-08)
+* Server:
+** Updated for Python 2.6.
+* Client:
+** Bug fix: Make the password-prompt plugin not conflict with
+   Plymouth.
+** Bug fix: Bug fix: update initramfs also when purging package.
+
 Version 1.2.3 (2010-10-11)
 * Server:
 ** Bug fix: Expose D-Bus API also in non-debug mode.

=== modified file 'README'
--- README	2010-09-26 18:32:58 +0000
+++ README	2011-09-18 14:28:47 +0000
@@ -1,182 +1,10 @@
--*- org -*-
-
-* Mandos
-  - Have your cake and eat it too!
-  
-  You know how it is.  You’ve heard of it happening.  The Man comes
-  and takes away your servers, your friends’ servers, the servers of
-  everybody in the same hosting facility. The servers of their
-  neighbors, and their neighbors’ friends.  The servers of people who
-  owe them money.  And like *that*, they’re gone.  And you doubt
-  you’ll ever see them again.
-  
-  That is why your servers have encrypted root file systems.  However,
-  there’s a downside.  There’s no going around it: rebooting is a
-  pain.  Dragging out that rarely-used keyboard and screen and
-  unraveling cables behind your servers to plug them in to type in
-  that password is messy, especially if you have many servers.  There
-  are some people who do clever things like using serial line consoles
-  and daisy-chain it to the next server, and keep all the servers
-  connected in a ring with serial cables, which will work, if your
-  servers are physically close enough.  There are also other
-  out-of-band management solutions, but with *all* these, you still
-  have to be on hand and manually type in the password at boot time.
-  Otherwise the server just sits there, waiting for a password.
-  
-  Wouldn’t it be great if you could have the security of encrypted
-  root file systems and still have servers that could boot up
-  automatically if there was a short power outage while you were
-  asleep?  That you could reboot at will, without having someone run
-  over to the server to type in the password?
-  
-  Well, with Mandos, you (almost) can!  The gain in convenience will
-  only be offset by a small loss in security.  The setup is as
-  follows:
-  
-  The server will still have its encrypted root file system.  The
-  password to this file system will be stored on another computer
-  (henceforth known as the Mandos server) on the same local network.
-  The password will *not* be stored in plaintext, but encrypted with
-  OpenPGP.  To decrypt this password, a key is needed.  This key (the
-  Mandos client key) will not be stored there, but back on the
-  original server (henceforth known as the Mandos client) in the
-  initial RAM disk image.  Oh, and all network Mandos client/server
-  communications will be encrypted, using TLS (SSL).
-  
-  So, at boot time, the Mandos client will ask for its encrypted data
-  over the network, decrypt it to get the password, use it to decrypt
-  the root file, and continue booting.
-  
-  Now, of course the initial RAM disk image is not on the encrypted
-  root file system, so anyone who had physical access could take the
-  Mandos client computer offline and read the disk with their own
-  tools to get the authentication keys used by a client.  *But*, by
-  then the Mandos server should notice that the original server has
-  been offline for too long, and will no longer give out the encrypted
-  key.  The timing here is the only real weak point, and the method,
-  frequency and timeout of the server’s checking can be adjusted to
-  any desired level of paranoia
-  
-  (The encrypted keys on the Mandos server is on its normal file
-  system, so those are safe, provided the root file system of *that*
-  server is encrypted.)
-
-* FAQ - couldn’t the security be defeated by...
-
-** Grabbing the Mandos client key from the initrd *really quickly*?
-   This, as mentioned above, is the only real weak point.  But if you
-   set the timing values tight enough, this will be really difficult
-   to do.  An attacker would have to physically disassemble the client
-   computer, extract the key from the initial RAM disk image, and then
-   connect to a *still online* Mandos server to get the encrypted key,
-   and do all this *before* the Mandos server timeout kicks in and the
-   Mandos server refuses to give out the key to anyone.
-   
-   Now, as the typical procedure seems to be to barge in and turn off
-   and grab *all* computers, to maybe look at them months later, this
-   is not likely.  If someone does that, the whole system *will* lock
-   itself up completely, since Mandos servers are no longer running.
-   
-   For sophisticated attackers who *could* do the clever thing, *and*
-   had physical access to the server for enough time, it would be
-   simpler to get a key for an encrypted file system by using hardware
-   memory scanners and reading it right off the memory bus.
-
-** Replay attacks?
-   Nope, the network stuff is all done over TLS, which provides
-   protection against that.
-
-** Man-in-the-middle?
-   No.  The server only gives out the passwords to clients which have
-   *in the TLS handshake* proven that they do indeed hold the OpenPGP
-   private key corresponding to that client.
-
-** Physically grabbing the Mandos server computer?
-   You could protect *that* computer the old-fashioned way, with a
-   must-type-in-the-password-at-boot method.  Or you could have two
-   computers be the Mandos server for each other.
-   
-   Multiple Mandos servers can coexist on a network without any
-   trouble.  They do not clash, and clients will try all available
-   servers.  This means that if just one reboots then the other can
-   bring it back up, but if both reboot at the same time they will
-   stay down until someone types in the password on one of them.
-
-** Faking ping replies?
-   The default for the server is to use "fping", the replies to which
-   could be faked to eliminate the timeout.  But this could easily be
-   changed to any shell command, with any security measures you like.
-   It could, for instance, be changed to an SSH command with strict
-   keychecking, which could not be faked.  Or IPsec could be used for
-   the ping packets, making them secure.
-
-* Security Summary
-  So, in summary:  The only weakness in the Mandos system is from
-  people who have:
-  1. The power to come in and physically take your servers, *and*
-  2. The cunning and patience to do it carefully, one at a time, and
-     *quickly*, faking Mandos client/server responses for each one
-     before the timeout.
-  
-  While there are some who may be threatened by people who have *both*
-  these attributes, they do not, probably, constitute the majority.
-  
-  If you *do* face such opponents, you must figure that they could
-  just as well open your servers and read the file system keys right
-  off the memory by running wires to the memory bus.
-  
-  What Mandos is designed to protect against is *not* such determined,
-  focused, and competent attacks, but against the early morning knock
-  on your door and the sudden absence of all the servers in your
-  server room.  Which it does nicely.
-
-* The Plugin System
-  In the early designs, the mandos-client(8mandos) program (which
-  retrieves a password from the Mandos server) also prompted for a
-  password on the terminal, in case a Mandos server could not be
-  found.  Other ways of retrieving a password could easily be
-  envisoned, but this multiplicity of purpose was seen to be too
-  complex to be a viable way to continue.  Instead, the original
-  program was separated into mandos-client(8mandos) and
-  password-prompt(8mandos), and a plugin-runner(8mandos) exist to run
-  them both in parallel, allowing the first successful plugin to
-  provide the password.  This opened up for any number of additional
-  plugins to run, all competing to be the first to find a password and
-  provide it to the plugin runner.
-  
-  Four additional plugins are provided:
-  * plymouth(8mandos)
-    This prompts for a password when using plymouth(8).
-  * usplash(8mandos)
-    This prompts for a password when using usplash(8).
-  * splashy(8mandos)
-    This prompts for a password when using splashy(8).
-  * askpass-fifo(8mandos)
-    To provide compatibility with the "askpass" program from
-    cryptsetup, this plugin listens to the same FIFO as askpass would
-    do.
-  
-  More plugins can easily be written and added by the system
-  administrator; see the section called "WRITING PLUGINS" in
-  plugin-runner(8mandos) to learn the plugin requirements.
-
-* Copyright
-
-    Copyright © 2008-2010 Teddy Hogeborn
-    Copyright © 2008-2010 Björn Påhlsson
-  
-** License:
-   
-   This program is free software: you can redistribute it and/or
-   modify it under the terms of the GNU General Public License as
-   published by the Free Software Foundation, either version 3 of the
-   License, or (at your option) any later version.
-
-   This program is distributed in the hope that it will be useful, but
-   WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program.  If not, see
-   <http://www.gnu.org/licenses/>.
+Please see: http://www.fukt.bsnet.se/mandos/man/intro.8mandos
+
+This information previously in this file has been moved to the
+intro(8mandos) manual page.  Go to the above URL, or run this command:
+
+	man 8mandos intro
+
+In short, this is the Mandos system; it allows computers to have
+encrypted root file systems and at the same time be capable of remote
+and/or unattended reboots.

=== modified file 'TODO'
--- TODO	2010-09-26 18:32:58 +0000
+++ TODO	2011-09-26 19:34:23 +0000
@@ -2,42 +2,45 @@
 
 * Use _attribute_((nonnull)) wherever possible.
 
+* [[http://www.undeadly.org/cgi?action=article&sid=20110530221728][OpenBSD]]
+
+* mandos-applet
+
 * mandos-client
-** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
-** TODO [#B] Retry a server which has a non-definite reply:
-*** A closed connection during the TLS handshake
-*** A TCP timeout
 ** TODO [#B] Use capabilities instead of seteuid().
-** TODO [#A] Retry --connect forever
+** TODO [#B] Use struct sockaddr_storage instead of a union
+** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
+** TODO [#B] Use getnameinfo(serv=NULL, NI_NUMERICHOST) instead of inet_ntop()
+** TODO [#B] Prefer /run/tmp over /tmp, if it exists
 
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
 
 * usplash
 ** TODO [#A] Make it work again
 ** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
 ** TODO Use [[info:libc:Argz%20Functions][argz_extract]]
 
 * askpass-fifo
-** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
 ** TODO [#B] Drop privileges after opening FIFO.
 
 * password-prompt
-** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
 ** TODO [#B] lock stdin (with flock()?)
 
+* plymouth
+
 * TODO [#B] passdev
 
 * plugin-runner
+** TODO handle printing for errors for plugins
+*** Hook up stderr of plugins, buffer them, and prepend mandos pluig [plugin name]
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#C] use same file name rules as run-parts(8)
 ** kernel command line option for debug info
 ** TODO [#B] Use openat()
 
 * mandos (server)
+** TODO [#A] Make all attributes properties!
 ** TODO [#B] Log level							  :BUGS:
 ** TODO Persistent state						  :BUGS:
    /var/lib/mandos/*
@@ -56,21 +59,8 @@
 ** TODO [#C] DBusServiceObjectUsingSuper
 ** TODO [#B] Global enable/disable flag
 ** TODO [#B] By-client countdown on secrets given
-** TODO [#B] Fix problem with fsck taking a really long time
-   Whenever a client successfully gets a secret it could get a
-   one-time timeout boost to allow for an fsck-incurred delay
-** TODO [#A] Delay before client receives key
-   This would give an operator opportunity to cancel the request if
-   desired.
-** TODO [#A] Client manual approval mode
-   A client needs manual approval on the server before it gets the
-   secret
 ** TODO [#B] Support RFC 3339 time duration syntax
 ** More D-Bus methods
-*** NeedsApproval(50, True) -> timeout, default approve
-    Default approval is configurable, but True by default
-    + Approve(True) -> approve sending saved
-    + Approve(False) -> Close client connection immediately
 *** NeedsPassword(50) - Timeout, default disapprove
     + SetPass(u"gazonk", True) -> Approval, persistent
     + Approve(False) -> Close client connection immediately
@@ -83,6 +73,7 @@
 ** TODO [#B] break the wait on approval_delay if connection dies
 ** TODO Generate Client.runtime_expansions from client options + extra
 ** TODO Allow %%(checker)s as a runtime expansion
+** TODO Use python-tlslite?
 
 * mandos.xml
 ** Add mandos contact info in manual pages
@@ -97,7 +88,7 @@
   arguments.
 
 * mandos-monitor
-** TODO help should be toggable
+** TODO help should be toggleable
 ** Urwid client data displayer
    Better view of client data in the listing
 *** Properties popup
@@ -106,15 +97,12 @@
 ** Show timeout countdown for approval
 
 * mandos-keygen
-** TODO Loop until passwords match when run interactively
 ** TODO "--secfile" option
    Using the "secfile" option instead of "secret"
 ** TODO [#B] "--test" option
    For testing decryption before rebooting.
 
 * Makefile
-** TODO Add "--Xlinker --as-needed"
-   http://udrepper.livejournal.com/19395.html
 ** TODO [#C] Implement DEB_BUILD_OPTIONS
    http://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
 

=== modified file 'clients.conf'
--- clients.conf	2010-09-12 03:00:40 +0000
+++ clients.conf	2011-09-19 09:42:55 +0000
@@ -4,14 +4,19 @@
 
 # How long until a client is disabled and not be allowed to get the
 # data this server holds.
-;timeout = 1h
+;timeout = 5m
 
 # How often to run the checker to confirm that a client is still up.
 # Note: a new checker will not be started if an old one is still
 # running.  The server will wait for a checker to complete until the
 # above "timeout" occurs, at which time the client will be disabled,
 # and any running checker killed.
-;interval = 5m
+;interval = 2m
+
+# Extended timeout is an added timeout that is given once after a
+# password has been sent sucessfully to a client.  This allows for
+# additional delays caused by file system checks and quota checks.
+;extended_timeout = 15m
 
 # What command to run as "the checker".
 ;checker = fping -q -- %%(host)s
@@ -70,7 +75,7 @@
 ;host = 192.0.2.3
 ;
 ;# Parameters from the [DEFAULT] section can be overridden per client.
-;interval = 5m
+;interval = 1m
 ;
 ;# This client requires manual approval before it receives its secret.
 ;approved_by_default = False

=== modified file 'common.ent'
--- common.ent	2010-10-11 17:45:21 +0000
+++ common.ent	2011-07-27 17:58:27 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.2.3">
+<!ENTITY version "1.3.1">

=== modified file 'debian/changelog'
--- debian/changelog	2010-10-11 17:45:21 +0000
+++ debian/changelog	2011-07-27 17:58:27 +0000
@@ -1,3 +1,23 @@
+mandos (1.3.1-1) unstable; urgency=low
+
+  * New upstream release.
+  * Conflict with correct version of dropbear.
+  * New version uses argparse; depend on python (<=2.7) | python-argparse.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Wed, 27 Jul 2011 19:47:17 +0200
+
+mandos (1.3.0-1) unstable; urgency=low
+
+  * New upstream release.
+  * debian/control (mandos): Depend on Python 2.6, remove dependency on
+    python-multiprocessing.
+  (mandos-client): Conflict with dropbear (<< 0.52-5).
+  * debian/mandos-client.postrm (purge): Bug fix: update initramfs also on
+    purge.
+  * debian/mandos-client.lintian-overrides: Added plugins.d/plymouth.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 08 Mar 2011 20:22:57 +0100
+
 mandos (1.2.3-1) experimental; urgency=low
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2010-10-01 18:40:55 +0000
+++ debian/control	2011-09-18 15:03:26 +0000
@@ -14,11 +14,11 @@
 
 Package: mandos
 Architecture: all
-Depends: ${misc:Depends}, python (>=2.5), python-gnutls, python-dbus,
+Depends: ${misc:Depends}, python (>=2.6), python-gnutls, python-dbus,
 	python-avahi, python-gobject, avahi-daemon, adduser,
-	python-urwid, python (>=2.6) | python-multiprocessing
+	python-urwid, python (>=2.7) | python-argparse
 Recommends: fping
-Description: a server giving encrypted passwords to Mandos clients
+Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
  computers to have encrypted root file systems and at the
  same time be capable of remote and/or unattended reboots.
@@ -37,6 +37,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
 	gnupg (<< 2)
+Conflicts: dropbear (<= 0.52-5)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system
  This is the client part of the Mandos system, which allows

=== modified file 'debian/copyright'
--- debian/copyright	2010-09-26 18:32:58 +0000
+++ debian/copyright	2011-02-27 17:26:35 +0000
@@ -5,8 +5,8 @@
 Upstream-Source: <http://www.fukt.bsnet.se/mandos>
 
 Files: *
-Copyright: Copyright © 2008-2010 Teddy Hogeborn
-Copyright: Copyright © 2008-2010 Björn Påhlsson
+Copyright: Copyright © 2008-2011 Teddy Hogeborn
+Copyright: Copyright © 2008-2011 Björn Påhlsson
 License: GPL-3+
     This program is free software: you can redistribute it and/or
     modify it under the terms of the GNU General Public License as

=== modified file 'debian/mandos-client.lintian-overrides'
--- debian/mandos-client.lintian-overrides	2009-01-18 06:41:57 +0000
+++ debian/mandos-client.lintian-overrides	2010-10-13 06:12:52 +0000
@@ -19,6 +19,7 @@
 mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/askpass-fifo 4755 root/root
 mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/splashy 4755 root/root
 mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/usplash 4755 root/root
+mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/plymouth 4755 root/root
 
 # The directory /etc/mandos/plugins.d can be used by local system
 # administrators to place plugins in, overriding and complementing

=== modified file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2009-01-18 00:16:57 +0000
+++ debian/mandos-client.postrm	2011-02-27 17:00:41 +0000
@@ -45,6 +45,7 @@
 	rm --force /etc/mandos/plugin-runner.conf \
 	    /etc/keys/mandos/pubkey.txt \
 	    /etc/keys/mandos/seckey.txt 2>/dev/null
+	update_initramfs
 	;;
     upgrade|failed-upgrade|disappear|abort-install|abort-upgrade)
 	;;

=== modified file 'initramfs-tools-script'
--- initramfs-tools-script	2009-09-16 23:28:39 +0000
+++ initramfs-tools-script	2011-07-16 00:29:19 +0000
@@ -108,6 +108,7 @@
 
 # Our keyscript
 mandos=/lib/mandos/plugin-runner
+test -x "$mandos"
 
 # parse /conf/conf.d/cryptroot.  Format:
 # target=sda2_crypt,source=/dev/sda2,key=none,keyscript=/foo/bar/baz

=== added file 'intro.xml'
--- intro.xml	1970-01-01 00:00:00 +0000
+++ intro.xml	2011-08-08 21:12:37 +0000
@@ -0,0 +1,410 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
+"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY TIMESTAMP "2011-08-08">
+<!ENTITY % common SYSTEM "common.ent">
+%common;
+]>
+
+<refentry xmlns:xi="http://www.w3.org/2001/XInclude">
+   <refentryinfo>
+    <title>Mandos Manual</title>
+    <!-- NWalsh’s docbook scripts use this to generate the footer: -->
+    <productname>Mandos</productname>
+    <productnumber>&version;</productnumber>
+    <date>&TIMESTAMP;</date>
+    <authorgroup>
+      <author>
+	<firstname>Björn</firstname>
+	<surname>Påhlsson</surname>
+	<address>
+	  <email>belorn@fukt.bsnet.se</email>
+	</address>
+      </author>
+      <author>
+	<firstname>Teddy</firstname>
+	<surname>Hogeborn</surname>
+	<address>
+	  <email>teddy@fukt.bsnet.se</email>
+	</address>
+      </author>
+    </authorgroup>
+    <copyright>
+      <year>2011</year>
+      <holder>Teddy Hogeborn</holder>
+      <holder>Björn Påhlsson</holder>
+    </copyright>
+    <xi:include href="legalnotice.xml"/>
+  </refentryinfo>
+  
+  <refmeta>
+    <refentrytitle>intro</refentrytitle>
+    <manvolnum>8mandos</manvolnum>
+  </refmeta>
+  
+  <refnamediv>
+    <refname>intro</refname>
+    <refpurpose>
+      Introduction to the Mandos system
+    </refpurpose>
+  </refnamediv>
+  
+  <refsect1 id="description">
+    <title>DESCRIPTION</title>
+    <para>
+      This is the the Mandos system, which allows computers to have
+      encrypted root file systems and at the same time be capable of
+      remote and/or unattended reboots.
+    </para>
+    <para>
+      The computers run a small client program in the initial RAM disk
+      environment which will communicate with a server over a network.
+      All network communication is encrypted using TLS.  The clients
+      are identified by the server using an OpenPGP key; each client
+      has one unique to it.  The server sends the clients an encrypted
+      password.  The encrypted password is decrypted by the clients
+      using the same OpenPGP key, and the password is then used to
+      unlock the root file system, whereupon the computers can
+      continue booting normally.
+    </para>
+  </refsect1>
+  
+  <refsect1 id="introduction">
+    <title>INTRODUCTION</title>
+    <para>
+      You know how it is.  You’ve heard of it happening.  The Man
+      comes and takes away your servers, your friends’ servers, the
+      servers of everybody in the same hosting facility. The servers
+      of their neighbors, and their neighbors’ friends.  The servers
+      of people who owe them money.  And like
+      <emphasis>that</emphasis>, they’re gone.  And you doubt you’ll
+      ever see them again.
+    </para>
+    <para>
+      That is why your servers have encrypted root file systems.
+      However, there’s a downside.  There’s no going around it:
+      rebooting is a pain.  Dragging out that rarely-used keyboard and
+      screen and unraveling cables behind your servers to plug them in
+      to type in that password is messy, especially if you have many
+      servers.  There are some people who do clever things like using
+      serial line consoles and daisy-chain it to the next server, and
+      keep all the servers connected in a ring with serial cables,
+      which will work, if your servers are physically close enough.
+      There are also other out-of-band management solutions, but with
+      <emphasis>all</emphasis> these, you still have to be on hand and
+      manually type in the password at boot time.  Otherwise the
+      server just sits there, waiting for a password.
+    </para>
+    <para>
+      Wouldn’t it be great if you could have the security of encrypted
+      root file systems and still have servers that could boot up
+      automatically if there was a short power outage while you were
+      asleep?  That you could reboot at will, without having someone
+      run over to the server to type in the password?
+    </para>
+    <para>
+      Well, with Mandos, you (almost) can!  The gain in convenience
+      will only be offset by a small loss in security.  The setup is
+      as follows:
+    </para>
+    <para>
+      The server will still have its encrypted root file system.  The
+      password to this file system will be stored on another computer
+      (henceforth known as the Mandos server) on the same local
+      network.  The password will <emphasis>not</emphasis> be stored
+      in plaintext, but encrypted with OpenPGP.  To decrypt this
+      password, a key is needed.  This key (the Mandos client key)
+      will not be stored there, but back on the original server
+      (henceforth known as the Mandos client) in the initial RAM disk
+      image.  Oh, and all network Mandos client/server communications
+      will be encrypted, using TLS (SSL).
+    </para>
+    <para>
+      So, at boot time, the Mandos client will ask for its encrypted
+      data over the network, decrypt it to get the password, use it to
+      decrypt the root file, and continue booting.
+    </para>
+    <para>
+      Now, of course the initial RAM disk image is not on the
+      encrypted root file system, so anyone who had physical access
+      could take the Mandos client computer offline and read the disk
+      with their own tools to get the authentication keys used by a
+      client.  <emphasis>But</emphasis>, by then the Mandos server
+      should notice that the original server has been offline for too
+      long, and will no longer give out the encrypted key.  The timing
+      here is the only real weak point, and the method, frequency and
+      timeout of the server’s checking can be adjusted to any desired
+      level of paranoia
+    </para>
+    <para>
+      (The encrypted keys on the Mandos server is on its normal file
+      system, so those are safe, provided the root file system of
+      <emphasis>that</emphasis> server is encrypted.)
+    </para>
+  </refsect1>
+  
+  <refsect1 id="faq">
+    <title>FREQUENTLY ASKED QUESTIONS</title>
+    <para>
+      Couldn’t the security be defeated by…
+    </para>
+    <refsect2 id="quick">
+      <title>Grabbing the Mandos client key from the
+      initrd <emphasis>really quickly</emphasis>?</title>
+    <para>
+      This, as mentioned above, is the only real weak point.  But if
+      you set the timing values tight enough, this will be really
+      difficult to do.  An attacker would have to physically
+      disassemble the client computer, extract the key from the
+      initial RAM disk image, and then connect to a <emphasis>still
+      online</emphasis> Mandos server to get the encrypted key, and do
+      all this <emphasis>before</emphasis> the Mandos server timeout
+      kicks in and the Mandos server refuses to give out the key to
+      anyone.
+    </para>
+    <para>
+      Now, as the typical procedure seems to be to barge in and turn
+      off and grab <emphasis>all</emphasis> computers, to maybe look
+      at them months later, this is not likely.  If someone does that,
+      the whole system <emphasis>will</emphasis> lock itself up
+      completely, since Mandos servers are no longer running.
+    </para>
+    <para>
+      For sophisticated attackers who <emphasis>could</emphasis> do
+      the clever thing, <emphasis>and</emphasis> had physical access
+      to the server for enough time, it would be simpler to get a key
+      for an encrypted file system by using hardware memory scanners
+      and reading it right off the memory bus.
+    </para>
+    </refsect2>
+    
+    <refsect2 id="replay">
+      <title>Replay attacks?</title>
+      <para>
+	Nope, the network stuff is all done over TLS, which provides
+	protection against that.
+      </para>
+    </refsect2>
+    
+    <refsect2 id="mitm">
+      <title>Man-in-the-middle?</title>
+      <para>
+	No.  The server only gives out the passwords to clients which
+	have <emphasis>in the TLS handshake</emphasis> proven that
+	they do indeed hold the OpenPGP private key corresponding to
+	that client.
+      </para>
+    </refsect2>
+    
+    <refsect2 id="physgrab">
+      <title>Physically grabbing the Mandos server computer?</title>
+      <para>
+	You could protect <emphasis>that</emphasis> computer the
+	old-fashioned way, with a must-type-in-the-password-at-boot
+	method.  Or you could have two computers be the Mandos server
+	for each other.
+      </para>
+      <para>
+	Multiple Mandos servers can coexist on a network without any
+	trouble.  They do not clash, and clients will try all
+	available servers.  This means that if just one reboots then
+	the other can bring it back up, but if both reboot at the same
+	time they will stay down until someone types in the password
+	on one of them.
+      </para>
+    </refsect2>
+    
+    <refsect2 id="fakeping">
+      <title>Faking ping replies?</title>
+      <para>
+	The default for the server is to use
+	<quote><literal>fping</literal></quote>, the replies to which
+	could be faked to eliminate the timeout.  But this could
+	easily be changed to any shell command, with any security
+	measures you like.  It could, for instance, be changed to an
+	SSH command with strict keychecking, which could not be faked.
+	Or IPsec could be used for the ping packets, making them
+	secure.
+      </para>
+    </refsect2>
+  </refsect1>
+  
+  <refsect1 id="security">
+    <title>SECURITY</title>
+    <para>
+      So, in summary:  The only weakness in the Mandos system is from
+      people who have:
+    </para>
+    <orderedlist>
+      <listitem>
+	<para>
+	  The power to come in and physically take your servers,
+	  <emphasis>and</emphasis>
+	</para>
+      </listitem>
+      <listitem>
+	<para>
+	  The cunning and patience to do it carefully, one at a time,
+	  and <emphasis>quickly</emphasis>, faking Mandos
+	  client/server responses for each one before the timeout.
+	</para>
+      </listitem>
+    </orderedlist>
+    <para>
+      While there are some who may be threatened by people who have
+      <emphasis>both</emphasis> these attributes, they do not,
+      probably, constitute the majority.
+    </para>
+    <para>
+      If you <emphasis>do</emphasis> face such opponents, you must
+      figure that they could just as well open your servers and read
+      the file system keys right off the memory by running wires to
+      the memory bus.
+    </para>
+    <para>
+      What Mandos is designed to protect against is
+      <emphasis>not</emphasis> such determined, focused, and competent
+      attacks, but against the early morning knock on your door and
+      the sudden absence of all the servers in your server room.
+      Which it does nicely.
+    </para>
+  </refsect1>
+  
+  <refsect1 id="plugins">
+    <title>PLUGINS</title>
+    <para>
+      In the early designs, the
+      <citerefentry><refentrytitle>mandos-client</refentrytitle
+      ><manvolnum>8mandos</manvolnum></citerefentry> program (which
+      retrieves a password from the Mandos server) also prompted for a
+      password on the terminal, in case a Mandos server could not be
+      found.  Other ways of retrieving a password could easily be
+      envisoned, but this multiplicity of purpose was seen to be too
+      complex to be a viable way to continue.  Instead, the original
+      program was separated into <citerefentry><refentrytitle
+      >mandos-client</refentrytitle><manvolnum>8mandos</manvolnum
+      ></citerefentry> and <citerefentry><refentrytitle
+      >password-prompt</refentrytitle><manvolnum>8mandos</manvolnum
+      ></citerefentry>, and a <citerefentry><refentrytitle
+      >plugin-runner</refentrytitle><manvolnum>8mandos</manvolnum
+      ></citerefentry> exist to run them both in parallel, allowing
+      the first successful plugin to provide the password.  This
+      opened up for any number of additional plugins to run, all
+      competing to be the first to find a password and provide it to
+      the plugin runner.
+    </para>
+    <para>
+      Four additional plugins are provided:
+    </para>
+    <variablelist>
+      <varlistentry>
+	<term>
+	  <citerefentry><refentrytitle>plymouth</refentrytitle>
+	  <manvolnum>8mandos</manvolnum></citerefentry>
+	</term>
+	<listitem>
+	  <para>
+	    This prompts for a password when using <citerefentry>
+	    <refentrytitle>plymouth</refentrytitle><manvolnum
+	    >8</manvolnum></citerefentry>.
+	  </para>
+	</listitem>
+      </varlistentry>
+      <varlistentry>
+	<term>
+	  <citerefentry><refentrytitle>usplash</refentrytitle>
+	  <manvolnum>8mandos</manvolnum></citerefentry>
+	</term>
+	<listitem>
+	  <para>
+	    This prompts for a password when using <citerefentry>
+	    <refentrytitle>usplash</refentrytitle><manvolnum
+	    >8</manvolnum></citerefentry>.
+	  </para>
+	</listitem>
+      </varlistentry>
+      <varlistentry>
+	<term>
+	  <citerefentry><refentrytitle>splashy</refentrytitle>
+	  <manvolnum>8mandos</manvolnum></citerefentry>
+	</term>
+	<listitem>
+	  <para>
+	    This prompts for a password when using <citerefentry>
+	    <refentrytitle>splashy</refentrytitle><manvolnum
+	    >8</manvolnum></citerefentry>.
+	  </para>
+	</listitem>
+      </varlistentry>
+      <varlistentry>
+	<term>
+	  <citerefentry><refentrytitle>askpass-fifo</refentrytitle>
+	  <manvolnum>8mandos</manvolnum></citerefentry>
+	</term>
+	<listitem>
+	  <para>
+	    To provide compatibility with the "askpass" program from
+	    cryptsetup, this plugin listens to the same FIFO as
+	    askpass would do.
+	  </para>
+	</listitem>
+      </varlistentry>
+    </variablelist>
+    <para>
+      More plugins can easily be written and added by the system
+      administrator; see the section called "WRITING PLUGINS" in
+      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry> to learn the
+      plugin requirements.
+    </para>
+  </refsect1>
+  
+  <refsect1 id="see_also">
+    <title>SEE ALSO</title>
+    <para>
+      <citerefentry><refentrytitle>mandos</refentrytitle>
+      <manvolnum>8</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos.conf</refentrytitle>
+      <manvolnum>5</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
+      <manvolnum>5</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-ctl</refentrytitle>
+      <manvolnum>8</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-monitor</refentrytitle>
+      <manvolnum>8</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-client</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>password-prompt</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>plymouth</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>usplash</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>splashy</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>askpass-fifo</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-keygen</refentrytitle>
+      <manvolnum>8</manvolnum></citerefentry>
+    </para>
+    <variablelist>
+      <varlistentry>
+	<term>
+	  <ulink url="http://www.fukt.bsnet.se/mandos">Mandos</ulink>
+	</term>
+	<listitem>
+	  <para>
+	    The Mandos home page.
+	  </para>
+	</listitem>
+      </varlistentry>
+    </variablelist>
+  </refsect1>
+</refentry>
+<!-- Local Variables: -->
+<!-- time-stamp-start: "<!ENTITY TIMESTAMP [\"']" -->
+<!-- time-stamp-end: "[\"']>" -->
+<!-- time-stamp-format: "%:y-%02m-%02d" -->
+<!-- End: -->

=== modified file 'mandos'
--- mandos	2010-10-11 17:45:21 +0000
+++ mandos	2011-09-18 15:59:05 +0000
@@ -11,8 +11,8 @@
 # "AvahiService" class, and some lines in "main".
 # 
 # Everything else is
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
+# Copyright © 2008-2011 Teddy Hogeborn
+# Copyright © 2008-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -31,11 +31,12 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-from __future__ import division, with_statement, absolute_import
+from __future__ import (division, absolute_import, print_function,
+                        unicode_literals)
 
 import SocketServer as socketserver
 import socket
-import optparse
+import argparse
 import datetime
 import errno
 import gnutls.crypto
@@ -81,22 +82,22 @@
         SO_BINDTODEVICE = None
 
 
-version = "1.2.3"
+version = "1.3.1"
 
-#logger = logging.getLogger(u'mandos')
-logger = logging.Logger(u'mandos')
+#logger = logging.getLogger('mandos')
+logger = logging.Logger('mandos')
 syslogger = (logging.handlers.SysLogHandler
              (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
-              address = "/dev/log"))
+              address = str("/dev/log")))
 syslogger.setFormatter(logging.Formatter
-                       (u'Mandos [%(process)d]: %(levelname)s:'
-                        u' %(message)s'))
+                       ('Mandos [%(process)d]: %(levelname)s:'
+                        ' %(message)s'))
 logger.addHandler(syslogger)
 
 console = logging.StreamHandler()
-console.setFormatter(logging.Formatter(u'%(name)s [%(process)d]:'
-                                       u' %(levelname)s:'
-                                       u' %(message)s'))
+console.setFormatter(logging.Formatter('%(name)s [%(process)d]:'
+                                       ' %(levelname)s:'
+                                       ' %(message)s'))
 logger.addHandler(console)
 
 class AvahiError(Exception):
@@ -119,8 +120,8 @@
     Attributes:
     interface: integer; avahi.IF_UNSPEC or an interface index.
                Used to optionally bind to the specified interface.
-    name: string; Example: u'Mandos'
-    type: string; Example: u'_mandos._tcp'.
+    name: string; Example: 'Mandos'
+    type: string; Example: '_mandos._tcp'.
                   See <http://www.dns-sd.org/ServiceTypes.html>
     port: integer; what port to announce
     TXT: list of strings; TXT record for the service
@@ -135,7 +136,7 @@
     """
     def __init__(self, interface = avahi.IF_UNSPEC, name = None,
                  servicetype = None, port = None, TXT = None,
-                 domain = u"", host = u"", max_renames = 32768,
+                 domain = "", host = "", max_renames = 32768,
                  protocol = avahi.PROTO_UNSPEC, bus = None):
         self.interface = interface
         self.name = name
@@ -150,43 +151,48 @@
         self.group = None       # our entry group
         self.server = None
         self.bus = bus
+        self.entry_group_state_changed_match = None
     def rename(self):
         """Derived from the Avahi example code"""
         if self.rename_count >= self.max_renames:
-            logger.critical(u"No suitable Zeroconf service name found"
-                            u" after %i retries, exiting.",
+            logger.critical("No suitable Zeroconf service name found"
+                            " after %i retries, exiting.",
                             self.rename_count)
-            raise AvahiServiceError(u"Too many renames")
+            raise AvahiServiceError("Too many renames")
         self.name = unicode(self.server.GetAlternativeServiceName(self.name))
-        logger.info(u"Changing Zeroconf service name to %r ...",
+        logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
         syslogger.setFormatter(logging.Formatter
-                               (u'Mandos (%s) [%%(process)d]:'
-                                u' %%(levelname)s: %%(message)s'
+                               ('Mandos (%s) [%%(process)d]:'
+                                ' %%(levelname)s: %%(message)s'
                                 % self.name))
         self.remove()
         try:
             self.add()
-        except dbus.exceptions.DBusException, error:
-            logger.critical(u"DBusException: %s", error)
+        except dbus.exceptions.DBusException as error:
+            logger.critical("DBusException: %s", error)
             self.cleanup()
             os._exit(1)
         self.rename_count += 1
     def remove(self):
         """Derived from the Avahi example code"""
+        if self.entry_group_state_changed_match is not None:
+            self.entry_group_state_changed_match.remove()
+            self.entry_group_state_changed_match = None
         if self.group is not None:
             self.group.Reset()
     def add(self):
         """Derived from the Avahi example code"""
+        self.remove()
         if self.group is None:
             self.group = dbus.Interface(
                 self.bus.get_object(avahi.DBUS_NAME,
                                     self.server.EntryGroupNew()),
                 avahi.DBUS_INTERFACE_ENTRY_GROUP)
-            self.group.connect_to_signal('StateChanged',
-                                         self
-                                         .entry_group_state_changed)
-        logger.debug(u"Adding Zeroconf service '%s' of type '%s' ...",
+        self.entry_group_state_changed_match = (
+            self.group.connect_to_signal(
+                'StateChanged', self .entry_group_state_changed))
+        logger.debug("Adding Zeroconf service '%s' of type '%s' ...",
                      self.name, self.type)
         self.group.AddService(
             self.interface,
@@ -199,39 +205,61 @@
         self.group.Commit()
     def entry_group_state_changed(self, state, error):
         """Derived from the Avahi example code"""
-        logger.debug(u"Avahi entry group state change: %i", state)
+        logger.debug("Avahi entry group state change: %i", state)
         
         if state == avahi.ENTRY_GROUP_ESTABLISHED:
-            logger.debug(u"Zeroconf service established.")
+            logger.debug("Zeroconf service established.")
         elif state == avahi.ENTRY_GROUP_COLLISION:
-            logger.warning(u"Zeroconf service name collision.")
+            logger.info("Zeroconf service name collision.")
             self.rename()
         elif state == avahi.ENTRY_GROUP_FAILURE:
-            logger.critical(u"Avahi: Error in group state changed %s",
+            logger.critical("Avahi: Error in group state changed %s",
                             unicode(error))
-            raise AvahiGroupError(u"State changed: %s"
+            raise AvahiGroupError("State changed: %s"
                                   % unicode(error))
     def cleanup(self):
         """Derived from the Avahi example code"""
         if self.group is not None:
-            self.group.Free()
+            try:
+                self.group.Free()
+            except (dbus.exceptions.UnknownMethodException,
+                    dbus.exceptions.DBusException) as e:
+                pass
             self.group = None
-    def server_state_changed(self, state):
+        self.remove()
+    def server_state_changed(self, state, error=None):
         """Derived from the Avahi example code"""
-        logger.debug(u"Avahi server state change: %i", state)
-        if state == avahi.SERVER_COLLISION:
-            logger.error(u"Zeroconf server name collision")
-            self.remove()
+        logger.debug("Avahi server state change: %i", state)
+        bad_states = { avahi.SERVER_INVALID:
+                           "Zeroconf server invalid",
+                       avahi.SERVER_REGISTERING: None,
+                       avahi.SERVER_COLLISION:
+                           "Zeroconf server name collision",
+                       avahi.SERVER_FAILURE:
+                           "Zeroconf server failure" }
+        if state in bad_states:
+            if bad_states[state] is not None:
+                if error is None:
+                    logger.error(bad_states[state])
+                else:
+                    logger.error(bad_states[state] + ": %r", error)
+            self.cleanup()
         elif state == avahi.SERVER_RUNNING:
             self.add()
+        else:
+            if error is None:
+                logger.debug("Unknown state: %r", state)
+            else:
+                logger.debug("Unknown state: %r: %r", state, error)
     def activate(self):
         """Derived from the Avahi example code"""
         if self.server is None:
             self.server = dbus.Interface(
                 self.bus.get_object(avahi.DBUS_NAME,
-                                    avahi.DBUS_PATH_SERVER),
+                                    avahi.DBUS_PATH_SERVER,
+                                    follow_name_owner_changes=True),
                 avahi.DBUS_INTERFACE_SERVER)
-        self.server.connect_to_signal(u"StateChanged",
+        self.server.connect_to_signal("StateChanged",
                                  self.server_state_changed)
         self.server_state_changed(self.server.GetState())
 
@@ -269,13 +297,16 @@
     secret:     bytestring; sent verbatim (over TLS) to client
     timeout:    datetime.timedelta(); How long from last_checked_ok
                                       until this client is disabled
+    extended_timeout:   extra long timeout when password has been sent
     runtime_expansions: Allowed attributes for runtime expansion.
+    expires:    datetime.datetime(); time (UTC) when a client will be
+                disabled, or None
     """
     
-    runtime_expansions = (u"approval_delay", u"approval_duration",
-                          u"created", u"enabled", u"fingerprint",
-                          u"host", u"interval", u"last_checked_ok",
-                          u"last_enabled", u"name", u"timeout")
+    runtime_expansions = ("approval_delay", "approval_duration",
+                          "created", "enabled", "fingerprint",
+                          "host", "interval", "last_checked_ok",
+                          "last_enabled", "name", "timeout")
     
     @staticmethod
     def _timedelta_to_milliseconds(td):
@@ -287,6 +318,10 @@
     def timeout_milliseconds(self):
         "Return the 'timeout' attribute in milliseconds"
         return self._timedelta_to_milliseconds(self.timeout)
+
+    def extended_timeout_milliseconds(self):
+        "Return the 'extended_timeout' attribute in milliseconds"
+        return self._timedelta_to_milliseconds(self.extended_timeout)    
     
     def interval_milliseconds(self):
         "Return the 'interval' attribute in milliseconds"
@@ -302,47 +337,49 @@
         self.name = name
         if config is None:
             config = {}
-        logger.debug(u"Creating client %r", self.name)
+        logger.debug("Creating client %r", self.name)
         # Uppercase and remove spaces from fingerprint for later
         # comparison purposes with return value from the fingerprint()
         # function
-        self.fingerprint = (config[u"fingerprint"].upper()
-                            .replace(u" ", u""))
-        logger.debug(u"  Fingerprint: %s", self.fingerprint)
-        if u"secret" in config:
-            self.secret = config[u"secret"].decode(u"base64")
-        elif u"secfile" in config:
+        self.fingerprint = (config["fingerprint"].upper()
+                            .replace(" ", ""))
+        logger.debug("  Fingerprint: %s", self.fingerprint)
+        if "secret" in config:
+            self.secret = config["secret"].decode("base64")
+        elif "secfile" in config:
             with open(os.path.expanduser(os.path.expandvars
-                                         (config[u"secfile"])),
+                                         (config["secfile"])),
                       "rb") as secfile:
                 self.secret = secfile.read()
         else:
-            raise TypeError(u"No secret or secfile for client %s"
+            raise TypeError("No secret or secfile for client %s"
                             % self.name)
-        self.host = config.get(u"host", u"")
+        self.host = config.get("host", "")
         self.created = datetime.datetime.utcnow()
         self.enabled = False
         self.last_approval_request = None
         self.last_enabled = None
         self.last_checked_ok = None
-        self.timeout = string_to_delta(config[u"timeout"])
-        self.interval = string_to_delta(config[u"interval"])
+        self.timeout = string_to_delta(config["timeout"])
+        self.extended_timeout = string_to_delta(config["extended_timeout"])
+        self.interval = string_to_delta(config["interval"])
         self.disable_hook = disable_hook
         self.checker = None
         self.checker_initiator_tag = None
         self.disable_initiator_tag = None
+        self.expires = None
         self.checker_callback_tag = None
-        self.checker_command = config[u"checker"]
+        self.checker_command = config["checker"]
         self.current_checker_command = None
         self.last_connect = None
         self._approved = None
-        self.approved_by_default = config.get(u"approved_by_default",
+        self.approved_by_default = config.get("approved_by_default",
                                               True)
         self.approvals_pending = 0
         self.approval_delay = string_to_delta(
-            config[u"approval_delay"])
+            config["approval_delay"])
         self.approval_duration = string_to_delta(
-            config[u"approval_duration"])
+            config["approval_duration"])
         self.changedstate = multiprocessing_manager.Condition(multiprocessing_manager.Lock())
     
     def send_changedstate(self):
@@ -352,7 +389,7 @@
         
     def enable(self):
         """Start this client's checker and timeout hooks"""
-        if getattr(self, u"enabled", False):
+        if getattr(self, "enabled", False):
             # Already enabled
             return
         self.send_changedstate()
@@ -363,6 +400,7 @@
                                       (self.interval_milliseconds(),
                                        self.start_checker))
         # Schedule a disable() when 'timeout' has passed
+        self.expires = datetime.datetime.utcnow() + self.timeout
         self.disable_initiator_tag = (gobject.timeout_add
                                    (self.timeout_milliseconds(),
                                     self.disable))
@@ -377,11 +415,12 @@
         if not quiet:
             self.send_changedstate()
         if not quiet:
-            logger.info(u"Disabling client %s", self.name)
-        if getattr(self, u"disable_initiator_tag", False):
+            logger.info("Disabling client %s", self.name)
+        if getattr(self, "disable_initiator_tag", False):
             gobject.source_remove(self.disable_initiator_tag)
             self.disable_initiator_tag = None
-        if getattr(self, u"checker_initiator_tag", False):
+        self.expires = None
+        if getattr(self, "checker_initiator_tag", False):
             gobject.source_remove(self.checker_initiator_tag)
             self.checker_initiator_tag = None
         self.stop_checker()
@@ -402,26 +441,29 @@
         if os.WIFEXITED(condition):
             exitstatus = os.WEXITSTATUS(condition)
             if exitstatus == 0:
-                logger.info(u"Checker for %(name)s succeeded",
+                logger.info("Checker for %(name)s succeeded",
                             vars(self))
                 self.checked_ok()
             else:
-                logger.info(u"Checker for %(name)s failed",
+                logger.info("Checker for %(name)s failed",
                             vars(self))
         else:
-            logger.warning(u"Checker for %(name)s crashed?",
+            logger.warning("Checker for %(name)s crashed?",
                            vars(self))
     
-    def checked_ok(self):
+    def checked_ok(self, timeout=None):
         """Bump up the timeout for this client.
         
         This should only be called when the client has been seen,
         alive and well.
         """
+        if timeout is None:
+            timeout = self.timeout
         self.last_checked_ok = datetime.datetime.utcnow()
         gobject.source_remove(self.disable_initiator_tag)
+        self.expires = datetime.datetime.utcnow() + timeout
         self.disable_initiator_tag = (gobject.timeout_add
-                                      (self.timeout_milliseconds(),
+                                      (self._timedelta_to_milliseconds(timeout),
                                        self.disable))
     
     def need_approval(self):
@@ -444,13 +486,13 @@
         # If a checker exists, make sure it is not a zombie
         try:
             pid, status = os.waitpid(self.checker.pid, os.WNOHANG)
-        except (AttributeError, OSError), error:
+        except (AttributeError, OSError) as error:
             if (isinstance(error, OSError)
                 and error.errno != errno.ECHILD):
                 raise error
         else:
             if pid:
-                logger.warning(u"Checker was a zombie")
+                logger.warning("Checker was a zombie")
                 gobject.source_remove(self.checker_callback_tag)
                 self.checker_callback(pid, status,
                                       self.current_checker_command)
@@ -463,21 +505,21 @@
                 # Escape attributes for the shell
                 escaped_attrs = dict(
                     (attr,
-                     re.escape(unicode(str(getattr(self, attr, u"")),
+                     re.escape(unicode(str(getattr(self, attr, "")),
                                        errors=
-                                       u'replace')))
+                                       'replace')))
                     for attr in
                     self.runtime_expansions)
 
                 try:
                     command = self.checker_command % escaped_attrs
-                except TypeError, error:
-                    logger.error(u'Could not format string "%s":'
-                                 u' %s', self.checker_command, error)
+                except TypeError as error:
+                    logger.error('Could not format string "%s":'
+                                 ' %s', self.checker_command, error)
                     return True # Try again later
             self.current_checker_command = command
             try:
-                logger.info(u"Starting checker %r for %s",
+                logger.info("Starting checker %r for %s",
                             command, self.name)
                 # We don't need to redirect stdout and stderr, since
                 # in normal mode, that is already done by daemon(),
@@ -485,7 +527,7 @@
                 # always replaced by /dev/null.)
                 self.checker = subprocess.Popen(command,
                                                 close_fds=True,
-                                                shell=True, cwd=u"/")
+                                                shell=True, cwd="/")
                 self.checker_callback_tag = (gobject.child_watch_add
                                              (self.checker.pid,
                                               self.checker_callback,
@@ -496,8 +538,8 @@
                 if pid:
                     gobject.source_remove(self.checker_callback_tag)
                     self.checker_callback(pid, status, command)
-            except OSError, error:
-                logger.error(u"Failed to start subprocess: %s",
+            except OSError as error:
+                logger.error("Failed to start subprocess: %s",
                              error)
         # Re-run this periodically if run by gobject.timeout_add
         return True
@@ -507,21 +549,21 @@
         if self.checker_callback_tag:
             gobject.source_remove(self.checker_callback_tag)
             self.checker_callback_tag = None
-        if getattr(self, u"checker", None) is None:
+        if getattr(self, "checker", None) is None:
             return
-        logger.debug(u"Stopping checker for %(name)s", vars(self))
+        logger.debug("Stopping checker for %(name)s", vars(self))
         try:
             os.kill(self.checker.pid, signal.SIGTERM)
             #time.sleep(0.5)
             #if self.checker.poll() is None:
             #    os.kill(self.checker.pid, signal.SIGKILL)
-        except OSError, error:
+        except OSError as error:
             if error.errno != errno.ESRCH: # No such process
                 raise
         self.checker = None
 
-def dbus_service_property(dbus_interface, signature=u"v",
-                          access=u"readwrite", byte_arrays=False):
+def dbus_service_property(dbus_interface, signature="v",
+                          access="readwrite", byte_arrays=False):
     """Decorators for marking methods of a DBusObjectWithProperties to
     become properties on the D-Bus.
     
@@ -534,18 +576,18 @@
     """
     # Encoding deeply encoded byte arrays is not supported yet by the
     # "Set" method, so we fail early here:
-    if byte_arrays and signature != u"ay":
-        raise ValueError(u"Byte arrays not supported for non-'ay'"
-                         u" signature %r" % signature)
+    if byte_arrays and signature != "ay":
+        raise ValueError("Byte arrays not supported for non-'ay'"
+                         " signature %r" % signature)
     def decorator(func):
         func._dbus_is_property = True
         func._dbus_interface = dbus_interface
         func._dbus_signature = signature
         func._dbus_access = access
         func._dbus_name = func.__name__
-        if func._dbus_name.endswith(u"_dbus_property"):
+        if func._dbus_name.endswith("_dbus_property"):
             func._dbus_name = func._dbus_name[:-14]
-        func._dbus_get_args_options = {u'byte_arrays': byte_arrays }
+        func._dbus_get_args_options = {'byte_arrays': byte_arrays }
         return func
     return decorator
 
@@ -579,7 +621,7 @@
     
     @staticmethod
     def _is_dbus_property(obj):
-        return getattr(obj, u"_dbus_is_property", False)
+        return getattr(obj, "_dbus_is_property", False)
     
     def _get_all_dbus_properties(self):
         """Returns a generator of (name, attribute) pairs
@@ -593,7 +635,7 @@
         property with the specified name and interface.
         """
         for name in (property_name,
-                     property_name + u"_dbus_property"):
+                     property_name + "_dbus_property"):
             prop = getattr(self, name, None)
             if (prop is None
                 or not self._is_dbus_property(prop)
@@ -603,41 +645,41 @@
                 continue
             return prop
         # No such property
-        raise DBusPropertyNotFound(self.dbus_object_path + u":"
-                                   + interface_name + u"."
+        raise DBusPropertyNotFound(self.dbus_object_path + ":"
+                                   + interface_name + "."
                                    + property_name)
     
-    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature=u"ss",
-                         out_signature=u"v")
+    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature="ss",
+                         out_signature="v")
     def Get(self, interface_name, property_name):
         """Standard D-Bus property Get() method, see D-Bus standard.
         """
         prop = self._get_dbus_property(interface_name, property_name)
-        if prop._dbus_access == u"write":
+        if prop._dbus_access == "write":
             raise DBusPropertyAccessException(property_name)
         value = prop()
-        if not hasattr(value, u"variant_level"):
+        if not hasattr(value, "variant_level"):
             return value
         return type(value)(value, variant_level=value.variant_level+1)
     
-    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature=u"ssv")
+    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature="ssv")
     def Set(self, interface_name, property_name, value):
         """Standard D-Bus property Set() method, see D-Bus standard.
         """
         prop = self._get_dbus_property(interface_name, property_name)
-        if prop._dbus_access == u"read":
+        if prop._dbus_access == "read":
             raise DBusPropertyAccessException(property_name)
-        if prop._dbus_get_args_options[u"byte_arrays"]:
+        if prop._dbus_get_args_options["byte_arrays"]:
             # The byte_arrays option is not supported yet on
             # signatures other than "ay".
-            if prop._dbus_signature != u"ay":
+            if prop._dbus_signature != "ay":
                 raise ValueError
             value = dbus.ByteArray(''.join(unichr(byte)
                                            for byte in value))
         prop(value)
     
-    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature=u"s",
-                         out_signature=u"a{sv}")
+    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature="s",
+                         out_signature="a{sv}")
     def GetAll(self, interface_name):
         """Standard D-Bus property GetAll() method, see D-Bus
         standard.
@@ -651,18 +693,18 @@
                 # Interface non-empty but did not match
                 continue
             # Ignore write-only properties
-            if prop._dbus_access == u"write":
+            if prop._dbus_access == "write":
                 continue
             value = prop()
-            if not hasattr(value, u"variant_level"):
+            if not hasattr(value, "variant_level"):
                 all[name] = value
                 continue
             all[name] = type(value)(value, variant_level=
                                     value.variant_level+1)
-        return dbus.Dictionary(all, signature=u"sv")
+        return dbus.Dictionary(all, signature="sv")
     
     @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
-                         out_signature=u"s",
+                         out_signature="s",
                          path_keyword='object_path',
                          connection_keyword='connection')
     def Introspect(self, object_path, connection):
@@ -673,38 +715,38 @@
         try:
             document = xml.dom.minidom.parseString(xmlstring)
             def make_tag(document, name, prop):
-                e = document.createElement(u"property")
-                e.setAttribute(u"name", name)
-                e.setAttribute(u"type", prop._dbus_signature)
-                e.setAttribute(u"access", prop._dbus_access)
+                e = document.createElement("property")
+                e.setAttribute("name", name)
+                e.setAttribute("type", prop._dbus_signature)
+                e.setAttribute("access", prop._dbus_access)
                 return e
-            for if_tag in document.getElementsByTagName(u"interface"):
+            for if_tag in document.getElementsByTagName("interface"):
                 for tag in (make_tag(document, name, prop)
                             for name, prop
                             in self._get_all_dbus_properties()
                             if prop._dbus_interface
-                            == if_tag.getAttribute(u"name")):
+                            == if_tag.getAttribute("name")):
                     if_tag.appendChild(tag)
                 # Add the names to the return values for the
                 # "org.freedesktop.DBus.Properties" methods
-                if (if_tag.getAttribute(u"name")
-                    == u"org.freedesktop.DBus.Properties"):
-                    for cn in if_tag.getElementsByTagName(u"method"):
-                        if cn.getAttribute(u"name") == u"Get":
-                            for arg in cn.getElementsByTagName(u"arg"):
-                                if (arg.getAttribute(u"direction")
-                                    == u"out"):
-                                    arg.setAttribute(u"name", u"value")
-                        elif cn.getAttribute(u"name") == u"GetAll":
-                            for arg in cn.getElementsByTagName(u"arg"):
-                                if (arg.getAttribute(u"direction")
-                                    == u"out"):
-                                    arg.setAttribute(u"name", u"props")
-            xmlstring = document.toxml(u"utf-8")
+                if (if_tag.getAttribute("name")
+                    == "org.freedesktop.DBus.Properties"):
+                    for cn in if_tag.getElementsByTagName("method"):
+                        if cn.getAttribute("name") == "Get":
+                            for arg in cn.getElementsByTagName("arg"):
+                                if (arg.getAttribute("direction")
+                                    == "out"):
+                                    arg.setAttribute("name", "value")
+                        elif cn.getAttribute("name") == "GetAll":
+                            for arg in cn.getElementsByTagName("arg"):
+                                if (arg.getAttribute("direction")
+                                    == "out"):
+                                    arg.setAttribute("name", "props")
+            xmlstring = document.toxml("utf-8")
             document.unlink()
         except (AttributeError, xml.dom.DOMException,
-                xml.parsers.expat.ExpatError), error:
-            logger.error(u"Failed to override Introspection method",
+                xml.parsers.expat.ExpatError) as error:
+            logger.error("Failed to override Introspection method",
                          error)
         return xmlstring
 
@@ -718,7 +760,7 @@
     """
     
     runtime_expansions = (Client.runtime_expansions
-                          + (u"dbus_object_path",))
+                          + ("dbus_object_path",))
     
     # dbus.service.Object doesn't use super(), so we can't either.
     
@@ -729,12 +771,22 @@
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
         client_object_name = unicode(self.name).translate(
-            {ord(u"."): ord(u"_"),
-             ord(u"-"): ord(u"_")})
+            {ord("."): ord("_"),
+             ord("-"): ord("_")})
         self.dbus_object_path = (dbus.ObjectPath
-                                 (u"/clients/" + client_object_name))
+                                 ("/clients/" + client_object_name))
         DBusObjectWithProperties.__init__(self, self.bus,
                                           self.dbus_object_path)
+    def _set_expires(self, value):
+        old_value = getattr(self, "_expires", None)
+        self._expires = value
+        if hasattr(self, "dbus_object_path") and old_value != value:
+            dbus_time = (self._datetime_to_dbus(self._expires,
+                                                variant_level=1))
+            self.PropertyChanged(dbus.String("Expires"),
+                                 dbus_time)
+    expires = property(lambda self: self._expires, _set_expires)
+    del _set_expires
         
     def _get_approvals_pending(self):
         return self._approvals_pending
@@ -745,7 +797,7 @@
         if (hasattr(self, "dbus_object_path")
             and bval is not bool(old_value)):
             dbus_bool = dbus.Boolean(bval, variant_level=1)
-            self.PropertyChanged(dbus.String(u"ApprovalPending"),
+            self.PropertyChanged(dbus.String("ApprovalPending"),
                                  dbus_bool)
 
     approvals_pending = property(_get_approvals_pending,
@@ -755,28 +807,30 @@
     @staticmethod
     def _datetime_to_dbus(dt, variant_level=0):
         """Convert a UTC datetime.datetime() to a D-Bus type."""
+        if dt is None:
+            return dbus.String("", variant_level = variant_level)
         return dbus.String(dt.isoformat(),
                            variant_level=variant_level)
     
     def enable(self):
-        oldstate = getattr(self, u"enabled", False)
+        oldstate = getattr(self, "enabled", False)
         r = Client.enable(self)
         if oldstate != self.enabled:
             # Emit D-Bus signals
-            self.PropertyChanged(dbus.String(u"Enabled"),
+            self.PropertyChanged(dbus.String("Enabled"),
                                  dbus.Boolean(True, variant_level=1))
             self.PropertyChanged(
-                dbus.String(u"LastEnabled"),
+                dbus.String("LastEnabled"),
                 self._datetime_to_dbus(self.last_enabled,
                                        variant_level=1))
         return r
     
     def disable(self, quiet = False):
-        oldstate = getattr(self, u"enabled", False)
+        oldstate = getattr(self, "enabled", False)
         r = Client.disable(self, quiet=quiet)
         if not quiet and oldstate != self.enabled:
             # Emit D-Bus signal
-            self.PropertyChanged(dbus.String(u"Enabled"),
+            self.PropertyChanged(dbus.String("Enabled"),
                                  dbus.Boolean(False, variant_level=1))
         return r
     
@@ -785,7 +839,7 @@
             self.remove_from_connection()
         except LookupError:
             pass
-        if hasattr(DBusObjectWithProperties, u"__del__"):
+        if hasattr(DBusObjectWithProperties, "__del__"):
             DBusObjectWithProperties.__del__(self, *args, **kwargs)
         Client.__del__(self, *args, **kwargs)
     
@@ -794,7 +848,7 @@
         self.checker_callback_tag = None
         self.checker = None
         # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"CheckerRunning"),
+        self.PropertyChanged(dbus.String("CheckerRunning"),
                              dbus.Boolean(False, variant_level=1))
         if os.WIFEXITED(condition):
             exitstatus = os.WEXITSTATUS(condition)
@@ -812,19 +866,18 @@
                                        *args, **kwargs)
     
     def checked_ok(self, *args, **kwargs):
-        r = Client.checked_ok(self, *args, **kwargs)
+        Client.checked_ok(self, *args, **kwargs)
         # Emit D-Bus signal
         self.PropertyChanged(
-            dbus.String(u"LastCheckedOK"),
+            dbus.String("LastCheckedOK"),
             (self._datetime_to_dbus(self.last_checked_ok,
                                     variant_level=1)))
-        return r
     
     def need_approval(self, *args, **kwargs):
         r = Client.need_approval(self, *args, **kwargs)
         # Emit D-Bus signal
         self.PropertyChanged(
-            dbus.String(u"LastApprovalRequest"),
+            dbus.String("LastApprovalRequest"),
             (self._datetime_to_dbus(self.last_approval_request,
                                     variant_level=1)))
         return r
@@ -842,16 +895,16 @@
             # Emit D-Bus signal
             self.CheckerStarted(self.current_checker_command)
             self.PropertyChanged(
-                dbus.String(u"CheckerRunning"),
+                dbus.String("CheckerRunning"),
                 dbus.Boolean(True, variant_level=1))
         return r
     
     def stop_checker(self, *args, **kwargs):
-        old_checker = getattr(self, u"checker", None)
+        old_checker = getattr(self, "checker", None)
         r = Client.stop_checker(self, *args, **kwargs)
         if (old_checker is not None
-            and getattr(self, u"checker", None) is None):
-            self.PropertyChanged(dbus.String(u"CheckerRunning"),
+            and getattr(self, "checker", None) is None):
+            self.PropertyChanged(dbus.String("CheckerRunning"),
                                  dbus.Boolean(False, variant_level=1))
         return r
 
@@ -868,24 +921,24 @@
     
     
     ## D-Bus methods, signals & properties
-    _interface = u"se.bsnet.fukt.Mandos.Client"
+    _interface = "se.bsnet.fukt.Mandos.Client"
     
     ## Signals
     
     # CheckerCompleted - signal
-    @dbus.service.signal(_interface, signature=u"nxs")
+    @dbus.service.signal(_interface, signature="nxs")
     def CheckerCompleted(self, exitcode, waitstatus, command):
         "D-Bus signal"
         pass
     
     # CheckerStarted - signal
-    @dbus.service.signal(_interface, signature=u"s")
+    @dbus.service.signal(_interface, signature="s")
     def CheckerStarted(self, command):
         "D-Bus signal"
         pass
     
     # PropertyChanged - signal
-    @dbus.service.signal(_interface, signature=u"sv")
+    @dbus.service.signal(_interface, signature="sv")
     def PropertyChanged(self, property, value):
         "D-Bus signal"
         pass
@@ -900,13 +953,13 @@
         pass
     
     # Rejected - signal
-    @dbus.service.signal(_interface, signature=u"s")
+    @dbus.service.signal(_interface, signature="s")
     def Rejected(self, reason):
         "D-Bus signal"
         pass
     
     # NeedApproval - signal
-    @dbus.service.signal(_interface, signature=u"tb")
+    @dbus.service.signal(_interface, signature="tb")
     def NeedApproval(self, timeout, default):
         "D-Bus signal"
         return self.need_approval()
@@ -914,14 +967,14 @@
     ## Methods
     
     # Approve - method
-    @dbus.service.method(_interface, in_signature=u"b")
+    @dbus.service.method(_interface, in_signature="b")
     def Approve(self, value):
         self.approve(value)
     
     # CheckedOK - method
     @dbus.service.method(_interface)
     def CheckedOK(self):
-        return self.checked_ok()
+        self.checked_ok()
     
     # Enable - method
     @dbus.service.method(_interface)
@@ -949,80 +1002,86 @@
     ## Properties
     
     # ApprovalPending - property
-    @dbus_service_property(_interface, signature=u"b", access=u"read")
+    @dbus_service_property(_interface, signature="b", access="read")
     def ApprovalPending_dbus_property(self):
         return dbus.Boolean(bool(self.approvals_pending))
     
     # ApprovedByDefault - property
-    @dbus_service_property(_interface, signature=u"b",
-                           access=u"readwrite")
+    @dbus_service_property(_interface, signature="b",
+                           access="readwrite")
     def ApprovedByDefault_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.Boolean(self.approved_by_default)
+        old_value = self.approved_by_default
         self.approved_by_default = bool(value)
         # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"ApprovedByDefault"),
-                             dbus.Boolean(value, variant_level=1))
+        if old_value != self.approved_by_default:
+            self.PropertyChanged(dbus.String("ApprovedByDefault"),
+                                 dbus.Boolean(value, variant_level=1))
     
     # ApprovalDelay - property
-    @dbus_service_property(_interface, signature=u"t",
-                           access=u"readwrite")
+    @dbus_service_property(_interface, signature="t",
+                           access="readwrite")
     def ApprovalDelay_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.UInt64(self.approval_delay_milliseconds())
+        old_value = self.approval_delay
         self.approval_delay = datetime.timedelta(0, 0, 0, value)
         # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"ApprovalDelay"),
-                             dbus.UInt64(value, variant_level=1))
+        if old_value != self.approval_delay:
+            self.PropertyChanged(dbus.String("ApprovalDelay"),
+                                 dbus.UInt64(value, variant_level=1))
     
     # ApprovalDuration - property
-    @dbus_service_property(_interface, signature=u"t",
-                           access=u"readwrite")
+    @dbus_service_property(_interface, signature="t",
+                           access="readwrite")
     def ApprovalDuration_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.UInt64(self._timedelta_to_milliseconds(
                     self.approval_duration))
+        old_value = self.approval_duration
         self.approval_duration = datetime.timedelta(0, 0, 0, value)
         # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"ApprovalDuration"),
-                             dbus.UInt64(value, variant_level=1))
+        if old_value != self.approval_duration:
+            self.PropertyChanged(dbus.String("ApprovalDuration"),
+                                 dbus.UInt64(value, variant_level=1))
     
     # Name - property
-    @dbus_service_property(_interface, signature=u"s", access=u"read")
+    @dbus_service_property(_interface, signature="s", access="read")
     def Name_dbus_property(self):
         return dbus.String(self.name)
     
     # Fingerprint - property
-    @dbus_service_property(_interface, signature=u"s", access=u"read")
+    @dbus_service_property(_interface, signature="s", access="read")
     def Fingerprint_dbus_property(self):
         return dbus.String(self.fingerprint)
     
     # Host - property
-    @dbus_service_property(_interface, signature=u"s",
-                           access=u"readwrite")
+    @dbus_service_property(_interface, signature="s",
+                           access="readwrite")
     def Host_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.host)
+        old_value = self.host
         self.host = value
         # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"Host"),
-                             dbus.String(value, variant_level=1))
+        if old_value != self.host:
+            self.PropertyChanged(dbus.String("Host"),
+                                 dbus.String(value, variant_level=1))
     
     # Created - property
-    @dbus_service_property(_interface, signature=u"s", access=u"read")
+    @dbus_service_property(_interface, signature="s", access="read")
     def Created_dbus_property(self):
         return dbus.String(self._datetime_to_dbus(self.created))
     
     # LastEnabled - property
-    @dbus_service_property(_interface, signature=u"s", access=u"read")
+    @dbus_service_property(_interface, signature="s", access="read")
     def LastEnabled_dbus_property(self):
-        if self.last_enabled is None:
-            return dbus.String(u"")
-        return dbus.String(self._datetime_to_dbus(self.last_enabled))
+        return self._datetime_to_dbus(self.last_enabled)
     
     # Enabled - property
-    @dbus_service_property(_interface, signature=u"b",
-                           access=u"readwrite")
+    @dbus_service_property(_interface, signature="b",
+                           access="readwrite")
     def Enabled_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.Boolean(self.enabled)
@@ -1032,41 +1091,42 @@
             self.disable()
     
     # LastCheckedOK - property
-    @dbus_service_property(_interface, signature=u"s",
-                           access=u"readwrite")
+    @dbus_service_property(_interface, signature="s",
+                           access="readwrite")
     def LastCheckedOK_dbus_property(self, value=None):
         if value is not None:
             self.checked_ok()
             return
-        if self.last_checked_ok is None:
-            return dbus.String(u"")
-        return dbus.String(self._datetime_to_dbus(self
-                                                  .last_checked_ok))
+        return self._datetime_to_dbus(self.last_checked_ok)
+    
+    # Expires - property
+    @dbus_service_property(_interface, signature="s", access="read")
+    def Expires_dbus_property(self):
+        return self._datetime_to_dbus(self.expires)
     
     # LastApprovalRequest - property
-    @dbus_service_property(_interface, signature=u"s", access=u"read")
+    @dbus_service_property(_interface, signature="s", access="read")
     def LastApprovalRequest_dbus_property(self):
-        if self.last_approval_request is None:
-            return dbus.String(u"")
-        return dbus.String(self.
-                           _datetime_to_dbus(self
-                                             .last_approval_request))
+        return self._datetime_to_dbus(self.last_approval_request)
     
     # Timeout - property
-    @dbus_service_property(_interface, signature=u"t",
-                           access=u"readwrite")
+    @dbus_service_property(_interface, signature="t",
+                           access="readwrite")
     def Timeout_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.UInt64(self.timeout_milliseconds())
+        old_value = self.timeout
         self.timeout = datetime.timedelta(0, 0, 0, value)
         # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"Timeout"),
-                             dbus.UInt64(value, variant_level=1))
-        if getattr(self, u"disable_initiator_tag", None) is None:
+        if old_value != self.timeout:
+            self.PropertyChanged(dbus.String("Timeout"),
+                                 dbus.UInt64(value, variant_level=1))
+        if getattr(self, "disable_initiator_tag", None) is None:
             return
         # Reschedule timeout
         gobject.source_remove(self.disable_initiator_tag)
         self.disable_initiator_tag = None
+        self.expires = None
         time_to_die = (self.
                        _timedelta_to_milliseconds((self
                                                    .last_checked_ok
@@ -1077,20 +1137,37 @@
             # The timeout has passed
             self.disable()
         else:
+            self.expires = (datetime.datetime.utcnow()
+                            + datetime.timedelta(milliseconds = time_to_die))
             self.disable_initiator_tag = (gobject.timeout_add
                                           (time_to_die, self.disable))
-    
+
+    # ExtendedTimeout - property
+    @dbus_service_property(_interface, signature="t",
+                           access="readwrite")
+    def ExtendedTimeout_dbus_property(self, value=None):
+        if value is None:       # get
+            return dbus.UInt64(self.extended_timeout_milliseconds())
+        old_value = self.extended_timeout
+        self.extended_timeout = datetime.timedelta(0, 0, 0, value)
+        # Emit D-Bus signal
+        if old_value != self.extended_timeout:
+            self.PropertyChanged(dbus.String("ExtendedTimeout"),
+                                 dbus.UInt64(value, variant_level=1))
+
     # Interval - property
-    @dbus_service_property(_interface, signature=u"t",
-                           access=u"readwrite")
+    @dbus_service_property(_interface, signature="t",
+                           access="readwrite")
     def Interval_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.UInt64(self.interval_milliseconds())
+        old_value = self.interval
         self.interval = datetime.timedelta(0, 0, 0, value)
         # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"Interval"),
-                             dbus.UInt64(value, variant_level=1))
-        if getattr(self, u"checker_initiator_tag", None) is None:
+        if old_value != self.interval:
+            self.PropertyChanged(dbus.String("Interval"),
+                                 dbus.UInt64(value, variant_level=1))
+        if getattr(self, "checker_initiator_tag", None) is None:
             return
         # Reschedule checker run
         gobject.source_remove(self.checker_initiator_tag)
@@ -1099,20 +1176,22 @@
         self.start_checker()    # Start one now, too
 
     # Checker - property
-    @dbus_service_property(_interface, signature=u"s",
-                           access=u"readwrite")
+    @dbus_service_property(_interface, signature="s",
+                           access="readwrite")
     def Checker_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.checker_command)
+        old_value = self.checker_command
         self.checker_command = value
         # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"Checker"),
-                             dbus.String(self.checker_command,
-                                         variant_level=1))
+        if old_value != self.checker_command:
+            self.PropertyChanged(dbus.String("Checker"),
+                                 dbus.String(self.checker_command,
+                                             variant_level=1))
     
     # CheckerRunning - property
-    @dbus_service_property(_interface, signature=u"b",
-                           access=u"readwrite")
+    @dbus_service_property(_interface, signature="b",
+                           access="readwrite")
     def CheckerRunning_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.Boolean(self.checker is not None)
@@ -1122,13 +1201,13 @@
             self.stop_checker()
     
     # ObjectPath - property
-    @dbus_service_property(_interface, signature=u"o", access=u"read")
+    @dbus_service_property(_interface, signature="o", access="read")
     def ObjectPath_dbus_property(self):
         return self.dbus_object_path # is already a dbus.ObjectPath
     
     # Secret = property
-    @dbus_service_property(_interface, signature=u"ay",
-                           access=u"write", byte_arrays=True)
+    @dbus_service_property(_interface, signature="ay",
+                           access="write", byte_arrays=True)
     def Secret_dbus_property(self, value):
         self.secret = str(value)
     
@@ -1169,9 +1248,9 @@
     
     def handle(self):
         with contextlib.closing(self.server.child_pipe) as child_pipe:
-            logger.info(u"TCP connection from: %s",
+            logger.info("TCP connection from: %s",
                         unicode(self.client_address))
-            logger.debug(u"Pipe FD: %d",
+            logger.debug("Pipe FD: %d",
                          self.server.child_pipe.fileno())
 
             session = (gnutls.connection
@@ -1184,14 +1263,14 @@
             # no X.509 keys are added to it.  Therefore, we can use it
             # here despite using OpenPGP certificates.
 
-            #priority = u':'.join((u"NONE", u"+VERS-TLS1.1",
-            #                      u"+AES-256-CBC", u"+SHA1",
-            #                      u"+COMP-NULL", u"+CTYPE-OPENPGP",
-            #                      u"+DHE-DSS"))
+            #priority = ':'.join(("NONE", "+VERS-TLS1.1",
+            #                      "+AES-256-CBC", "+SHA1",
+            #                      "+COMP-NULL", "+CTYPE-OPENPGP",
+            #                      "+DHE-DSS"))
             # Use a fallback default, since this MUST be set.
             priority = self.server.gnutls_priority
             if priority is None:
-                priority = u"NORMAL"
+                priority = "NORMAL"
             (gnutls.library.functions
              .gnutls_priority_set_direct(session._c_object,
                                          priority, None))
@@ -1199,33 +1278,34 @@
             # Start communication using the Mandos protocol
             # Get protocol number
             line = self.request.makefile().readline()
-            logger.debug(u"Protocol version: %r", line)
+            logger.debug("Protocol version: %r", line)
             try:
                 if int(line.strip().split()[0]) > 1:
                     raise RuntimeError
-            except (ValueError, IndexError, RuntimeError), error:
-                logger.error(u"Unknown protocol version: %s", error)
+            except (ValueError, IndexError, RuntimeError) as error:
+                logger.error("Unknown protocol version: %s", error)
                 return
 
             # Start GnuTLS connection
             try:
                 session.handshake()
-            except gnutls.errors.GNUTLSError, error:
-                logger.warning(u"Handshake failed: %s", error)
+            except gnutls.errors.GNUTLSError as error:
+                logger.warning("Handshake failed: %s", error)
                 # Do not run session.bye() here: the session is not
                 # established.  Just abandon the request.
                 return
-            logger.debug(u"Handshake succeeded")
+            logger.debug("Handshake succeeded")
 
             approval_required = False
             try:
                 try:
                     fpr = self.fingerprint(self.peer_certificate
                                            (session))
-                except (TypeError, gnutls.errors.GNUTLSError), error:
-                    logger.warning(u"Bad certificate: %s", error)
+                except (TypeError,
+                        gnutls.errors.GNUTLSError) as error:
+                    logger.warning("Bad certificate: %s", error)
                     return
-                logger.debug(u"Fingerprint: %s", fpr)
+                logger.debug("Fingerprint: %s", fpr)
 
                 try:
                     client = ProxyClient(child_pipe, fpr,
@@ -1240,7 +1320,7 @@
                 
                 while True:
                     if not client.enabled:
-                        logger.warning(u"Client %s is disabled",
+                        logger.info("Client %s is disabled",
                                        client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
@@ -1251,7 +1331,7 @@
                         #We are approved or approval is disabled
                         break
                     elif client._approved is None:
-                        logger.info(u"Client %s needs approval",
+                        logger.info("Client %s needs approval",
                                     client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
@@ -1259,7 +1339,7 @@
                                 client.approval_delay_milliseconds(),
                                 client.approved_by_default)
                     else:
-                        logger.warning(u"Client %s was not approved",
+                        logger.warning("Client %s was not approved",
                                        client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
@@ -1291,17 +1371,17 @@
                 while sent_size < len(client.secret):
                     try:
                         sent = session.send(client.secret[sent_size:])
-                    except (gnutls.errors.GNUTLSError), error:
+                    except gnutls.errors.GNUTLSError as error:
                         logger.warning("gnutls send failed")
                         return
-                    logger.debug(u"Sent: %d, remaining: %d",
+                    logger.debug("Sent: %d, remaining: %d",
                                  sent, len(client.secret)
                                  - (sent_size + sent))
                     sent_size += sent
 
-                logger.info(u"Sending secret to %s", client.name)
+                logger.info("Sending secret to %s", client.name)
                 # bump the timeout as if seen
-                client.checked_ok()
+                client.checked_ok(client.extended_timeout)
                 if self.server.use_dbus:
                     # Emit D-Bus signal
                     client.GotSecret()
@@ -1311,7 +1391,7 @@
                     client.approvals_pending -= 1
                 try:
                     session.bye()
-                except (gnutls.errors.GNUTLSError), error:
+                except gnutls.errors.GNUTLSError as error:
                     logger.warning("GnuTLS bye failed")
     
     @staticmethod
@@ -1328,8 +1408,8 @@
                      .gnutls_certificate_get_peers
                      (session._c_object, ctypes.byref(list_size)))
         if not bool(cert_list) and list_size.value != 0:
-            raise gnutls.errors.GNUTLSError(u"error getting peer"
-                                            u" certificate")
+            raise gnutls.errors.GNUTLSError("error getting peer"
+                                            " certificate")
         if list_size.value == 0:
             return None
         cert = cert_list[0]
@@ -1361,7 +1441,7 @@
         if crtverify.value != 0:
             gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
             raise (gnutls.errors.CertificateSecurityError
-                   (u"Verify failed"))
+                   ("Verify failed"))
         # New buffer for the fingerprint
         buf = ctypes.create_string_buffer(20)
         buf_len = ctypes.c_size_t()
@@ -1374,7 +1454,7 @@
         # Convert the buffer to a Python bytestring
         fpr = ctypes.string_at(buf, buf_len.value)
         # Convert the bytestring to hexadecimal notation
-        hex_fpr = u''.join(u"%02X" % ord(char) for char in fpr)
+        hex_fpr = ''.join("%02X" % ord(char) for char in fpr)
         return hex_fpr
 
 
@@ -1408,7 +1488,7 @@
 
     def add_pipe(self, parent_pipe):
         """Dummy function; override as necessary"""
-        pass
+        raise NotImplementedError
 
 class IPv6_TCPServer(MultiprocessingMixInWithPipe,
                      socketserver.TCPServer, object):
@@ -1432,23 +1512,23 @@
         bind to an address or port if they were not specified."""
         if self.interface is not None:
             if SO_BINDTODEVICE is None:
-                logger.error(u"SO_BINDTODEVICE does not exist;"
-                             u" cannot bind to interface %s",
+                logger.error("SO_BINDTODEVICE does not exist;"
+                             " cannot bind to interface %s",
                              self.interface)
             else:
                 try:
                     self.socket.setsockopt(socket.SOL_SOCKET,
                                            SO_BINDTODEVICE,
                                            str(self.interface
-                                               + u'\0'))
-                except socket.error, error:
+                                               + '\0'))
+                except socket.error as error:
                     if error[0] == errno.EPERM:
-                        logger.error(u"No permission to"
-                                     u" bind to interface %s",
+                        logger.error("No permission to"
+                                     " bind to interface %s",
                                      self.interface)
                     elif error[0] == errno.ENOPROTOOPT:
-                        logger.error(u"SO_BINDTODEVICE not available;"
-                                     u" cannot bind to interface %s",
+                        logger.error("SO_BINDTODEVICE not available;"
+                                     " cannot bind to interface %s",
                                      self.interface)
                     else:
                         raise
@@ -1456,7 +1536,7 @@
         if self.server_address[0] or self.server_address[1]:
             if not self.server_address[0]:
                 if self.address_family == socket.AF_INET6:
-                    any_address = u"::" # in6addr_any
+                    any_address = "::" # in6addr_any
                 else:
                     any_address = socket.INADDR_ANY
                 self.server_address = (any_address,
@@ -1511,12 +1591,12 @@
     def handle_ipc(self, source, condition, parent_pipe=None,
                    client_object=None):
         condition_names = {
-            gobject.IO_IN: u"IN",   # There is data to read.
-            gobject.IO_OUT: u"OUT", # Data can be written (without
+            gobject.IO_IN: "IN",   # There is data to read.
+            gobject.IO_OUT: "OUT", # Data can be written (without
                                     # blocking).
-            gobject.IO_PRI: u"PRI", # There is urgent data to read.
-            gobject.IO_ERR: u"ERR", # Error condition.
-            gobject.IO_HUP: u"HUP"  # Hung up (the connection has been
+            gobject.IO_PRI: "PRI", # There is urgent data to read.
+            gobject.IO_ERR: "ERR", # Error condition.
+            gobject.IO_HUP: "HUP"  # Hung up (the connection has been
                                     # broken, usually for pipes and
                                     # sockets).
             }
@@ -1541,8 +1621,8 @@
                     client = c
                     break
             else:
-                logger.warning(u"Client not found for fingerprint: %s, ad"
-                               u"dress: %s", fpr, address)
+                logger.info("Client not found for fingerprint: %s, ad"
+                            "dress: %s", fpr, address)
                 if self.use_dbus:
                     # Emit D-Bus signal
                     mandos_dbus_service.ClientNotFound(fpr, address[0])
@@ -1582,17 +1662,17 @@
 def string_to_delta(interval):
     """Parse a string and return a datetime.timedelta
     
-    >>> string_to_delta(u'7d')
+    >>> string_to_delta('7d')
     datetime.timedelta(7)
-    >>> string_to_delta(u'60s')
+    >>> string_to_delta('60s')
     datetime.timedelta(0, 60)
-    >>> string_to_delta(u'60m')
+    >>> string_to_delta('60m')
     datetime.timedelta(0, 3600)
-    >>> string_to_delta(u'24h')
+    >>> string_to_delta('24h')
     datetime.timedelta(1)
-    >>> string_to_delta(u'1w')
+    >>> string_to_delta('1w')
     datetime.timedelta(7)
-    >>> string_to_delta(u'5m 30s')
+    >>> string_to_delta('5m 30s')
     datetime.timedelta(0, 330)
     """
     timevalue = datetime.timedelta(0)
@@ -1600,20 +1680,20 @@
         try:
             suffix = unicode(s[-1])
             value = int(s[:-1])
-            if suffix == u"d":
+            if suffix == "d":
                 delta = datetime.timedelta(value)
-            elif suffix == u"s":
+            elif suffix == "s":
                 delta = datetime.timedelta(0, value)
-            elif suffix == u"m":
+            elif suffix == "m":
                 delta = datetime.timedelta(0, 0, 0, 0, value)
-            elif suffix == u"h":
+            elif suffix == "h":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, value)
-            elif suffix == u"w":
+            elif suffix == "w":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
             else:
-                raise ValueError(u"Unknown suffix %r" % suffix)
-        except (ValueError, IndexError), e:
-            raise ValueError(e.message)
+                raise ValueError("Unknown suffix %r" % suffix)
+        except (ValueError, IndexError) as e:
+            raise ValueError(*(e.args))
         timevalue += delta
     return timevalue
 
@@ -1625,18 +1705,18 @@
     global if_nametoindex
     try:
         if_nametoindex = (ctypes.cdll.LoadLibrary
-                          (ctypes.util.find_library(u"c"))
+                          (ctypes.util.find_library("c"))
                           .if_nametoindex)
     except (OSError, AttributeError):
-        logger.warning(u"Doing if_nametoindex the hard way")
+        logger.warning("Doing if_nametoindex the hard way")
         def if_nametoindex(interface):
             "Get an interface index the hard way, i.e. using fcntl()"
             SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
             with contextlib.closing(socket.socket()) as s:
                 ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
-                                    struct.pack(str(u"16s16x"),
+                                    struct.pack(str("16s16x"),
                                                 interface))
-            interface_index = struct.unpack(str(u"I"),
+            interface_index = struct.unpack(str("I"),
                                             ifreq[16:20])[0]
             return interface_index
     return if_nametoindex(interface)
@@ -1650,7 +1730,7 @@
         sys.exit()
     os.setsid()
     if not nochdir:
-        os.chdir(u"/")
+        os.chdir("/")
     if os.fork():
         sys.exit()
     if not noclose:
@@ -1658,7 +1738,7 @@
         null = os.open(os.path.devnull, os.O_NOCTTY | os.O_RDWR)
         if not stat.S_ISCHR(os.fstat(null).st_mode):
             raise OSError(errno.ENODEV,
-                          u"%s not a character device"
+                          "%s not a character device"
                           % os.path.devnull)
         os.dup2(null, sys.stdin.fileno())
         os.dup2(null, sys.stdout.fileno())
@@ -1672,34 +1752,37 @@
     ##################################################################
     # Parsing of options, both command line and config file
     
-    parser = optparse.OptionParser(version = "%%prog %s" % version)
-    parser.add_option("-i", u"--interface", type=u"string",
-                      metavar="IF", help=u"Bind to interface IF")
-    parser.add_option("-a", u"--address", type=u"string",
-                      help=u"Address to listen for requests on")
-    parser.add_option("-p", u"--port", type=u"int",
-                      help=u"Port number to receive requests on")
-    parser.add_option("--check", action=u"store_true",
-                      help=u"Run self-test")
-    parser.add_option("--debug", action=u"store_true",
-                      help=u"Debug mode; run in foreground and log to"
-                      u" terminal")
-    parser.add_option("--debuglevel", type=u"string", metavar="LEVEL",
-                      help=u"Debug level for stdout output")
-    parser.add_option("--priority", type=u"string", help=u"GnuTLS"
-                      u" priority string (see GnuTLS documentation)")
-    parser.add_option("--servicename", type=u"string",
-                      metavar=u"NAME", help=u"Zeroconf service name")
-    parser.add_option("--configdir", type=u"string",
-                      default=u"/etc/mandos", metavar=u"DIR",
-                      help=u"Directory to search for configuration"
-                      u" files")
-    parser.add_option("--no-dbus", action=u"store_false",
-                      dest=u"use_dbus", help=u"Do not provide D-Bus"
-                      u" system bus interface")
-    parser.add_option("--no-ipv6", action=u"store_false",
-                      dest=u"use_ipv6", help=u"Do not use IPv6")
-    options = parser.parse_args()[0]
+    parser = argparse.ArgumentParser()
+    parser.add_argument("-v", "--version", action="version",
+                        version = "%%(prog)s %s" % version,
+                        help="show version number and exit")
+    parser.add_argument("-i", "--interface", metavar="IF",
+                        help="Bind to interface IF")
+    parser.add_argument("-a", "--address",
+                        help="Address to listen for requests on")
+    parser.add_argument("-p", "--port", type=int,
+                        help="Port number to receive requests on")
+    parser.add_argument("--check", action="store_true",
+                        help="Run self-test")
+    parser.add_argument("--debug", action="store_true",
+                        help="Debug mode; run in foreground and log"
+                        " to terminal")
+    parser.add_argument("--debuglevel", metavar="LEVEL",
+                        help="Debug level for stdout output")
+    parser.add_argument("--priority", help="GnuTLS"
+                        " priority string (see GnuTLS documentation)")
+    parser.add_argument("--servicename",
+                        metavar="NAME", help="Zeroconf service name")
+    parser.add_argument("--configdir",
+                        default="/etc/mandos", metavar="DIR",
+                        help="Directory to search for configuration"
+                        " files")
+    parser.add_argument("--no-dbus", action="store_false",
+                        dest="use_dbus", help="Do not provide D-Bus"
+                        " system bus interface")
+    parser.add_argument("--no-ipv6", action="store_false",
+                        dest="use_ipv6", help="Do not use IPv6")
+    options = parser.parse_args()
     
     if options.check:
         import doctest
@@ -1707,39 +1790,39 @@
         sys.exit()
     
     # Default values for config file for server-global settings
-    server_defaults = { u"interface": u"",
-                        u"address": u"",
-                        u"port": u"",
-                        u"debug": u"False",
-                        u"priority":
-                        u"SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP",
-                        u"servicename": u"Mandos",
-                        u"use_dbus": u"True",
-                        u"use_ipv6": u"True",
-                        u"debuglevel": u"",
+    server_defaults = { "interface": "",
+                        "address": "",
+                        "port": "",
+                        "debug": "False",
+                        "priority":
+                        "SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP",
+                        "servicename": "Mandos",
+                        "use_dbus": "True",
+                        "use_ipv6": "True",
+                        "debuglevel": "",
                         }
     
     # Parse config file for server-global settings
     server_config = configparser.SafeConfigParser(server_defaults)
     del server_defaults
     server_config.read(os.path.join(options.configdir,
-                                    u"mandos.conf"))
+                                    "mandos.conf"))
     # Convert the SafeConfigParser object to a dict
     server_settings = server_config.defaults()
     # Use the appropriate methods on the non-string config options
-    for option in (u"debug", u"use_dbus", u"use_ipv6"):
-        server_settings[option] = server_config.getboolean(u"DEFAULT",
+    for option in ("debug", "use_dbus", "use_ipv6"):
+        server_settings[option] = server_config.getboolean("DEFAULT",
                                                            option)
     if server_settings["port"]:
-        server_settings["port"] = server_config.getint(u"DEFAULT",
-                                                       u"port")
+        server_settings["port"] = server_config.getint("DEFAULT",
+                                                       "port")
     del server_config
     
     # Override the settings from the config file with command line
     # options, if set.
-    for option in (u"interface", u"address", u"port", u"debug",
-                   u"priority", u"servicename", u"configdir",
-                   u"use_dbus", u"use_ipv6", u"debuglevel"):
+    for option in ("interface", "address", "port", "debug",
+                   "priority", "servicename", "configdir",
+                   "use_dbus", "use_ipv6", "debuglevel"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -1753,66 +1836,67 @@
     ##################################################################
     
     # For convenience
-    debug = server_settings[u"debug"]
-    debuglevel = server_settings[u"debuglevel"]
-    use_dbus = server_settings[u"use_dbus"]
-    use_ipv6 = server_settings[u"use_ipv6"]
+    debug = server_settings["debug"]
+    debuglevel = server_settings["debuglevel"]
+    use_dbus = server_settings["use_dbus"]
+    use_ipv6 = server_settings["use_ipv6"]
 
-    if server_settings[u"servicename"] != u"Mandos":
+    if server_settings["servicename"] != "Mandos":
         syslogger.setFormatter(logging.Formatter
-                               (u'Mandos (%s) [%%(process)d]:'
-                                u' %%(levelname)s: %%(message)s'
-                                % server_settings[u"servicename"]))
+                               ('Mandos (%s) [%%(process)d]:'
+                                ' %%(levelname)s: %%(message)s'
+                                % server_settings["servicename"]))
     
     # Parse config file with clients
-    client_defaults = { u"timeout": u"1h",
-                        u"interval": u"5m",
-                        u"checker": u"fping -q -- %%(host)s",
-                        u"host": u"",
-                        u"approval_delay": u"0s",
-                        u"approval_duration": u"1s",
+    client_defaults = { "timeout": "5m",
+                        "extended_timeout": "15m",
+                        "interval": "2m",
+                        "checker": "fping -q -- %%(host)s",
+                        "host": "",
+                        "approval_delay": "0s",
+                        "approval_duration": "1s",
                         }
     client_config = configparser.SafeConfigParser(client_defaults)
-    client_config.read(os.path.join(server_settings[u"configdir"],
-                                    u"clients.conf"))
+    client_config.read(os.path.join(server_settings["configdir"],
+                                    "clients.conf"))
     
     global mandos_dbus_service
     mandos_dbus_service = None
     
-    tcp_server = MandosServer((server_settings[u"address"],
-                               server_settings[u"port"]),
+    tcp_server = MandosServer((server_settings["address"],
+                               server_settings["port"]),
                               ClientHandler,
-                              interface=(server_settings[u"interface"]
+                              interface=(server_settings["interface"]
                                          or None),
                               use_ipv6=use_ipv6,
                               gnutls_priority=
-                              server_settings[u"priority"],
+                              server_settings["priority"],
                               use_dbus=use_dbus)
     if not debug:
-        pidfilename = u"/var/run/mandos.pid"
+        pidfilename = "/var/run/mandos.pid"
         try:
-            pidfile = open(pidfilename, u"w")
+            pidfile = open(pidfilename, "w")
         except IOError:
-            logger.error(u"Could not open file %r", pidfilename)
+            logger.error("Could not open file %r", pidfilename)
     
     try:
-        uid = pwd.getpwnam(u"_mandos").pw_uid
-        gid = pwd.getpwnam(u"_mandos").pw_gid
+        uid = pwd.getpwnam("_mandos").pw_uid
+        gid = pwd.getpwnam("_mandos").pw_gid
     except KeyError:
         try:
-            uid = pwd.getpwnam(u"mandos").pw_uid
-            gid = pwd.getpwnam(u"mandos").pw_gid
+            uid = pwd.getpwnam("mandos").pw_uid
+            gid = pwd.getpwnam("mandos").pw_gid
         except KeyError:
             try:
-                uid = pwd.getpwnam(u"nobody").pw_uid
-                gid = pwd.getpwnam(u"nobody").pw_gid
+                uid = pwd.getpwnam("nobody").pw_uid
+                gid = pwd.getpwnam("nobody").pw_gid
             except KeyError:
                 uid = 65534
                 gid = 65534
     try:
         os.setgid(gid)
         os.setuid(uid)
-    except OSError, error:
+    except OSError as error:
         if error[0] != errno.EPERM:
             raise error
     
@@ -1833,7 +1917,7 @@
         
         @gnutls.library.types.gnutls_log_func
         def debug_gnutls(level, string):
-            logger.debug(u"GnuTLS: %s", string[:-1])
+            logger.debug("GnuTLS: %s", string[:-1])
         
         (gnutls.library.functions
          .gnutls_global_set_log_function(debug_gnutls))
@@ -1860,20 +1944,20 @@
     # End of Avahi example code
     if use_dbus:
         try:
-            bus_name = dbus.service.BusName(u"se.bsnet.fukt.Mandos",
+            bus_name = dbus.service.BusName("se.bsnet.fukt.Mandos",
                                             bus, do_not_queue=True)
-        except dbus.exceptions.NameExistsException, e:
-            logger.error(unicode(e) + u", disabling D-Bus")
+        except dbus.exceptions.NameExistsException as e:
+            logger.error(unicode(e) + ", disabling D-Bus")
             use_dbus = False
-            server_settings[u"use_dbus"] = False
+            server_settings["use_dbus"] = False
             tcp_server.use_dbus = False
     protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
-    service = AvahiService(name = server_settings[u"servicename"],
-                           servicetype = u"_mandos._tcp",
+    service = AvahiService(name = server_settings["servicename"],
+                           servicetype = "_mandos._tcp",
                            protocol = protocol, bus = bus)
     if server_settings["interface"]:
         service.interface = (if_nametoindex
-                             (str(server_settings[u"interface"])))
+                             (str(server_settings["interface"])))
     
     global multiprocessing_manager
     multiprocessing_manager = multiprocessing.Manager()
@@ -1899,16 +1983,16 @@
                         client_config, section)))
             for section in client_config.sections()))
     if not tcp_server.clients:
-        logger.warning(u"No clients defined")
+        logger.warning("No clients defined")
         
     if not debug:
         try:
             with pidfile:
                 pid = os.getpid()
-                pidfile.write(str(pid) + "\n")
+                pidfile.write(str(pid) + "\n".encode("utf-8"))
             del pidfile
         except IOError:
-            logger.error(u"Could not write to file %r with PID %d",
+            logger.error("Could not write to file %r with PID %d",
                          pidfilename, pid)
         except NameError:
             # "pidfile" was never created
@@ -1924,40 +2008,40 @@
         class MandosDBusService(dbus.service.Object):
             """A D-Bus proxy object"""
             def __init__(self):
-                dbus.service.Object.__init__(self, bus, u"/")
-            _interface = u"se.bsnet.fukt.Mandos"
+                dbus.service.Object.__init__(self, bus, "/")
+            _interface = "se.bsnet.fukt.Mandos"
             
-            @dbus.service.signal(_interface, signature=u"o")
+            @dbus.service.signal(_interface, signature="o")
             def ClientAdded(self, objpath):
                 "D-Bus signal"
                 pass
             
-            @dbus.service.signal(_interface, signature=u"ss")
+            @dbus.service.signal(_interface, signature="ss")
             def ClientNotFound(self, fingerprint, address):
                 "D-Bus signal"
                 pass
             
-            @dbus.service.signal(_interface, signature=u"os")
+            @dbus.service.signal(_interface, signature="os")
             def ClientRemoved(self, objpath, name):
                 "D-Bus signal"
                 pass
             
-            @dbus.service.method(_interface, out_signature=u"ao")
+            @dbus.service.method(_interface, out_signature="ao")
             def GetAllClients(self):
                 "D-Bus method"
                 return dbus.Array(c.dbus_object_path
                                   for c in tcp_server.clients)
             
             @dbus.service.method(_interface,
-                                 out_signature=u"a{oa{sv}}")
+                                 out_signature="a{oa{sv}}")
             def GetAllClientsWithProperties(self):
                 "D-Bus method"
                 return dbus.Dictionary(
-                    ((c.dbus_object_path, c.GetAll(u""))
+                    ((c.dbus_object_path, c.GetAll(""))
                      for c in tcp_server.clients),
-                    signature=u"oa{sv}")
+                    signature="oa{sv}")
             
-            @dbus.service.method(_interface, in_signature=u"o")
+            @dbus.service.method(_interface, in_signature="o")
             def RemoveClient(self, object_path):
                 "D-Bus method"
                 for c in tcp_server.clients:
@@ -2005,11 +2089,11 @@
     # Find out what port we got
     service.port = tcp_server.socket.getsockname()[1]
     if use_ipv6:
-        logger.info(u"Now listening on address %r, port %d,"
+        logger.info("Now listening on address %r, port %d,"
                     " flowinfo %d, scope_id %d"
                     % tcp_server.socket.getsockname())
     else:                       # IPv4
-        logger.info(u"Now listening on address %r, port %d"
+        logger.info("Now listening on address %r, port %d"
                     % tcp_server.socket.getsockname())
     
     #service.interface = tcp_server.socket.getsockname()[3]
@@ -2018,8 +2102,8 @@
         # From the Avahi example code
         try:
             service.activate()
-        except dbus.exceptions.DBusException, error:
-            logger.critical(u"DBusException: %s", error)
+        except dbus.exceptions.DBusException as error:
+            logger.critical("DBusException: %s", error)
             cleanup()
             sys.exit(1)
         # End of Avahi example code
@@ -2029,17 +2113,17 @@
                              (tcp_server.handle_request
                               (*args[2:], **kwargs) or True))
         
-        logger.debug(u"Starting main loop")
+        logger.debug("Starting main loop")
         main_loop.run()
-    except AvahiError, error:
-        logger.critical(u"AvahiError: %s", error)
+    except AvahiError as error:
+        logger.critical("AvahiError: %s", error)
         cleanup()
         sys.exit(1)
     except KeyboardInterrupt:
         if debug:
-            print >> sys.stderr
-        logger.debug(u"Server received KeyboardInterrupt")
-    logger.debug(u"Server exiting")
+            print("", file=sys.stderr)
+        logger.debug("Server received KeyboardInterrupt")
+    logger.debug("Server exiting")
     # Must run before the D-Bus bus name gets deregistered
     cleanup()
 

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2010-09-27 18:57:12 +0000
+++ mandos-clients.conf.xml	2011-09-26 19:34:23 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2011-09-24">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -35,6 +35,7 @@
       <year>2008</year>
       <year>2009</year>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -181,6 +182,29 @@
       </varlistentry>
       
       <varlistentry>
+	<term><option>extended_timeout<literal> = </literal><replaceable
+	>TIME</replaceable></option></term>
+	<listitem>
+	  <para>
+	    This option is <emphasis>optional</emphasis>.
+	  </para>
+	  <para>
+	    Extended timeout is an added timeout that is given once
+	    after a password has been sent sucessfully to a client.
+	    The timeout is by default longer than the normal timeout,
+	    and is used for handling the extra long downtime while a
+	    machine is booting up.  Time to take into consideration
+	    when changing this value is file system checks and quota
+	    checks.  The default value is 15 minutes.
+	  </para>
+	  <para>
+	    The format of <replaceable>TIME</replaceable> is the same
+	    as for <varname>timeout</varname> below.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
 	<term><option>fingerprint<literal> = </literal
 	><replaceable>HEXSTRING</replaceable></option></term>
 	<listitem>
@@ -228,7 +252,7 @@
 	    will wait for a checker to complete until the below
 	    <quote><varname>timeout</varname></quote> occurs, at which
 	    time the client will be disabled, and any running checker
-	    killed.  The default interval is 5 minutes.
+	    killed.  The default interval is 2 minutes.
 	  </para>
 	  <para>
 	    The format of <replaceable>TIME</replaceable> is the same
@@ -298,10 +322,11 @@
 	    This option is <emphasis>optional</emphasis>.
 	  </para>
 	  <para>
-	    The timeout is how long the server will wait (for either a
-	    successful checker run or a client receiving its secret)
-	    until a client is disabled and not allowed to get the data
-	    this server holds.  By default Mandos will use 1 hour.
+	    The timeout is how long the server will wait, after a
+	    successful checker run, until a client is disabled and not
+	    allowed to get the data this server holds.  By default
+	    Mandos will use 5 minutes.  See also the
+	    <option>extended_timeout</option> option.
 	  </para>
 	  <para>
 	    The <replaceable>TIME</replaceable> is specified as a
@@ -419,8 +444,8 @@
     <informalexample>
       <programlisting>
 [DEFAULT]
-timeout = 1h
-interval = 5m
+timeout = 5m
+interval = 2m
 checker = fping -q -- %%(host)s
 
 # Client "foo"
@@ -459,6 +484,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-keygen</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos.conf</refentrytitle>

=== modified file 'mandos-ctl'
--- mandos-ctl	2010-10-11 17:45:21 +0000
+++ mandos-ctl	2011-09-18 14:28:47 +0000
@@ -22,73 +22,75 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-from __future__ import division
+from __future__ import (division, absolute_import, print_function,
+                        unicode_literals)
+
 import sys
 import dbus
-from optparse import OptionParser
+import argparse
 import locale
 import datetime
 import re
 import os
 
-locale.setlocale(locale.LC_ALL, u'')
+locale.setlocale(locale.LC_ALL, "")
 
 tablewords = {
-    'Name': u'Name',
-    'Enabled': u'Enabled',
-    'Timeout': u'Timeout',
-    'LastCheckedOK': u'Last Successful Check',
-    'LastApprovalRequest': u'Last Approval Request',
-    'Created': u'Created',
-    'Interval': u'Interval',
-    'Host': u'Host',
-    'Fingerprint': u'Fingerprint',
-    'CheckerRunning': u'Check Is Running',
-    'LastEnabled': u'Last Enabled',
-    'ApprovalPending': u'Approval Is Pending',
-    'ApprovedByDefault': u'Approved By Default',
-    'ApprovalDelay': u"Approval Delay",
-    'ApprovalDuration': u"Approval Duration",
-    'Checker': u'Checker',
+    "Name": "Name",
+    "Enabled": "Enabled",
+    "Timeout": "Timeout",
+    "LastCheckedOK": "Last Successful Check",
+    "LastApprovalRequest": "Last Approval Request",
+    "Created": "Created",
+    "Interval": "Interval",
+    "Host": "Host",
+    "Fingerprint": "Fingerprint",
+    "CheckerRunning": "Check Is Running",
+    "LastEnabled": "Last Enabled",
+    "ApprovalPending": "Approval Is Pending",
+    "ApprovedByDefault": "Approved By Default",
+    "ApprovalDelay": "Approval Delay",
+    "ApprovalDuration": "Approval Duration",
+    "Checker": "Checker",
+    "ExtendedTimeout" : "Extended Timeout"
     }
-defaultkeywords = ('Name', 'Enabled', 'Timeout', 'LastCheckedOK')
-domain = 'se.bsnet.fukt'
-busname = domain + '.Mandos'
-server_path = '/'
-server_interface = domain + '.Mandos'
-client_interface = domain + '.Mandos.Client'
-version = "1.2.3"
+defaultkeywords = ("Name", "Enabled", "Timeout", "LastCheckedOK")
+domain = "se.bsnet.fukt"
+busname = domain + ".Mandos"
+server_path = "/"
+server_interface = domain + ".Mandos"
+client_interface = domain + ".Mandos.Client"
+version = "1.3.1"
 
 def timedelta_to_milliseconds(td):
-    "Convert a datetime.timedelta object to milliseconds"
+    """Convert a datetime.timedelta object to milliseconds"""
     return ((td.days * 24 * 60 * 60 * 1000)
             + (td.seconds * 1000)
             + (td.microseconds // 1000))
 
 def milliseconds_to_string(ms):
     td = datetime.timedelta(0, 0, 0, ms)
-    return (u"%(days)s%(hours)02d:%(minutes)02d:%(seconds)02d"
+    return ("%(days)s%(hours)02d:%(minutes)02d:%(seconds)02d"
             % { "days": "%dT" % td.days if td.days else "",
                 "hours": td.seconds // 3600,
                 "minutes": (td.seconds % 3600) // 60,
                 "seconds": td.seconds % 60,
                 })
 
-
 def string_to_delta(interval):
     """Parse a string and return a datetime.timedelta
-
-    >>> string_to_delta('7d')
+    
+    >>> string_to_delta("7d")
     datetime.timedelta(7)
-    >>> string_to_delta('60s')
+    >>> string_to_delta("60s")
     datetime.timedelta(0, 60)
-    >>> string_to_delta('60m')
+    >>> string_to_delta("60m")
     datetime.timedelta(0, 3600)
-    >>> string_to_delta('24h')
+    >>> string_to_delta("24h")
     datetime.timedelta(1)
-    >>> string_to_delta(u'1w')
+    >>> string_to_delta("1w")
     datetime.timedelta(7)
-    >>> string_to_delta('5m 30s')
+    >>> string_to_delta("5m 30s")
     datetime.timedelta(0, 330)
     """
     timevalue = datetime.timedelta(0)
@@ -98,15 +100,15 @@
         try:
             suffix = unicode(s[-1])
             value = int(s[:-1])
-            if suffix == u"d":
+            if suffix == "d":
                 delta = datetime.timedelta(value)
-            elif suffix == u"s":
+            elif suffix == "s":
                 delta = datetime.timedelta(0, value)
-            elif suffix == u"m":
+            elif suffix == "m":
                 delta = datetime.timedelta(0, 0, 0, 0, value)
-            elif suffix == u"h":
+            elif suffix == "h":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, value)
-            elif suffix == u"w":
+            elif suffix == "w":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
             else:
                 raise ValueError
@@ -118,25 +120,25 @@
 def print_clients(clients, keywords):
     def valuetostring(value, keyword):
         if type(value) is dbus.Boolean:
-            return u"Yes" if value else u"No"
-        if keyword in (u"Timeout", u"Interval", u"ApprovalDelay",
-                       u"ApprovalDuration"):
+            return "Yes" if value else "No"
+        if keyword in ("Timeout", "Interval", "ApprovalDelay",
+                       "ApprovalDuration"):
             return milliseconds_to_string(value)
         return unicode(value)
     
     # Create format string to print table rows
-    format_string = u' '.join(u'%%-%ds' %
-                              max(len(tablewords[key]),
-                                  max(len(valuetostring(client[key],
-                                                        key))
-                                      for client in
-                                      clients))
-                              for key in keywords)
+    format_string = " ".join("%%-%ds" %
+                             max(len(tablewords[key]),
+                                 max(len(valuetostring(client[key],
+                                                       key))
+                                     for client in
+                                     clients))
+                             for key in keywords)
     # Print header line
-    print format_string % tuple(tablewords[key] for key in keywords)
+    print(format_string % tuple(tablewords[key] for key in keywords))
     for client in clients:
-        print format_string % tuple(valuetostring(client[key], key)
-                                    for key in keywords)
+        print(format_string % tuple(valuetostring(client[key], key)
+                                    for key in keywords))
 
 def has_actions(options):
     return any((options.enable,
@@ -148,6 +150,7 @@
                 options.remove,
                 options.checker is not None,
                 options.timeout is not None,
+                options.extended_timeout is not None,
                 options.interval is not None,
                 options.approved_by_default is not None,
                 options.approval_delay is not None,
@@ -156,182 +159,198 @@
                 options.secret is not None,
                 options.approve,
                 options.deny))
-        
+
 def main():
-	parser = OptionParser(version = "%%prog %s" % version)
-	parser.add_option("-a", "--all", action="store_true",
-	                  help="Select all clients")
-	parser.add_option("-v", "--verbose", action="store_true",
-	                  help="Print all fields")
-	parser.add_option("-e", "--enable", action="store_true",
-	                  help="Enable client")
-	parser.add_option("-d", "--disable", action="store_true",
-	                  help="disable client")
-	parser.add_option("-b", "--bump-timeout", action="store_true",
-	                  help="Bump timeout for client")
-	parser.add_option("--start-checker", action="store_true",
-	                  help="Start checker for client")
-	parser.add_option("--stop-checker", action="store_true",
-	                  help="Stop checker for client")
-	parser.add_option("-V", "--is-enabled", action="store_true",
-	                  help="Check if client is enabled")
-	parser.add_option("-r", "--remove", action="store_true",
-	                  help="Remove client")
-	parser.add_option("-c", "--checker", type="string",
-	                  help="Set checker command for client")
-	parser.add_option("-t", "--timeout", type="string",
-	                  help="Set timeout for client")
-	parser.add_option("-i", "--interval", type="string",
-	                  help="Set checker interval for client")
-        parser.add_option("--approve-by-default", action="store_true",
-                          dest=u"approved_by_default",
-                          help="Set client to be approved by default")
-        parser.add_option("--deny-by-default", action="store_false",
-                          dest=u"approved_by_default",
-                          help="Set client to be denied by default")
-        parser.add_option("--approval-delay", type="string",
-                          help="Set delay before client approve/deny")
-        parser.add_option("--approval-duration", type="string",
-                          help="Set duration of one client approval")
-	parser.add_option("-H", "--host", type="string",
-	                  help="Set host for client")
-	parser.add_option("-s", "--secret", type="string",
-	                  help="Set password blob (file) for client")
-	parser.add_option("-A", "--approve", action="store_true",
-	                  help="Approve any current client request")
-	parser.add_option("-D", "--deny", action="store_true",
-	                  help="Deny any current client request")
-	options, client_names = parser.parse_args()
-        
-        if has_actions(options) and not client_names and not options.all:
-            parser.error('Options require clients names or --all.')
-        if options.verbose and has_actions(options):
-            parser.error('--verbose can only be used alone or with'
-                         ' --all.')
-        if options.all and not has_actions(options):
-            parser.error('--all requires an action.')
-        
-        try:
-            bus = dbus.SystemBus()
-            mandos_dbus_objc = bus.get_object(busname, server_path)
-        except dbus.exceptions.DBusException:
-            print >> sys.stderr, "Could not connect to Mandos server"
-            sys.exit(1)
-    
-        mandos_serv = dbus.Interface(mandos_dbus_objc,
-                                     dbus_interface = server_interface)
-
-        #block stderr since dbus library prints to stderr
-        null = os.open(os.path.devnull, os.O_RDWR)
-        stderrcopy = os.dup(sys.stderr.fileno())
-        os.dup2(null, sys.stderr.fileno())
-        os.close(null)
-        try:
-            try:
-                mandos_clients = mandos_serv.GetAllClientsWithProperties()
-            finally:
-                #restore stderr
-                os.dup2(stderrcopy, sys.stderr.fileno())
-                os.close(stderrcopy)
-        except dbus.exceptions.DBusException, e:
-            print >> sys.stderr, "Access denied: Accessing mandos server through dbus."
-            sys.exit(1)
-            
-	# Compile dict of (clients: properties) to process
-	clients={}
-        
-        if options.all or not client_names:
-            clients = dict((bus.get_object(busname, path), properties)
-                           for path, properties in
-                           mandos_clients.iteritems())
-        else:
-            for name in client_names:
-                for path, client in mandos_clients.iteritems():
-                    if client['Name'] == name:
-                        client_objc = bus.get_object(busname, path)
-                        clients[client_objc] = client
-                        break
-                else:
-                    print >> sys.stderr, "Client not found on server: %r" % name
-                    sys.exit(1)
-            
-	if not has_actions(options) and clients:
-	    if options.verbose:
-	        keywords = ('Name', 'Enabled', 'Timeout',
-                            'LastCheckedOK', 'Created', 'Interval',
-                            'Host', 'Fingerprint', 'CheckerRunning',
-                            'LastEnabled', 'ApprovalPending',
-                            'ApprovedByDefault',
-                            'LastApprovalRequest', 'ApprovalDelay',
-                            'ApprovalDuration', 'Checker')
+    parser = argparse.ArgumentParser()
+    parser.add_argument("--version", action="version",
+                        version = "%%prog %s" % version,
+                        help="show version number and exit")
+    parser.add_argument("-a", "--all", action="store_true",
+                        help="Select all clients")
+    parser.add_argument("-v", "--verbose", action="store_true",
+                        help="Print all fields")
+    parser.add_argument("-e", "--enable", action="store_true",
+                        help="Enable client")
+    parser.add_argument("-d", "--disable", action="store_true",
+                        help="disable client")
+    parser.add_argument("-b", "--bump-timeout", action="store_true",
+                        help="Bump timeout for client")
+    parser.add_argument("--start-checker", action="store_true",
+                        help="Start checker for client")
+    parser.add_argument("--stop-checker", action="store_true",
+                        help="Stop checker for client")
+    parser.add_argument("-V", "--is-enabled", action="store_true",
+                        help="Check if client is enabled")
+    parser.add_argument("-r", "--remove", action="store_true",
+                        help="Remove client")
+    parser.add_argument("-c", "--checker",
+                        help="Set checker command for client")
+    parser.add_argument("-t", "--timeout",
+                        help="Set timeout for client")
+    parser.add_argument("--extended-timeout",
+                        help="Set extended timeout for client")
+    parser.add_argument("-i", "--interval",
+                        help="Set checker interval for client")
+    parser.add_argument("--approve-by-default", action="store_true",
+                        default=None, dest="approved_by_default",
+                        help="Set client to be approved by default")
+    parser.add_argument("--deny-by-default", action="store_false",
+                        dest="approved_by_default",
+                        help="Set client to be denied by default")
+    parser.add_argument("--approval-delay",
+                        help="Set delay before client approve/deny")
+    parser.add_argument("--approval-duration",
+                        help="Set duration of one client approval")
+    parser.add_argument("-H", "--host", help="Set host for client")
+    parser.add_argument("-s", "--secret", type=file,
+                        help="Set password blob (file) for client")
+    parser.add_argument("-A", "--approve", action="store_true",
+                        help="Approve any current client request")
+    parser.add_argument("-D", "--deny", action="store_true",
+                        help="Deny any current client request")
+    parser.add_argument("client", nargs="*", help="Client name")
+    options = parser.parse_args()
+    
+    if has_actions(options) and not options.client and not options.all:
+        parser.error("Options require clients names or --all.")
+    if options.verbose and has_actions(options):
+        parser.error("--verbose can only be used alone or with"
+                     " --all.")
+    if options.all and not has_actions(options):
+        parser.error("--all requires an action.")
+    
+    try:
+        bus = dbus.SystemBus()
+        mandos_dbus_objc = bus.get_object(busname, server_path)
+    except dbus.exceptions.DBusException:
+        print("Could not connect to Mandos server",
+              file=sys.stderr)
+        sys.exit(1)
+    
+    mandos_serv = dbus.Interface(mandos_dbus_objc,
+                                 dbus_interface = server_interface)
+    
+    #block stderr since dbus library prints to stderr
+    null = os.open(os.path.devnull, os.O_RDWR)
+    stderrcopy = os.dup(sys.stderr.fileno())
+    os.dup2(null, sys.stderr.fileno())
+    os.close(null)
+    try:
+        try:
+            mandos_clients = mandos_serv.GetAllClientsWithProperties()
+        finally:
+            #restore stderr
+            os.dup2(stderrcopy, sys.stderr.fileno())
+            os.close(stderrcopy)
+    except dbus.exceptions.DBusException, e:
+        print("Access denied: Accessing mandos server through dbus.",
+              file=sys.stderr)
+        sys.exit(1)
+    
+    # Compile dict of (clients: properties) to process
+    clients={}
+    
+    if options.all or not options.client:
+        clients = dict((bus.get_object(busname, path), properties)
+                       for path, properties in
+                       mandos_clients.iteritems())
+    else:
+        for name in options.client:
+            for path, client in mandos_clients.iteritems():
+                if client["Name"] == name:
+                    client_objc = bus.get_object(busname, path)
+                    clients[client_objc] = client
+                    break
             else:
-                keywords = defaultkeywords
-            
-	    print_clients(clients.values(), keywords)
+                print("Client not found on server: %r" % name,
+                      file=sys.stderr)
+                sys.exit(1)
+    
+    if not has_actions(options) and clients:
+        if options.verbose:
+            keywords = ("Name", "Enabled", "Timeout",
+                        "LastCheckedOK", "Created", "Interval",
+                        "Host", "Fingerprint", "CheckerRunning",
+                        "LastEnabled", "ApprovalPending",
+                        "ApprovedByDefault",
+                        "LastApprovalRequest", "ApprovalDelay",
+                        "ApprovalDuration", "Checker",
+                        "ExtendedTimeout")
         else:
-            # Process each client in the list by all selected options
-            for client in clients:
-                if options.remove:
-                    mandos_serv.RemoveClient(client.__dbus_object_path__)
-                if options.enable:
-                    client.Enable(dbus_interface=client_interface)
-                if options.disable:
-                    client.Disable(dbus_interface=client_interface)
-                if options.bump_timeout:
-                    client.CheckedOK(dbus_interface=client_interface)
-                if options.start_checker:
-                    client.StartChecker(dbus_interface=client_interface)
-                if options.stop_checker:
-                    client.StopChecker(dbus_interface=client_interface)
-                if options.is_enabled:
-                    sys.exit(0 if client.Get(client_interface,
-                                             u"Enabled",
-                                             dbus_interface=dbus.PROPERTIES_IFACE)
-                             else 1)
-                if options.checker:
-                    client.Set(client_interface, u"Checker", options.checker,
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.host:
-                    client.Set(client_interface, u"Host", options.host,
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.interval:
-                    client.Set(client_interface, u"Interval",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.interval)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approval_delay:
-                    client.Set(client_interface, u"ApprovalDelay",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.
-                                                approval_delay)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approval_duration:
-                    client.Set(client_interface, u"ApprovalDuration",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.
-                                                approval_duration)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.timeout:
-                    client.Set(client_interface, u"Timeout",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.timeout)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.secret:
-                    client.Set(client_interface, u"Secret",
-                               dbus.ByteArray(open(options.secret,
-                                                   u'rb').read()),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approved_by_default is not None:
-                    client.Set(client_interface, u"ApprovedByDefault",
-                               dbus.Boolean(options
-                                            .approved_by_default),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approve:
-                    client.Approve(dbus.Boolean(True),
-                                   dbus_interface=client_interface)
-                elif options.deny:
-                    client.Approve(dbus.Boolean(False),
-                                   dbus_interface=client_interface)
+            keywords = defaultkeywords
+        
+        print_clients(clients.values(), keywords)
+    else:
+        # Process each client in the list by all selected options
+        for client in clients:
+            if options.remove:
+                mandos_serv.RemoveClient(client.__dbus_object_path__)
+            if options.enable:
+                client.Enable(dbus_interface=client_interface)
+            if options.disable:
+                client.Disable(dbus_interface=client_interface)
+            if options.bump_timeout:
+                client.CheckedOK(dbus_interface=client_interface)
+            if options.start_checker:
+                client.StartChecker(dbus_interface=client_interface)
+            if options.stop_checker:
+                client.StopChecker(dbus_interface=client_interface)
+            if options.is_enabled:
+                sys.exit(0 if client.Get(client_interface,
+                                         "Enabled",
+                                         dbus_interface=
+                                         dbus.PROPERTIES_IFACE)
+                         else 1)
+            if options.checker:
+                client.Set(client_interface, "Checker",
+                           options.checker,
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.host:
+                client.Set(client_interface, "Host", options.host,
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.interval:
+                client.Set(client_interface, "Interval",
+                           timedelta_to_milliseconds
+                           (string_to_delta(options.interval)),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.approval_delay:
+                client.Set(client_interface, "ApprovalDelay",
+                           timedelta_to_milliseconds
+                           (string_to_delta(options.
+                                            approval_delay)),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.approval_duration:
+                client.Set(client_interface, "ApprovalDuration",
+                           timedelta_to_milliseconds
+                           (string_to_delta(options.
+                                            approval_duration)),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.timeout:
+                client.Set(client_interface, "Timeout",
+                           timedelta_to_milliseconds
+                           (string_to_delta(options.timeout)),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.extended_timeout:
+                client.Set(client_interface, "ExtendedTimeout",
+                           timedelta_to_milliseconds
+                           (string_to_delta(options.extended_timeout)),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.secret:
+                client.Set(client_interface, "Secret",
+                           dbus.ByteArray(open(options.secret,
+                                               "rb").read()),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.approved_by_default is not None:
+                client.Set(client_interface, "ApprovedByDefault",
+                           dbus.Boolean(options
+                                        .approved_by_default),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.approve:
+                client.Approve(dbus.Boolean(True),
+                               dbus_interface=client_interface)
+            elif options.deny:
+                client.Approve(dbus.Boolean(False),
+                               dbus_interface=client_interface)
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     main()

=== modified file 'mandos-ctl.xml'
--- mandos-ctl.xml	2010-09-25 23:52:17 +0000
+++ mandos-ctl.xml	2011-09-18 14:28:47 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-ctl">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -32,6 +32,7 @@
     </authorgroup>
     <copyright>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -94,6 +95,11 @@
       </group>
       <sbr/>
       <group>
+	<arg choice="plain"><option>--extended-timeout
+	<replaceable>TIME</replaceable></option></arg>
+      </group>
+      <sbr/>
+      <group>
 	<arg choice="plain"><option>--interval
 	<replaceable>TIME</replaceable></option></arg>
 	<arg choice="plain"><option>-i
@@ -317,6 +323,19 @@
 	  </para>
 	</listitem>
       </varlistentry>
+
+      <varlistentry>
+	<term><option>--extended-timeout
+	<replaceable>TIME</replaceable></option></term>
+	<listitem>
+	  <para>
+	    Set the <varname>extended_timeout</varname> option of the
+	    specified client(s); see <citerefentry><refentrytitle
+	    >mandos-clients.conf</refentrytitle><manvolnum
+	    >5</manvolnum></citerefentry>.
+	  </para>
+	</listitem>
+      </varlistentry>
       
       <varlistentry>
 	<term><option>--interval
@@ -553,6 +572,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>

=== modified file 'mandos-keygen'
--- mandos-keygen	2010-10-11 17:45:21 +0000
+++ mandos-keygen	2011-08-17 22:27:13 +0000
@@ -2,8 +2,8 @@
 # 
 # Mandos key generator - create a new OpenPGP key for a Mandos client
 # 
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
+# Copyright © 2008-2011 Teddy Hogeborn
+# Copyright © 2008-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-VERSION="1.2.3"
+VERSION="1.3.1"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA
@@ -192,7 +192,7 @@
 shred --remove \"$RINGDIR\"/sec*;
 test -n \"$BATCHFILE\" && rm --force \"$BATCHFILE\"; \
 rm --recursive --force \"$RINGDIR\";
-stty echo; \
+tty --quiet && stty echo; \
 " EXIT
 
 set -e
@@ -289,31 +289,37 @@
     
     FILECOMMENT="Encrypted password for a Mandos client"
     
-    if [ -n "$PASSFILE" ]; then
-	cat "$PASSFILE"
-    else
-	stty -echo
-	echo -n "Enter passphrase: " >&2
-	first="$(head --lines=1 | tr --delete '\n')"
-	echo >&2
-	echo -n "Repeat passphrase: " >&2
-	second="$(head --lines=1 | tr --delete '\n')"
-	echo >&2
-	stty echo
-	if [ "$first" != "$second" ]; then
-	    echo "Passphrase mismatch" >&2
-	    touch "$RINGDIR"/mismatch
+    while [ ! -s "$SECFILE" ]; do
+	if [ -n "$PASSFILE" ]; then
+	    cat "$PASSFILE"
 	else
-	    echo -n "$first"
+	    tty --quiet && stty -echo
+	    read -p "Enter passphrase: " first
+	    tty --quiet && echo >&2
+	    read -p "Repeat passphrase: " second
+	    if tty --quiet; then
+		echo >&2
+		stty echo
+	    fi
+	    if [ "$first" != "$second" ]; then
+		echo "Passphrase mismatch" >&2
+		touch "$RINGDIR"/mismatch
+	    else
+		echo -n "$first"
+	    fi
+	fi | gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
+	    --homedir "$RINGDIR" --trust-model always --armor \
+	    --encrypt --sign --recipient "$FINGERPRINT" --comment \
+	    "$FILECOMMENT" > "$SECFILE"
+	if [ -e "$RINGDIR"/mismatch ]; then
+	    rm --force "$RINGDIR"/mismatch
+	    if tty --quiet; then
+		> "$SECFILE"
+	    else
+		exit 1
+	    fi
 	fi
-    fi | gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
-	--homedir "$RINGDIR" --trust-model always --armor --encrypt \
-	--sign --recipient "$FINGERPRINT" --comment "$FILECOMMENT" \
-	> "$SECFILE"
-    if [ -e "$RINGDIR"/mismatch ]; then
-	rm --force "$RINGDIR"/mismatch
-	exit 1
-    fi
+    done
     
     cat <<-EOF
 	[$KEYNAME]

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2009-01-04 21:54:55 +0000
+++ mandos-keygen.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -33,6 +33,7 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -492,6 +493,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>gpg</refentrytitle>
       <manvolnum>1</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>

=== modified file 'mandos-monitor'
--- mandos-monitor	2010-10-11 17:45:21 +0000
+++ mandos-monitor	2011-09-18 14:28:47 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2009,2010 Teddy Hogeborn
-# Copyright © 2009,2010 Björn Påhlsson
+# Copyright © 2009-2011 Teddy Hogeborn
+# Copyright © 2009-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,7 +22,8 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-from __future__ import division, absolute_import, with_statement
+from __future__ import (division, absolute_import, print_function,
+                        unicode_literals)
 
 import sys
 import os
@@ -42,7 +43,7 @@
 
 import locale
 
-locale.setlocale(locale.LC_ALL, u'')
+locale.setlocale(locale.LC_ALL, '')
 
 import logging
 logging.getLogger('dbus.proxies').setLevel(logging.CRITICAL)
@@ -51,7 +52,7 @@
 domain = 'se.bsnet.fukt'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.2.3"
+version = "1.3.1"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False
@@ -65,9 +66,9 @@
     "Parse an ISO 8601 date string to a datetime.datetime()"
     if not iso:
         return None
-    d, t = iso.split(u"T", 1)
-    year, month, day = d.split(u"-", 2)
-    hour, minute, second = t.split(u":", 2)
+    d, t = iso.split("T", 1)
+    year, month, day = d.split("-", 2)
+    hour, minute, second = t.split(":", 2)
     second, fraction = divmod(float(second), 1)
     return datetime.datetime(int(year),
                              int(month),
@@ -86,16 +87,17 @@
         self.proxy = proxy_object # Mandos Client proxy object
         
         self.properties = dict()
-        self.proxy.connect_to_signal(u"PropertyChanged",
-                                     self.property_changed,
-                                     client_interface,
-                                     byte_arrays=True)
+        self.property_changed_match = (
+            self.proxy.connect_to_signal("PropertyChanged",
+                                         self.property_changed,
+                                         client_interface,
+                                         byte_arrays=True))
         
         self.properties.update(
             self.proxy.GetAll(client_interface,
                               dbus_interface = dbus.PROPERTIES_IFACE))
 
-        #XXX This break good super behaviour!
+        #XXX This breaks good super behaviour
 #        super(MandosClientPropertyCache, self).__init__(
 #            *args, **kwargs)
     
@@ -105,6 +107,11 @@
         """
         # Update properties dict with new value
         self.properties[property] = value
+    
+    def delete(self, *args, **kwargs):
+        self.property_changed_match.remove()
+        super(MandosClientPropertyCache, self).__init__(
+            *args, **kwargs)
 
 
 class MandosClientWidget(urwid.FlowWidget, MandosClientPropertyCache):
@@ -127,9 +134,9 @@
         self.last_checker_failed = False
         
         # The widget shown normally
-        self._text_widget = urwid.Text(u"")
+        self._text_widget = urwid.Text("")
         # The widget shown when we have focus
-        self._focus_text_widget = urwid.Text(u"")
+        self._focus_text_widget = urwid.Text("")
         super(MandosClientWidget, self).__init__(
             update_hook=update_hook, delete_hook=delete_hook,
             *args, **kwargs)
@@ -137,7 +144,7 @@
         self.opened = False
         
         last_checked_ok = isoformat_to_datetime(self.properties
-                                                [u"LastCheckedOK"])
+                                                ["LastCheckedOK"])
         if last_checked_ok is None:
             self.last_checker_failed = True
         else:
@@ -146,7 +153,7 @@
                                         > datetime.timedelta
                                         (milliseconds=
                                          self.properties
-                                         [u"Interval"]))
+                                         ["Interval"]))
         
         if self.last_checker_failed:
             self.using_timer(True)
@@ -154,31 +161,33 @@
         if self.need_approval:
             self.using_timer(True)
         
-        self.proxy.connect_to_signal(u"CheckerCompleted",
-                                     self.checker_completed,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"CheckerStarted",
-                                     self.checker_started,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"GotSecret",
-                                     self.got_secret,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"NeedApproval",
-                                     self.need_approval,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"Rejected",
-                                     self.rejected,
-                                     client_interface,
-                                     byte_arrays=True)
+        self.match_objects = (
+            self.proxy.connect_to_signal("CheckerCompleted",
+                                         self.checker_completed,
+                                         client_interface,
+                                         byte_arrays=True),
+            self.proxy.connect_to_signal("CheckerStarted",
+                                         self.checker_started,
+                                         client_interface,
+                                         byte_arrays=True),
+            self.proxy.connect_to_signal("GotSecret",
+                                         self.got_secret,
+                                         client_interface,
+                                         byte_arrays=True),
+            self.proxy.connect_to_signal("NeedApproval",
+                                         self.need_approval,
+                                         client_interface,
+                                         byte_arrays=True),
+            self.proxy.connect_to_signal("Rejected",
+                                         self.rejected,
+                                         client_interface,
+                                         byte_arrays=True))
+        #self.logger('Created client %s' % (self.properties["Name"]))
     
     def property_changed(self, property=None, value=None):
         super(self, MandosClientWidget).property_changed(property,
                                                          value)
-        if property == u"ApprovalPending":
+        if property == "ApprovalPending":
             using_timer(bool(value))
         
     def using_timer(self, flag):
@@ -191,6 +200,7 @@
         else:
             self._update_timer_callback_lock -= 1
         if old == 0 and self._update_timer_callback_lock:
+            # Will update the shown timer value every second
             self._update_timer_callback_tag = (gobject.timeout_add
                                                (1000,
                                                 self.update_timer))
@@ -203,9 +213,9 @@
             if self.last_checker_failed:
                 self.last_checker_failed = False
                 self.using_timer(False)
-            #self.logger(u'Checker for client %s (command "%s")'
-            #            u' was successful'
-            #            % (self.properties[u"Name"], command))
+            #self.logger('Checker for client %s (command "%s")'
+            #            ' was successful'
+            #            % (self.properties["Name"], command))
             self.update()
             return
         # Checker failed
@@ -213,57 +223,57 @@
             self.last_checker_failed = True
             self.using_timer(True)
         if os.WIFEXITED(condition):
-            self.logger(u'Checker for client %s (command "%s")'
-                        u' failed with exit code %s'
-                        % (self.properties[u"Name"], command,
+            self.logger('Checker for client %s (command "%s")'
+                        ' failed with exit code %s'
+                        % (self.properties["Name"], command,
                            os.WEXITSTATUS(condition)))
         elif os.WIFSIGNALED(condition):
-            self.logger(u'Checker for client %s (command "%s")'
-                        u' was killed by signal %s'
-                        % (self.properties[u"Name"], command,
+            self.logger('Checker for client %s (command "%s")'
+                        ' was killed by signal %s'
+                        % (self.properties["Name"], command,
                            os.WTERMSIG(condition)))
         elif os.WCOREDUMP(condition):
-            self.logger(u'Checker for client %s (command "%s")'
-                        u' dumped core'
-                        % (self.properties[u"Name"], command))
+            self.logger('Checker for client %s (command "%s")'
+                        ' dumped core'
+                        % (self.properties["Name"], command))
         else:
-            self.logger(u'Checker for client %s completed'
-                        u' mysteriously')
+            self.logger('Checker for client %s completed'
+                        ' mysteriously')
         self.update()
     
     def checker_started(self, command):
-        #self.logger(u'Client %s started checker "%s"'
-        #            % (self.properties[u"Name"], unicode(command)))
+        #self.logger('Client %s started checker "%s"'
+        #            % (self.properties["Name"], unicode(command)))
         pass
     
     def got_secret(self):
         self.last_checker_failed = False
-        self.logger(u'Client %s received its secret'
-                    % self.properties[u"Name"])
+        self.logger('Client %s received its secret'
+                    % self.properties["Name"])
     
     def need_approval(self, timeout, default):
         if not default:
-            message = u'Client %s needs approval within %s seconds'
+            message = 'Client %s needs approval within %s seconds'
         else:
-            message = u'Client %s will get its secret in %s seconds'
+            message = 'Client %s will get its secret in %s seconds'
         self.logger(message
-                    % (self.properties[u"Name"], timeout/1000))
+                    % (self.properties["Name"], timeout/1000))
         self.using_timer(True)
     
     def rejected(self, reason):
-        self.logger(u'Client %s was rejected; reason: %s'
-                    % (self.properties[u"Name"], reason))
+        self.logger('Client %s was rejected; reason: %s'
+                    % (self.properties["Name"], reason))
     
     def selectable(self):
         """Make this a "selectable" widget.
         This overrides the method from urwid.FlowWidget."""
         return True
     
-    def rows(self, (maxcol,), focus=False):
+    def rows(self, maxcolrow, focus=False):
         """How many rows this widget will occupy might depend on
         whether we have focus or not.
         This overrides the method from urwid.FlowWidget"""
-        return self.current_widget(focus).rows((maxcol,), focus=focus)
+        return self.current_widget(focus).rows(maxcolrow, focus=focus)
     
     def current_widget(self, focus=False):
         if focus or self.opened:
@@ -273,56 +283,56 @@
     def update(self):
         "Called when what is visible on the screen should be updated."
         # How to add standout mode to a style
-        with_standout = { u"normal": u"standout",
-                          u"bold": u"bold-standout",
-                          u"underline-blink":
-                              u"underline-blink-standout",
-                          u"bold-underline-blink":
-                              u"bold-underline-blink-standout",
+        with_standout = { "normal": "standout",
+                          "bold": "bold-standout",
+                          "underline-blink":
+                              "underline-blink-standout",
+                          "bold-underline-blink":
+                              "bold-underline-blink-standout",
                           }
 
         # Rebuild focus and non-focus widgets using current properties
 
         # Base part of a client. Name!
-        base = (u'%(name)s: '
-                      % {u"name": self.properties[u"Name"]})
-        if not self.properties[u"Enabled"]:
-            message = u"DISABLED"
-        elif self.properties[u"ApprovalPending"]:
+        base = ('%(name)s: '
+                      % {"name": self.properties["Name"]})
+        if not self.properties["Enabled"]:
+            message = "DISABLED"
+        elif self.properties["ApprovalPending"]:
             timeout = datetime.timedelta(milliseconds
                                          = self.properties
-                                         [u"ApprovalDelay"])
+                                         ["ApprovalDelay"])
             last_approval_request = isoformat_to_datetime(
-                self.properties[u"LastApprovalRequest"])
+                self.properties["LastApprovalRequest"])
             if last_approval_request is not None:
                 timer = timeout - (datetime.datetime.utcnow()
                                    - last_approval_request)
             else:
                 timer = datetime.timedelta()
-            if self.properties[u"ApprovedByDefault"]:
-                message = u"Approval in %s. (d)eny?"
+            if self.properties["ApprovedByDefault"]:
+                message = "Approval in %s. (d)eny?"
             else:
-                message = u"Denial in %s. (a)pprove?"
+                message = "Denial in %s. (a)pprove?"
             message = message % unicode(timer).rsplit(".", 1)[0]
         elif self.last_checker_failed:
-            timeout = datetime.timedelta(milliseconds
-                                         = self.properties
-                                         [u"Timeout"])
-            last_ok = isoformat_to_datetime(
-                max((self.properties[u"LastCheckedOK"]
-                     or self.properties[u"Created"]),
-                    self.properties[u"LastEnabled"]))
-            timer = timeout - (datetime.datetime.utcnow() - last_ok)
-            message = (u'A checker has failed! Time until client'
-                       u' gets disabled: %s'
+            # When checker has failed, print a timer until client expires
+            expires = self.properties["Expires"]
+            if expires == "":
+                timer = datetime.timedelta(0)
+            else:
+                expires = datetime.datetime.strptime(expires,
+                                                     '%Y-%m-%dT%H:%M:%S.%f')
+                timer = expires - datetime.datetime.utcnow()
+            message = ('A checker has failed! Time until client'
+                       ' gets disabled: %s'
                            % unicode(timer).rsplit(".", 1)[0])
         else:
-            message = u"enabled"
+            message = "enabled"
         self._text = "%s%s" % (base, message)
             
         if not urwid.supports_unicode():
             self._text = self._text.encode("ascii", "replace")
-        textlist = [(u"normal", self._text)]
+        textlist = [("normal", self._text)]
         self._text_widget.set_text(textlist)
         self._focus_text_widget.set_text([(with_standout[text[0]],
                                            text[1])
@@ -337,51 +347,64 @@
             self.update_hook()
     
     def update_timer(self):
-        "called by gobject"
+        """called by gobject. Will indefinitely loop until
+        gobject.source_remove() on tag is called"""
         self.update()
         return True             # Keep calling this
     
-    def delete(self):
+    def delete(self, *args, **kwargs):
         if self._update_timer_callback_tag is not None:
             gobject.source_remove(self._update_timer_callback_tag)
             self._update_timer_callback_tag = None
+        for match in self.match_objects:
+            match.remove()
+        self.match_objects = ()
         if self.delete_hook is not None:
             self.delete_hook(self)
+        return super(MandosClientWidget, self).delete(*args, **kwargs)
     
-    def render(self, (maxcol,), focus=False):
+    def render(self, maxcolrow, focus=False):
         """Render differently if we have focus.
         This overrides the method from urwid.FlowWidget"""
-        return self.current_widget(focus).render((maxcol,),
+        return self.current_widget(focus).render(maxcolrow,
                                                  focus=focus)
     
-    def keypress(self, (maxcol,), key):
+    def keypress(self, maxcolrow, key):
         """Handle keys.
         This overrides the method from urwid.FlowWidget"""
-        if key == u"+":
-            self.proxy.Enable(dbus_interface = client_interface)
-        elif key == u"-":
-            self.proxy.Disable(dbus_interface = client_interface)
-        elif key == u"a":
+        if key == "+":
+            self.proxy.Enable(dbus_interface = client_interface,
+                              ignore_reply=True)
+        elif key == "-":
+            self.proxy.Disable(dbus_interface = client_interface,
+                               ignore_reply=True)
+        elif key == "a":
             self.proxy.Approve(dbus.Boolean(True, variant_level=1),
-                               dbus_interface = client_interface)
-        elif key == u"d":
+                               dbus_interface = client_interface,
+                               ignore_reply=True)
+        elif key == "d":
             self.proxy.Approve(dbus.Boolean(False, variant_level=1),
-                                  dbus_interface = client_interface)
-        elif key == u"R" or key == u"_" or key == u"ctrl k":
+                                  dbus_interface = client_interface,
+                               ignore_reply=True)
+        elif key == "R" or key == "_" or key == "ctrl k":
             self.server_proxy_object.RemoveClient(self.proxy
-                                                  .object_path)
-        elif key == u"s":
-            self.proxy.StartChecker(dbus_interface = client_interface)
-        elif key == u"S":
-            self.proxy.StopChecker(dbus_interface = client_interface)
-        elif key == u"C":
-            self.proxy.CheckedOK(dbus_interface = client_interface)
+                                                  .object_path,
+                                                  ignore_reply=True)
+        elif key == "s":
+            self.proxy.StartChecker(dbus_interface = client_interface,
+                                    ignore_reply=True)
+        elif key == "S":
+            self.proxy.StopChecker(dbus_interface = client_interface,
+                                   ignore_reply=True)
+        elif key == "C":
+            self.proxy.CheckedOK(dbus_interface = client_interface,
+                                 ignore_reply=True)
         # xxx
-#         elif key == u"p" or key == "=":
+#         elif key == "p" or key == "=":
 #             self.proxy.pause()
-#         elif key == u"u" or key == ":":
+#         elif key == "u" or key == ":":
 #             self.proxy.unpause()
-#         elif key == u"RET":
+#         elif key == "RET":
 #             self.open()
         else:
             return key
@@ -403,10 +426,9 @@
     "down" key presses, thus not allowing any containing widgets to
     use them as an excuse to shift focus away from this widget.
     """
-    def keypress(self, (maxcol, maxrow), key):
-        ret = super(ConstrainedListBox, self).keypress((maxcol,
-                                                        maxrow), key)
-        if ret in (u"up", u"down"):
+    def keypress(self, maxcolrow, key):
+        ret = super(ConstrainedListBox, self).keypress(maxcolrow, key)
+        if ret in ("up", "down"):
             return
         return ret
 
@@ -421,31 +443,31 @@
         self.screen = urwid.curses_display.Screen()
         
         self.screen.register_palette((
-                (u"normal",
-                 u"default", u"default", None),
-                (u"bold",
-                 u"default", u"default", u"bold"),
-                (u"underline-blink",
-                 u"default", u"default", u"underline"),
-                (u"standout",
-                 u"default", u"default", u"standout"),
-                (u"bold-underline-blink",
-                 u"default", u"default", (u"bold", u"underline")),
-                (u"bold-standout",
-                 u"default", u"default", (u"bold", u"standout")),
-                (u"underline-blink-standout",
-                 u"default", u"default", (u"underline", u"standout")),
-                (u"bold-underline-blink-standout",
-                 u"default", u"default", (u"bold", u"underline",
-                                          u"standout")),
+                ("normal",
+                 "default", "default", None),
+                ("bold",
+                 "default", "default", "bold"),
+                ("underline-blink",
+                 "default", "default", "underline"),
+                ("standout",
+                 "default", "default", "standout"),
+                ("bold-underline-blink",
+                 "default", "default", ("bold", "underline")),
+                ("bold-standout",
+                 "default", "default", ("bold", "standout")),
+                ("underline-blink-standout",
+                 "default", "default", ("underline", "standout")),
+                ("bold-underline-blink-standout",
+                 "default", "default", ("bold", "underline",
+                                          "standout")),
                 ))
         
         if urwid.supports_unicode():
-            self.divider = u"─" # \u2500
-            #self.divider = u"━" # \u2501
+            self.divider = "─" # \u2500
+            #self.divider = "━" # \u2501
         else:
-            #self.divider = u"-" # \u002d
-            self.divider = u"_" # \u005f
+            #self.divider = "-" # \u002d
+            self.divider = "_" # \u005f
         
         self.screen.start()
         
@@ -465,19 +487,19 @@
         # This keeps track of whether self.uilist currently has
         # self.logbox in it or not
         self.log_visible = True
-        self.log_wrap = u"any"
+        self.log_wrap = "any"
         
         self.rebuild()
-        self.log_message_raw((u"bold",
-                              u"Mandos Monitor version " + version))
-        self.log_message_raw((u"bold",
-                              u"q: Quit  ?: Help"))
+        self.log_message_raw(("bold",
+                              "Mandos Monitor version " + version))
+        self.log_message_raw(("bold",
+                              "q: Quit  ?: Help"))
         
         self.busname = domain + '.Mandos'
         self.main_loop = gobject.MainLoop()
         self.bus = dbus.SystemBus()
         mandos_dbus_objc = self.bus.get_object(
-            self.busname, u"/", follow_name_owner_changes=True)
+            self.busname, "/", follow_name_owner_changes=True)
         self.mandos_serv = dbus.Interface(mandos_dbus_objc,
                                           dbus_interface
                                           = server_interface)
@@ -488,17 +510,17 @@
             mandos_clients = dbus.Dictionary()
         
         (self.mandos_serv
-         .connect_to_signal(u"ClientRemoved",
+         .connect_to_signal("ClientRemoved",
                             self.find_and_remove_client,
                             dbus_interface=server_interface,
                             byte_arrays=True))
         (self.mandos_serv
-         .connect_to_signal(u"ClientAdded",
+         .connect_to_signal("ClientAdded",
                             self.add_new_client,
                             dbus_interface=server_interface,
                             byte_arrays=True))
         (self.mandos_serv
-         .connect_to_signal(u"ClientNotFound",
+         .connect_to_signal("ClientNotFound",
                             self.client_not_found,
                             dbus_interface=server_interface,
                             byte_arrays=True))
@@ -519,8 +541,8 @@
                             path=path)
     
     def client_not_found(self, fingerprint, address):
-        self.log_message((u"Client with address %s and fingerprint %s"
-                          u" could not be found" % (address,
+        self.log_message(("Client with address %s and fingerprint %s"
+                          " could not be found" % (address,
                                                     fingerprint)))
     
     def rebuild(self):
@@ -542,7 +564,7 @@
     
     def log_message(self, message):
         timestamp = datetime.datetime.now().isoformat()
-        self.log_message_raw(timestamp + u": " + message)
+        self.log_message_raw(timestamp + ": " + message)
     
     def log_message_raw(self, markup):
         """Add a log message to the log buffer."""
@@ -551,29 +573,29 @@
             and len(self.log) > self.max_log_length):
             del self.log[0:len(self.log)-self.max_log_length-1]
         self.logbox.set_focus(len(self.logbox.body.contents),
-                              coming_from=u"above")
+                              coming_from="above")
         self.refresh()
     
     def toggle_log_display(self):
         """Toggle visibility of the log buffer."""
         self.log_visible = not self.log_visible
         self.rebuild()
-        #self.log_message(u"Log visibility changed to: "
+        #self.log_message("Log visibility changed to: "
         #                 + unicode(self.log_visible))
     
     def change_log_display(self):
         """Change type of log display.
         Currently, this toggles wrapping of text lines."""
-        if self.log_wrap == u"clip":
-            self.log_wrap = u"any"
+        if self.log_wrap == "clip":
+            self.log_wrap = "any"
         else:
-            self.log_wrap = u"clip"
+            self.log_wrap = "clip"
         for textwidget in self.log:
             textwidget.set_wrap_mode(self.log_wrap)
-        #self.log_message(u"Wrap mode: " + self.log_wrap)
+        #self.log_message("Wrap mode: " + self.log_wrap)
     
     def find_and_remove_client(self, path, name):
-        """Find an client from its object path and remove it.
+        """Find a client by its object path and remove it.
         
         This is connected to the ClientRemoved signal from the
         Mandos server object."""
@@ -581,8 +603,10 @@
             client = self.clients_dict[path]
         except KeyError:
             # not found?
+            self.log_message("Unknown client %r (%r) removed", name,
+                             path)
             return
-        self.remove_client(client, path)
+        client.delete()
     
     def add_new_client(self, path):
         client_proxy_object = self.bus.get_object(self.busname, path)
@@ -603,7 +627,7 @@
         if path is None:
             path = client.proxy.object_path
         self.clients_dict[path] = client
-        self.clients.sort(None, lambda c: c.properties[u"Name"])
+        self.clients.sort(None, lambda c: c.properties["Name"])
         self.refresh()
     
     def remove_client(self, client, path=None):
@@ -640,15 +664,15 @@
     
     def process_input(self, source, condition):
         keys = self.screen.get_input()
-        translations = { u"ctrl n": u"down",      # Emacs
-                         u"ctrl p": u"up",        # Emacs
-                         u"ctrl v": u"page down", # Emacs
-                         u"meta v": u"page up",   # Emacs
-                         u" ": u"page down",      # less
-                         u"f": u"page down",      # less
-                         u"b": u"page up",        # less
-                         u"j": u"down",           # vi
-                         u"k": u"up",             # vi
+        translations = { "ctrl n": "down",      # Emacs
+                         "ctrl p": "up",        # Emacs
+                         "ctrl v": "page down", # Emacs
+                         "meta v": "page up",   # Emacs
+                         " ": "page down",      # less
+                         "f": "page down",      # less
+                         "b": "page up",        # less
+                         "j": "down",           # vi
+                         "k": "up",             # vi
                          }
         for key in keys:
             try:
@@ -656,66 +680,66 @@
             except KeyError:    # :-)
                 pass
             
-            if key == u"q" or key == u"Q":
+            if key == "q" or key == "Q":
                 self.stop()
                 break
-            elif key == u"window resize":
+            elif key == "window resize":
                 self.size = self.screen.get_cols_rows()
                 self.refresh()
-            elif key == u"\f":  # Ctrl-L
+            elif key == "\f":  # Ctrl-L
                 self.refresh()
-            elif key == u"l" or key == u"D":
+            elif key == "l" or key == "D":
                 self.toggle_log_display()
                 self.refresh()
-            elif key == u"w" or key == u"i":
+            elif key == "w" or key == "i":
                 self.change_log_display()
                 self.refresh()
-            elif key == u"?" or key == u"f1" or key == u"esc":
+            elif key == "?" or key == "f1" or key == "esc":
                 if not self.log_visible:
                     self.log_visible = True
                     self.rebuild()
-                self.log_message_raw((u"bold",
-                                      u"  ".
-                                      join((u"q: Quit",
-                                            u"?: Help",
-                                            u"l: Log window toggle",
-                                            u"TAB: Switch window",
-                                            u"w: Wrap (log)"))))
-                self.log_message_raw((u"bold",
-                                      u"  "
-                                      .join((u"Clients:",
-                                             u"+: Enable",
-                                             u"-: Disable",
-                                             u"R: Remove",
-                                             u"s: Start new checker",
-                                             u"S: Stop checker",
-                                             u"C: Checker OK",
-                                             u"a: Approve",
-                                             u"d: Deny"))))
+                self.log_message_raw(("bold",
+                                      "  ".
+                                      join(("q: Quit",
+                                            "?: Help",
+                                            "l: Log window toggle",
+                                            "TAB: Switch window",
+                                            "w: Wrap (log)"))))
+                self.log_message_raw(("bold",
+                                      "  "
+                                      .join(("Clients:",
+                                             "+: Enable",
+                                             "-: Disable",
+                                             "R: Remove",
+                                             "s: Start new checker",
+                                             "S: Stop checker",
+                                             "C: Checker OK",
+                                             "a: Approve",
+                                             "d: Deny"))))
                 self.refresh()
-            elif key == u"tab":
+            elif key == "tab":
                 if self.topwidget.get_focus() is self.logbox:
                     self.topwidget.set_focus(0)
                 else:
                     self.topwidget.set_focus(self.logbox)
                 self.refresh()
-            #elif (key == u"end" or key == u"meta >" or key == u"G"
-            #      or key == u">"):
+            #elif (key == "end" or key == "meta >" or key == "G"
+            #      or key == ">"):
             #    pass            # xxx end-of-buffer
-            #elif (key == u"home" or key == u"meta <" or key == u"g"
-            #      or key == u"<"):
+            #elif (key == "home" or key == "meta <" or key == "g"
+            #      or key == "<"):
             #    pass            # xxx beginning-of-buffer
-            #elif key == u"ctrl e" or key == u"$":
+            #elif key == "ctrl e" or key == "$":
             #    pass            # xxx move-end-of-line
-            #elif key == u"ctrl a" or key == u"^":
+            #elif key == "ctrl a" or key == "^":
             #    pass            # xxx move-beginning-of-line
-            #elif key == u"ctrl b" or key == u"meta (" or key == u"h":
+            #elif key == "ctrl b" or key == "meta (" or key == "h":
             #    pass            # xxx left
-            #elif key == u"ctrl f" or key == u"meta )" or key == u"l":
+            #elif key == "ctrl f" or key == "meta )" or key == "l":
             #    pass            # xxx right
-            #elif key == u"a":
+            #elif key == "a":
             #    pass            # scroll up log
-            #elif key == u"z":
+            #elif key == "z":
             #    pass            # scroll down log
             elif self.topwidget.selectable():
                 self.topwidget.keypress(self.size, key)

=== modified file 'mandos-monitor.xml'
--- mandos-monitor.xml	2010-09-30 06:24:20 +0000
+++ mandos-monitor.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-monitor">
-<!ENTITY TIMESTAMP "2010-09-14">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -32,6 +32,7 @@
     </authorgroup>
     <copyright>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -218,6 +219,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-ctl</refentrytitle>

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2009-02-25 01:14:29 +0000
+++ mandos.conf.xml	2011-08-08 21:12:37 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2009-02-25">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -34,6 +34,7 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -204,6 +205,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>gnutls_priority_init</refentrytitle
       ><manvolnum>3</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos</refentrytitle>

=== modified file 'mandos.lsm'
--- mandos.lsm	2010-10-11 17:45:21 +0000
+++ mandos.lsm	2011-07-27 17:58:27 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.2.3
-Entered-date:	2010-10-11
+Version:	1.3.1
+Entered-date:	2011-07-27
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,10 +12,10 @@
 Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
 		belorn@fukt.bsnet.se (Björn Påhlsson)
 Primary-site: http://www.fukt.bsnet.se/mandos
-	      133K mandos_1.2.3.orig.tar.gz
+	      136K mandos_1.3.1.orig.tar.gz
 Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		133K mandos_1.2.3.orig.tar.gz
-Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.5, and
+		136K mandos_1.3.1.orig.tar.gz
+Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.
 Copying-policy: GNU General Public License version 3.0 or later

=== modified file 'mandos.xml'
--- mandos.xml	2010-09-27 17:39:03 +0000
+++ mandos.xml	2011-09-18 14:28:47 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -34,6 +34,7 @@
       <year>2008</year>
       <year>2009</year>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -116,14 +117,16 @@
     <para>
       <command>&COMMANDNAME;</command> is a server daemon which
       handles incoming request for passwords for a pre-defined list of
-      client host computers.  The Mandos server uses Zeroconf to
-      announce itself on the local network, and uses TLS to
-      communicate securely with and to authenticate the clients.  The
-      Mandos server uses IPv6 to allow Mandos clients to use IPv6
-      link-local addresses, since the clients will probably not have
-      any other addresses configured (see <xref linkend="overview"/>).
-      Any authenticated client is then given the stored pre-encrypted
-      password for that specific client.
+      client host computers. For an introduction, see
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>. The Mandos server
+      uses Zeroconf to announce itself on the local network, and uses
+      TLS to communicate securely with and to authenticate the
+      clients.  The Mandos server uses IPv6 to allow Mandos clients to
+      use IPv6 link-local addresses, since the clients will probably
+      not have any other addresses configured (see <xref
+      linkend="overview"/>).  Any authenticated client is then given
+      the stored pre-encrypted password for that specific client.
     </para>
   </refsect1>
   
@@ -351,9 +354,9 @@
       for some time, the client is assumed to be compromised and is no
       longer eligible to receive the encrypted password.  (Manual
       intervention is required to re-enable a client.)  The timeout,
-      checker program, and interval between checks can be configured
-      both globally and per client; see <citerefentry>
-      <refentrytitle>mandos-clients.conf</refentrytitle>
+      extended timeout, checker program, and interval between checks
+      can be configured both globally and per client; see
+      <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>.  A client successfully
       receiving its password will also be treated as a successful
       checker run.
@@ -609,15 +612,16 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
-      <citerefentry>
-	<refentrytitle>mandos-clients.conf</refentrytitle>
-	<manvolnum>5</manvolnum></citerefentry>, <citerefentry>
-	<refentrytitle>mandos.conf</refentrytitle>
-	<manvolnum>5</manvolnum></citerefentry>, <citerefentry>
-	<refentrytitle>mandos-client</refentrytitle>
-	<manvolnum>8mandos</manvolnum></citerefentry>, <citerefentry>
-	<refentrytitle>sh</refentrytitle><manvolnum>1</manvolnum>
-      </citerefentry>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
+      <manvolnum>5</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos.conf</refentrytitle>
+      <manvolnum>5</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-client</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>sh</refentrytitle>
+      <manvolnum>1</manvolnum></citerefentry>
     </para>
     <variablelist>
       <varlistentry>

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2010-09-26 21:27:28 +0000
+++ plugin-runner.c	2011-07-16 00:29:19 +0000
@@ -742,7 +742,29 @@
     }
   }
   
-  /* Strip permissions down to nobody */
+  {
+    /* Work around Debian bug #633582:
+       <http://bugs.debian.org/633582> */
+    int plugindir_fd = open(/* plugindir or */ PDIR, O_RDONLY);
+    if(plugindir_fd == -1){
+      error(0, errno, "open");
+    } else {
+      ret = (int)TEMP_FAILURE_RETRY(fstat(plugindir_fd, &st));
+      if(ret == -1){
+	error(0, errno, "fstat");
+      } else {
+	if(S_ISDIR(st.st_mode) and st.st_uid == 0 and st.st_gid == 0){
+	  ret = fchown(plugindir_fd, uid, gid);
+	  if(ret == -1){
+	    error(0, errno, "fchown");
+	  }
+	}
+      }
+      TEMP_FAILURE_RETRY(close(plugindir_fd));
+    }
+  }
+  
+  /* Lower permissions */
   setgid(gid);
   if(ret == -1){
     error(0, errno, "setgid");

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2009-01-18 06:41:57 +0000
+++ plugin-runner.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2009-01-17">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -33,6 +33,7 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -617,6 +618,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>cryptsetup</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>crypttab</refentrytitle>

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2010-09-26 18:32:58 +0000
+++ plugins.d/askpass-fifo.c	2011-07-13 02:24:39 +0000
@@ -2,8 +2,8 @@
 /*
  * Askpass-FIFO - Read a password from a FIFO and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -32,6 +32,8 @@
 				   ENFILE, ENOMEM, EBADF, EINVAL, EIO,
 				   EISDIR, EFBIG */
 #include <error.h>		/* error() */
+#include <stdio.h>		/* fprintf(), vfprintf(),
+				   vasprintf() */
 #include <stdlib.h>		/* EXIT_FAILURE, NULL, size_t, free(),
 				   realloc(), EXIT_SUCCESS */
 #include <fcntl.h>		/* open(), O_RDONLY */
@@ -39,7 +41,32 @@
 				   STDOUT_FILENO */
 #include <sysexits.h>		/* EX_OSERR, EX_OSFILE,
 				   EX_UNAVAILABLE, EX_IOERR */
-
+#include <string.h> 		/* strerror() */
+#include <stdarg.h>		/* va_list, va_start(), ... */
+
+
+/* Function to use when printing errors */
+void error_plus(int status, int errnum, const char *formatstring,
+		...){
+  va_list ap;
+  char *text;
+  int ret;
+  
+  va_start(ap, formatstring);
+  ret = vasprintf(&text, formatstring, ap);
+  if (ret == -1){
+    fprintf(stderr, "Mandos plugin %s: ",
+	    program_invocation_short_name);
+    vfprintf(stderr, formatstring, ap);
+    fprintf(stderr, ": ");
+    fprintf(stderr, "%s\n", strerror(errnum));
+    error(status, errno, "vasprintf while printing error");
+    return;
+  }
+  fprintf(stderr, "Mandos plugin ");
+  error(status, errnum, "%s", text);
+  free(text);
+}
 
 int main(__attribute__((unused))int argc,
 	 __attribute__((unused))char **argv){
@@ -51,19 +78,19 @@
   ret = mkfifo(passfifo, S_IRUSR | S_IWUSR);
   if(ret == -1){
     int e = errno;
-    error(0, errno, "mkfifo");
     switch(e){
     case EACCES:
     case ENOTDIR:
     case ELOOP:
-      return EX_OSFILE;
+      error_plus(EX_OSFILE, errno, "mkfifo");
     case ENAMETOOLONG:
     case ENOSPC:
     case EROFS:
     default:
-      return EX_OSERR;
+      error_plus(EX_OSERR, errno, "mkfifo");
     case ENOENT:
-      return EX_UNAVAILABLE;	/* no "/lib/cryptsetup"? */
+      /* no "/lib/cryptsetup"? */
+      error_plus(EX_UNAVAILABLE, errno, "mkfifo");
     case EEXIST:
       break;			/* not an error */
     }
@@ -73,7 +100,7 @@
   int fifo_fd = open(passfifo, O_RDONLY);
   if(fifo_fd == -1){
     int e = errno;
-    error(0, errno, "open");
+    error_plus(0, errno, "open");
     switch(e){
     case EACCES:
     case ENOENT:
@@ -101,7 +128,7 @@
       if(buf_len + blocksize > buf_allocated){
 	char *tmp = realloc(buf, buf_allocated + blocksize);
 	if(tmp == NULL){
-	  error(0, errno, "realloc");
+	  error_plus(0, errno, "realloc");
 	  free(buf);
 	  return EX_OSERR;
 	}
@@ -113,7 +140,7 @@
 	int e = errno;
 	free(buf);
 	errno = e;
-	error(0, errno, "read");
+	error_plus(0, errno, "read");
 	switch(e){
 	case EBADF:
 	case EFAULT:
@@ -141,7 +168,7 @@
       int e = errno;
       free(buf);
       errno = e;
-      error(0, errno, "write");
+      error_plus(0, errno, "write");
       switch(e){
       case EBADF:
       case EFAULT:
@@ -161,7 +188,7 @@
   ret = close(STDOUT_FILENO);
   if(ret == -1){
     int e = errno;
-    error(0, errno, "close");
+    error_plus(0, errno, "close");
     switch(e){
     case EBADF:
       return EX_OSFILE;

=== modified file 'plugins.d/askpass-fifo.xml'
--- plugins.d/askpass-fifo.xml	2009-01-04 21:54:55 +0000
+++ plugins.d/askpass-fifo.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "askpass-fifo">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -33,6 +33,7 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -148,6 +149,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>fifo</refentrytitle>
       <manvolnum>7</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>plugin-runner</refentrytitle>

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2010-09-26 21:27:28 +0000
+++ plugins.d/mandos-client.c	2011-08-07 14:49:02 +0000
@@ -9,8 +9,8 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -62,7 +62,8 @@
 #include <inttypes.h>		/* PRIu16, PRIdMAX, intmax_t,
 				   strtoimax() */
 #include <assert.h>		/* assert() */
-#include <errno.h>		/* perror(), errno */
+#include <errno.h>		/* perror(), errno,
+				   program_invocation_short_name */
 #include <time.h>		/* nanosleep(), time(), sleep() */
 #include <net/if.h>		/* ioctl, ifreq, SIOCGIFFLAGS, IFF_UP,
 				   SIOCSIFFLAGS, if_indextoname(),
@@ -73,7 +74,7 @@
 #include <unistd.h>		/* close(), SEEK_SET, off_t, write(),
 				   getuid(), getgid(), seteuid(),
 				   setgid(), pause() */
-#include <arpa/inet.h>		/* inet_pton(), htons */
+#include <arpa/inet.h>		/* inet_pton(), htons, inet_ntop() */
 #include <iso646.h>		/* not, or, and */
 #include <argp.h>		/* struct argp_option, error_t, struct
 				   argp_state, struct argp,
@@ -130,6 +131,17 @@
 static const char sys_class_net[] = "/sys/class/net";
 char *connect_to = NULL;
 
+/* Doubly linked list that need to be circularly linked when used */
+typedef struct server{
+  const char *ip;
+  uint16_t port;
+  AvahiIfIndex if_index;
+  int af;
+  struct timespec last_seen;
+  struct server *next;
+  struct server *prev;
+} server;
+
 /* Used for passing in values through the Avahi callback functions */
 typedef struct {
   AvahiSimplePoll *simple_poll;
@@ -139,16 +151,25 @@
   gnutls_dh_params_t dh_params;
   const char *priority;
   gpgme_ctx_t ctx;
+  server *current_server;
 } mandos_context;
 
 /* global context so signal handler can reach it*/
 mandos_context mc = { .simple_poll = NULL, .server = NULL,
 		      .dh_bits = 1024, .priority = "SECURE256"
-		      ":!CTYPE-X.509:+CTYPE-OPENPGP" };
+		      ":!CTYPE-X.509:+CTYPE-OPENPGP",
+		      .current_server = NULL };
 
 sig_atomic_t quit_now = 0;
 int signal_received = 0;
 
+/* Function to use when printing errors */
+void perror_plus(const char *print_text){
+  fprintf(stderr, "Mandos plugin %s: ",
+	  program_invocation_short_name);
+  perror(print_text);
+}
+
 /*
  * Make additional room in "buffer" for at least BUFFER_SIZE more
  * bytes. "buffer_capacity" is how much is currently allocated,
@@ -166,6 +187,44 @@
   return buffer_capacity;
 }
 
+/* Add server to set of servers to retry periodically */
+int add_server(const char *ip, uint16_t port,
+		 AvahiIfIndex if_index,
+		 int af){
+  int ret;
+  server *new_server = malloc(sizeof(server));
+  if(new_server == NULL){
+    perror_plus("malloc");
+    return -1;
+  }
+  *new_server = (server){ .ip = strdup(ip),
+			 .port = port,
+			 .if_index = if_index,
+			 .af = af };
+  if(new_server->ip == NULL){
+    perror_plus("strdup");
+    return -1;
+  }
+  /* Special case of first server */
+  if (mc.current_server == NULL){
+    new_server->next = new_server;
+    new_server->prev = new_server;
+    mc.current_server = new_server;
+  /* Place the new server last in the list */
+  } else {
+    new_server->next = mc.current_server;
+    new_server->prev = mc.current_server->prev;
+    new_server->prev->next = new_server;
+    mc.current_server->prev = new_server;
+  }
+  ret = clock_gettime(CLOCK_MONOTONIC, &mc.current_server->last_seen);
+  if(ret == -1){
+    perror_plus("clock_gettime");
+    return -1;
+  }
+  return 0;
+}
+
 /* 
  * Initialize GPGME.
  */
@@ -185,7 +244,7 @@
     
     fd = (int)TEMP_FAILURE_RETRY(open(filename, O_RDONLY));
     if(fd == -1){
-      perror("open");
+      perror_plus("open");
       return false;
     }
     
@@ -205,7 +264,7 @@
     
     ret = (int)TEMP_FAILURE_RETRY(close(fd));
     if(ret == -1){
-      perror("close");
+      perror_plus("close");
     }
     gpgme_data_release(pgp_data);
     return true;
@@ -224,7 +283,7 @@
     return false;
   }
   
-    /* Set GPGME home directory for the OpenPGP engine only */
+  /* Set GPGME home directory for the OpenPGP engine only */
   rc = gpgme_get_engine_info(&engine_info);
   if(rc != GPG_ERR_NO_ERROR){
     fprintf(stderr, "bad gpgme_get_engine_info: %s: %s\n",
@@ -336,7 +395,7 @@
   
   /* Seek back to the beginning of the GPGME plaintext data buffer */
   if(gpgme_data_seek(dh_plain, (off_t)0, SEEK_SET) == -1){
-    perror("gpgme_data_seek");
+    perror_plus("gpgme_data_seek");
     plaintext_length = -1;
     goto decrypt_end;
   }
@@ -347,7 +406,7 @@
 				      (size_t)plaintext_length,
 				      plaintext_capacity);
     if(plaintext_capacity == 0){
-	perror("incbuffer");
+	perror_plus("incbuffer");
 	plaintext_length = -1;
 	goto decrypt_end;
     }
@@ -360,7 +419,7 @@
       break;
     }
     if(ret < 0){
-      perror("gpgme_data_read");
+      perror_plus("gpgme_data_read");
       plaintext_length = -1;
       goto decrypt_end;
     }
@@ -423,12 +482,9 @@
   }
   
   /* OpenPGP credentials */
-  gnutls_certificate_allocate_credentials(&mc.cred);
+  ret = gnutls_certificate_allocate_credentials(&mc.cred);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "GnuTLS memory error: %s\n", /* Spurious warning
-						    from
-						    -Wunreachable-code
-						 */
+    fprintf(stderr, "GnuTLS memory error: %s\n",
 	    safer_gnutls_strerror(ret));
     gnutls_global_deinit();
     return -1;
@@ -589,7 +645,7 @@
   tcp_sd = socket(pf, SOCK_STREAM, 0);
   if(tcp_sd < 0){
     int e = errno;
-    perror("socket");
+    perror_plus("socket");
     errno = e;
     goto mandos_end;
   }
@@ -609,7 +665,7 @@
   }
   if(ret < 0 ){
     int e = errno;
-    perror("inet_pton");
+    perror_plus("inet_pton");
     errno = e;
     goto mandos_end;
   }
@@ -651,7 +707,7 @@
     if(af == AF_INET6 and if_index != AVAHI_IF_UNSPEC){
       char interface[IF_NAMESIZE];
       if(if_indextoname((unsigned int)if_index, interface) == NULL){
-	perror("if_indextoname");
+	perror_plus("if_indextoname");
       } else {
 	fprintf(stderr, "Connection to: %s%%%s, port %" PRIu16 "\n",
 		ip, interface, port);
@@ -671,7 +727,7 @@
 			sizeof(addrstr));
     }
     if(pcret == NULL){
-      perror("inet_ntop");
+      perror_plus("inet_ntop");
     } else {
       if(strcmp(addrstr, ip) != 0){
 	fprintf(stderr, "Canonical address form: %s\n", addrstr);
@@ -692,7 +748,7 @@
   if(ret < 0){
     if ((errno != ECONNREFUSED and errno != ENETUNREACH) or debug){
       int e = errno;
-      perror("connect");
+      perror_plus("connect");
       errno = e;
     }
     goto mandos_end;
@@ -711,7 +767,7 @@
 				   out_size - written));
     if(ret == -1){
       int e = errno;
-      perror("write");
+      perror_plus("write");
       errno = e;
       goto mandos_end;
     }
@@ -742,6 +798,7 @@
     goto mandos_end;
   }
   
+  /* Spurious warning from -Wint-to-pointer-cast */
   gnutls_transport_set_ptr(session, (gnutls_transport_ptr_t) tcp_sd);
   
   if(quit_now){
@@ -784,7 +841,7 @@
 				   buffer_capacity);
     if(buffer_capacity == 0){
       int e = errno;
-      perror("incbuffer");
+      perror_plus("incbuffer");
       errno = e;
       goto mandos_end;
     }
@@ -895,14 +952,14 @@
       if(e == 0){
 	e = errno;
       }
-      perror("close");
+      perror_plus("close");
     }
     gnutls_deinit(session);
+    errno = e;
     if(quit_now){
-      e = EINTR;
+      errno = EINTR;
       retval = -1;
     }
-    errno = e;
   }
   return retval;
 }
@@ -951,6 +1008,9 @@
 					   avahi_proto_to_af(proto));
       if(ret == 0){
 	avahi_simple_poll_quit(mc.simple_poll);
+      } else {
+	ret = add_server(ip, port, interface,
+			 avahi_proto_to_af(proto));
       }
     }
   }
@@ -1010,7 +1070,7 @@
   }
 }
 
-/* stop main loop after sigterm has been called */
+/* Signal handler that stops main loop after SIGTERM */
 static void handle_sigterm(int sig){
   if(quit_now){
     return;
@@ -1018,6 +1078,7 @@
   quit_now = 1;
   signal_received = sig;
   int old_errno = errno;
+  /* set main loop to exit */
   if(mc.simple_poll != NULL){
     avahi_simple_poll_quit(mc.simple_poll);
   }
@@ -1032,27 +1093,29 @@
 int good_interface(const struct dirent *if_entry){
   ssize_t ssret;
   char *flagname = NULL;
+  if(if_entry->d_name[0] == '.'){
+    return 0;
+  }
   int ret = asprintf(&flagname, "%s/%s/flags", sys_class_net,
 		     if_entry->d_name);
   if(ret < 0){
-    perror("asprintf");
-    return 0;
-  }
-  if(if_entry->d_name[0] == '.'){
+    perror_plus("asprintf");
     return 0;
   }
   int flags_fd = (int)TEMP_FAILURE_RETRY(open(flagname, O_RDONLY));
   if(flags_fd == -1){
-    perror("open");
+    perror_plus("open");
+    free(flagname);
     return 0;
   }
+  free(flagname);
   typedef short ifreq_flags;	/* ifreq.ifr_flags in netdevice(7) */
   /* read line from flags_fd */
-  ssize_t to_read = (sizeof(ifreq_flags)*2)+3; /* "0x1003\n" */
+  ssize_t to_read = 2+(sizeof(ifreq_flags)*2)+1; /* "0x1003\n" */
   char *flagstring = malloc((size_t)to_read+1); /* +1 for final \0 */
   flagstring[(size_t)to_read] = '\0';
   if(flagstring == NULL){
-    perror("malloc");
+    perror_plus("malloc");
     close(flags_fd);
     return 0;
   }
@@ -1060,7 +1123,7 @@
     ssret = (ssize_t)TEMP_FAILURE_RETRY(read(flags_fd, flagstring,
 					     (size_t)to_read));
     if(ssret == -1){
-      perror("read");
+      perror_plus("read");
       free(flagstring);
       close(flags_fd);
       return 0;
@@ -1111,6 +1174,14 @@
     }
     return 0;
   }
+  /* Reject non-ARP interfaces (including dummy interfaces) */
+  if(flags & IFF_NOARP){
+    if(debug){
+      fprintf(stderr, "Rejecting non-ARP interface \"%s\"\n",
+	      if_entry->d_name);
+    }
+    return 0;
+  }
   /* Accept this device */
   if(debug){
     fprintf(stderr, "Interface \"%s\" is acceptable\n",
@@ -1119,6 +1190,88 @@
   return 1;
 }
 
+int notdotentries(const struct dirent *direntry){
+  /* Skip "." and ".." */
+  if(direntry->d_name[0] == '.'
+     and (direntry->d_name[1] == '\0'
+	  or (direntry->d_name[1] == '.'
+	      and direntry->d_name[2] == '\0'))){
+    return 0;
+  }
+  return 1;
+}
+
+int avahi_loop_with_timeout(AvahiSimplePoll *s, int retry_interval){
+  int ret;
+  struct timespec now;
+  struct timespec waited_time;
+  intmax_t block_time;
+  
+  while(true){
+    if(mc.current_server == NULL){
+      if (debug){
+	fprintf(stderr,
+		"Wait until first server is found. No timeout!\n");
+      }
+      ret = avahi_simple_poll_iterate(s, -1);
+    } else {
+      if (debug){
+	fprintf(stderr, "Check current_server if we should run it,"
+		" or wait\n");
+      }
+      /* the current time */
+      ret = clock_gettime(CLOCK_MONOTONIC, &now);
+      if(ret == -1){
+	perror_plus("clock_gettime");
+	return -1;
+      }
+      /* Calculating in ms how long time between now and server
+	 who we visted longest time ago. Now - last seen.  */
+      waited_time.tv_sec = (now.tv_sec
+			    - mc.current_server->last_seen.tv_sec);
+      waited_time.tv_nsec = (now.tv_nsec
+			     - mc.current_server->last_seen.tv_nsec);
+      /* total time is 10s/10,000ms.
+	 Converting to s from ms by dividing by 1,000,
+	 and ns to ms by dividing by 1,000,000. */
+      block_time = ((retry_interval
+		     - ((intmax_t)waited_time.tv_sec * 1000))
+		    - ((intmax_t)waited_time.tv_nsec / 1000000));
+      
+      if (debug){
+	fprintf(stderr, "Blocking for %" PRIdMAX " ms\n", block_time);
+      }
+      
+      if(block_time <= 0){
+	ret = start_mandos_communication(mc.current_server->ip,
+					 mc.current_server->port,
+					 mc.current_server->if_index,
+					 mc.current_server->af);
+	if(ret == 0){
+	  avahi_simple_poll_quit(mc.simple_poll);
+	  return 0;
+	}
+	ret = clock_gettime(CLOCK_MONOTONIC,
+			    &mc.current_server->last_seen);
+	if(ret == -1){
+	  perror_plus("clock_gettime");
+	  return -1;
+	}
+	mc.current_server = mc.current_server->next;
+	block_time = 0; 	/* Call avahi to find new Mandos
+				   servers, but don't block */
+      }
+      
+      ret = avahi_simple_poll_iterate(s, (int)block_time);
+    }
+    if(ret != 0){
+      if (ret > 0 or errno != EINTR) {
+	return (ret != 1) ? ret : 0;
+      }
+    }
+  }
+}
+
 int main(int argc, char *argv[]){
   AvahiSServiceBrowser *sb = NULL;
   int error;
@@ -1141,6 +1294,8 @@
   bool gnutls_initialized = false;
   bool gpgme_initialized = false;
   float delay = 2.5f;
+  double retry_interval = 10; /* 10s between trying a server and
+				 retrying the same server again */
   
   struct sigaction old_sigterm_action = { .sa_handler = SIG_DFL };
   struct sigaction sigterm_action = { .sa_handler = handle_sigterm };
@@ -1152,14 +1307,14 @@
   errno = 0;
   ret = setgid(gid);
   if(ret == -1){
-    perror("setgid");
+    perror_plus("setgid");
   }
   
   /* Lower user privileges (temporarily) */
   errno = 0;
   ret = seteuid(uid);
   if(ret == -1){
-    perror("seteuid");
+    perror_plus("seteuid");
   }
   
   if(quit_now){
@@ -1200,6 +1355,10 @@
 	.arg = "SECONDS",
 	.doc = "Maximum delay to wait for interface startup",
 	.group = 2 },
+      { .name = "retry", .key = 132,
+	.arg = "SECONDS",
+	.doc = "Retry interval used when denied by the mandos server",
+	.group = 2 },
       /*
        * These reproduce what we would get without ARGP_NO_HELP
        */
@@ -1249,6 +1408,14 @@
 	if(errno != 0 or tmp == arg or *tmp != '\0'){
 	  argp_error(state, "Bad delay");
 	}
+      case 132:			/* --retry */
+	errno = 0;
+	retry_interval = strtod(arg, &tmp);
+	if(errno != 0 or tmp == arg or *tmp != '\0'
+	   or (retry_interval * 1000) > INT_MAX
+	   or retry_interval < 0){
+	  argp_error(state, "Bad retry interval");
+	}
 	break;
 	/*
 	 * These reproduce what we would get without ARGP_NO_HELP
@@ -1282,7 +1449,7 @@
     case ENOMEM:
     default:
       errno = ret;
-      perror("argp_parse");
+      perror_plus("argp_parse");
       exitcode = EX_OSERR;
       goto end;
     case EINVAL:
@@ -1290,6 +1457,66 @@
       goto end;
     }
   }
+    
+  {
+    /* Work around Debian bug #633582:
+       <http://bugs.debian.org/633582> */
+    struct stat st;
+    
+    /* Re-raise priviliges */
+    errno = 0;
+    ret = seteuid(0);
+    if(ret == -1){
+      perror_plus("seteuid");
+    }
+    
+    if(strcmp(seckey, PATHDIR "/" SECKEY) == 0){
+      int seckey_fd = open(seckey, O_RDONLY);
+      if(seckey_fd == -1){
+	perror_plus("open");
+      } else {
+	ret = (int)TEMP_FAILURE_RETRY(fstat(seckey_fd, &st));
+	if(ret == -1){
+	  perror_plus("fstat");
+	} else {
+	  if(S_ISREG(st.st_mode) and st.st_uid == 0 and st.st_gid == 0){
+	    ret = fchown(seckey_fd, uid, gid);
+	    if(ret == -1){
+	      perror_plus("fchown");
+	    }
+	  }
+	}
+	TEMP_FAILURE_RETRY(close(seckey_fd));
+      }
+    }
+    
+    if(strcmp(pubkey, PATHDIR "/" PUBKEY) == 0){
+      int pubkey_fd = open(pubkey, O_RDONLY);
+      if(pubkey_fd == -1){
+	perror_plus("open");
+      } else {
+	ret = (int)TEMP_FAILURE_RETRY(fstat(pubkey_fd, &st));
+	if(ret == -1){
+	  perror_plus("fstat");
+	} else {
+	  if(S_ISREG(st.st_mode) and st.st_uid == 0 and st.st_gid == 0){
+	    ret = fchown(pubkey_fd, uid, gid);
+	    if(ret == -1){
+	      perror_plus("fchown");
+	    }
+	  }
+	}
+	TEMP_FAILURE_RETRY(close(pubkey_fd));
+      }
+    }
+    
+    /* Lower privileges */
+    errno = 0;
+    ret = seteuid(uid);
+    if(ret == -1){
+      perror_plus("seteuid");
+    }
+  }
   
   if(not debug){
     avahi_set_log_function(empty_log);
@@ -1306,7 +1533,7 @@
 	fprintf(stderr, "Using interface \"%s\"\n", interface);
       }
       if(interface == NULL){
-	perror("malloc");
+	perror_plus("malloc");
 	free(direntries);
 	exitcode = EXIT_FAILURE;
 	goto end;
@@ -1334,19 +1561,19 @@
   sigemptyset(&sigterm_action.sa_mask);
   ret = sigaddset(&sigterm_action.sa_mask, SIGINT);
   if(ret == -1){
-    perror("sigaddset");
+    perror_plus("sigaddset");
     exitcode = EX_OSERR;
     goto end;
   }
   ret = sigaddset(&sigterm_action.sa_mask, SIGHUP);
   if(ret == -1){
-    perror("sigaddset");
+    perror_plus("sigaddset");
     exitcode = EX_OSERR;
     goto end;
   }
   ret = sigaddset(&sigterm_action.sa_mask, SIGTERM);
   if(ret == -1){
-    perror("sigaddset");
+    perror_plus("sigaddset");
     exitcode = EX_OSERR;
     goto end;
   }
@@ -1356,39 +1583,39 @@
   */
   ret = sigaction(SIGINT, NULL, &old_sigterm_action);
   if(ret == -1){
-    perror("sigaction");
+    perror_plus("sigaction");
     return EX_OSERR;
   }
   if(old_sigterm_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGINT, &sigterm_action, NULL);
     if(ret == -1){
-      perror("sigaction");
+      perror_plus("sigaction");
       exitcode = EX_OSERR;
       goto end;
     }
   }
   ret = sigaction(SIGHUP, NULL, &old_sigterm_action);
   if(ret == -1){
-    perror("sigaction");
+    perror_plus("sigaction");
     return EX_OSERR;
   }
   if(old_sigterm_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGHUP, &sigterm_action, NULL);
     if(ret == -1){
-      perror("sigaction");
+      perror_plus("sigaction");
       exitcode = EX_OSERR;
       goto end;
     }
   }
   ret = sigaction(SIGTERM, NULL, &old_sigterm_action);
   if(ret == -1){
-    perror("sigaction");
+    perror_plus("sigaction");
     return EX_OSERR;
   }
   if(old_sigterm_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGTERM, &sigterm_action, NULL);
     if(ret == -1){
-      perror("sigaction");
+      perror_plus("sigaction");
       exitcode = EX_OSERR;
       goto end;
     }
@@ -1411,7 +1638,7 @@
     errno = 0;
     ret = seteuid(0);
     if(ret == -1){
-      perror("seteuid");
+      perror_plus("seteuid");
     }
     
 #ifdef __linux__
@@ -1421,19 +1648,19 @@
     bool restore_loglevel = true;
     if(ret == -1){
       restore_loglevel = false;
-      perror("klogctl");
+      perror_plus("klogctl");
     }
 #endif	/* __linux__ */
     
     sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
     if(sd < 0){
-      perror("socket");
+      perror_plus("socket");
       exitcode = EX_OSERR;
 #ifdef __linux__
       if(restore_loglevel){
 	ret = klogctl(7, NULL, 0);
 	if(ret == -1){
-	  perror("klogctl");
+	  perror_plus("klogctl");
 	}
       }
 #endif	/* __linux__ */
@@ -1441,19 +1668,19 @@
       errno = 0;
       ret = seteuid(uid);
       if(ret == -1){
-	perror("seteuid");
+	perror_plus("seteuid");
       }
       goto end;
     }
     strcpy(network.ifr_name, interface);
     ret = ioctl(sd, SIOCGIFFLAGS, &network);
     if(ret == -1){
-      perror("ioctl SIOCGIFFLAGS");
+      perror_plus("ioctl SIOCGIFFLAGS");
 #ifdef __linux__
       if(restore_loglevel){
 	ret = klogctl(7, NULL, 0);
 	if(ret == -1){
-	  perror("klogctl");
+	  perror_plus("klogctl");
 	}
       }
 #endif	/* __linux__ */
@@ -1462,7 +1689,7 @@
       errno = 0;
       ret = seteuid(uid);
       if(ret == -1){
-	perror("seteuid");
+	perror_plus("seteuid");
       }
       goto end;
     }
@@ -1472,13 +1699,13 @@
       ret = ioctl(sd, SIOCSIFFLAGS, &network);
       if(ret == -1){
 	take_down_interface = false;
-	perror("ioctl SIOCSIFFLAGS +IFF_UP");
+	perror_plus("ioctl SIOCSIFFLAGS +IFF_UP");
 	exitcode = EX_OSERR;
 #ifdef __linux__
 	if(restore_loglevel){
 	  ret = klogctl(7, NULL, 0);
 	  if(ret == -1){
-	    perror("klogctl");
+	    perror_plus("klogctl");
 	  }
 	}
 #endif	/* __linux__ */
@@ -1486,30 +1713,31 @@
 	errno = 0;
 	ret = seteuid(uid);
 	if(ret == -1){
-	  perror("seteuid");
+	  perror_plus("seteuid");
 	}
 	goto end;
       }
     }
-    /* sleep checking until interface is running */
+    /* Sleep checking until interface is running.
+       Check every 0.25s, up to total time of delay */
     for(int i=0; i < delay * 4; i++){
       ret = ioctl(sd, SIOCGIFFLAGS, &network);
       if(ret == -1){
-	perror("ioctl SIOCGIFFLAGS");
+	perror_plus("ioctl SIOCGIFFLAGS");
       } else if(network.ifr_flags & IFF_RUNNING){
 	break;
       }
       struct timespec sleeptime = { .tv_nsec = 250000000 };
       ret = nanosleep(&sleeptime, NULL);
       if(ret == -1 and errno != EINTR){
-	perror("nanosleep");
+	perror_plus("nanosleep");
       }
     }
     if(not take_down_interface){
       /* We won't need the socket anymore */
       ret = (int)TEMP_FAILURE_RETRY(close(sd));
       if(ret == -1){
-	perror("close");
+	perror_plus("close");
       }
     }
 #ifdef __linux__
@@ -1517,7 +1745,7 @@
       /* Restores kernel loglevel to default */
       ret = klogctl(7, NULL, 0);
       if(ret == -1){
-	perror("klogctl");
+	perror_plus("klogctl");
       }
     }
 #endif	/* __linux__ */
@@ -1527,13 +1755,13 @@
       /* Lower privileges */
       ret = seteuid(uid);
       if(ret == -1){
-	perror("seteuid");
+	perror_plus("seteuid");
       }
     } else {
       /* Lower privileges permanently */
       ret = setuid(uid);
       if(ret == -1){
-	perror("setuid");
+	perror_plus("setuid");
       }
     }
   }
@@ -1555,12 +1783,11 @@
     goto end;
   }
   
+  if(mkdtemp(tempdir) == NULL){
+    perror_plus("mkdtemp");
+    goto end;
+  }
   tempdir_created = true;
-  if(mkdtemp(tempdir) == NULL){
-    tempdir_created = false;
-    perror("mkdtemp");
-    goto end;
-  }
   
   if(quit_now){
     goto end;
@@ -1608,27 +1835,37 @@
     
     port = (uint16_t)tmpmax;
     *address = '\0';
-    address = connect_to;
     /* Colon in address indicates IPv6 */
     int af;
-    if(strchr(address, ':') != NULL){
+    if(strchr(connect_to, ':') != NULL){
       af = AF_INET6;
+      /* Accept [] around IPv6 address - see RFC 5952 */
+      if(connect_to[0] == '[' and address[-1] == ']')
+	{
+	  connect_to++;
+	  address[-1] = '\0';
+	}
     } else {
       af = AF_INET;
     }
+    address = connect_to;
     
     if(quit_now){
       goto end;
     }
-
+    
     while(not quit_now){
       ret = start_mandos_communication(address, port, if_index, af);
       if(quit_now or ret == 0){
 	break;
       }
-      sleep(15);
-    };
-
+      if(debug){
+	fprintf(stderr, "Retrying in %d seconds\n",
+		(int)retry_interval);
+      }
+      sleep((int)retry_interval);
+    }
+    
     if (not quit_now){
       exitcode = EXIT_SUCCESS;
     }
@@ -1690,8 +1927,13 @@
   if(debug){
     fprintf(stderr, "Starting Avahi loop search\n");
   }
-  
-  avahi_simple_poll_loop(mc.simple_poll);
+
+  ret = avahi_loop_with_timeout(mc.simple_poll,
+				(int)(retry_interval * 1000));
+  if(debug){
+    fprintf(stderr, "avahi_loop_with_timeout exited %s\n",
+	    (ret == 0) ? "successfully" : "with error");
+  }
   
  end:
   
@@ -1718,6 +1960,17 @@
   if(gpgme_initialized){
     gpgme_release(mc.ctx);
   }
+
+  /* Cleans up the circular linked list of Mandos servers the client
+     has seen */
+  if(mc.current_server != NULL){
+    mc.current_server->prev->next = NULL;
+    while(mc.current_server != NULL){
+      server *next = mc.current_server->next;
+      free(mc.current_server);
+      mc.current_server = next;
+    }
+  }
   
   /* Take down the network interface */
   if(take_down_interface){
@@ -1725,59 +1978,46 @@
     errno = 0;
     ret = seteuid(0);
     if(ret == -1){
-      perror("seteuid");
+      perror_plus("seteuid");
     }
     if(geteuid() == 0){
       ret = ioctl(sd, SIOCGIFFLAGS, &network);
       if(ret == -1){
-	perror("ioctl SIOCGIFFLAGS");
+	perror_plus("ioctl SIOCGIFFLAGS");
       } else if(network.ifr_flags & IFF_UP) {
 	network.ifr_flags &= ~(short)IFF_UP; /* clear flag */
 	ret = ioctl(sd, SIOCSIFFLAGS, &network);
 	if(ret == -1){
-	  perror("ioctl SIOCSIFFLAGS -IFF_UP");
+	  perror_plus("ioctl SIOCSIFFLAGS -IFF_UP");
 	}
       }
       ret = (int)TEMP_FAILURE_RETRY(close(sd));
       if(ret == -1){
-	perror("close");
+	perror_plus("close");
       }
       /* Lower privileges permanently */
       errno = 0;
       ret = setuid(uid);
       if(ret == -1){
-	perror("setuid");
+	perror_plus("setuid");
       }
     }
   }
   
-  /* Removes the temp directory used by GPGME */
+  /* Removes the GPGME temp directory and all files inside */
   if(tempdir_created){
-    DIR *d;
-    struct dirent *direntry;
-    d = opendir(tempdir);
-    if(d == NULL){
-      if(errno != ENOENT){
-	perror("opendir");
-      }
-    } else {
-      while(true){
-	direntry = readdir(d);
-	if(direntry == NULL){
-	  break;
-	}
-	/* Skip "." and ".." */
-	if(direntry->d_name[0] == '.'
-	   and (direntry->d_name[1] == '\0'
-		or (direntry->d_name[1] == '.'
-		    and direntry->d_name[2] == '\0'))){
-	  continue;
-	}
+    struct dirent **direntries = NULL;
+    struct dirent *direntry = NULL;
+    int numentries = scandir(tempdir, &direntries, notdotentries,
+			     alphasort);
+    if (numentries > 0){
+      for(int i = 0; i < numentries; i++){
+	direntry = direntries[i];
 	char *fullname = NULL;
 	ret = asprintf(&fullname, "%s/%s", tempdir,
 		       direntry->d_name);
 	if(ret < 0){
-	  perror("asprintf");
+	  perror_plus("asprintf");
 	  continue;
 	}
 	ret = remove(fullname);
@@ -1787,11 +2027,16 @@
 	}
 	free(fullname);
       }
-      closedir(d);
+    }
+
+    /* need to clean even if 0 because man page doesn't specify */
+    free(direntries);
+    if (numentries == -1){
+      perror_plus("scandir");
     }
     ret = rmdir(tempdir);
     if(ret == -1 and errno != ENOENT){
-      perror("rmdir");
+      perror_plus("rmdir");
     }
   }
   
@@ -1802,13 +2047,13 @@
 					    &old_sigterm_action,
 					    NULL));
     if(ret == -1){
-      perror("sigaction");
+      perror_plus("sigaction");
     }
     do {
       ret = raise(signal_received);
     } while(ret != 0 and errno == EINTR);
     if(ret != 0){
-      perror("raise");
+      perror_plus("raise");
       abort();
     }
     TEMP_FAILURE_RETRY(pause());

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2010-09-26 18:32:58 +0000
+++ plugins.d/mandos-client.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -33,6 +33,7 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -97,6 +98,10 @@
       </arg>
       <sbr/>
       <arg>
+	<option>--retry <replaceable>SECONDS</replaceable></option>
+      </arg>
+      <sbr/>
+      <arg>
 	<option>--debug</option>
       </arg>
     </cmdsynopsis>
@@ -133,9 +138,9 @@
       using TLS with an OpenPGP key to ensure authenticity and
       confidentiality.  This client program keeps running, trying all
       servers on the network, until it receives a satisfactory reply
-      or a TERM signal is received.  If no servers are found, or after
-      all servers have been tried, it waits indefinitely for new
-      servers to appear.
+      or a TERM signal.  After all servers have been tried, all
+      servers are periodically retried.  If no servers are found it
+      will wait indefinitely for new servers to appear.
     </para>
     <para>
       This program is not meant to be run directly; it is really meant
@@ -293,6 +298,19 @@
 	  </para>
 	</listitem>
       </varlistentry>
+
+      <varlistentry>
+	<term><option>--retry=<replaceable
+	>SECONDS</replaceable></option></term>
+	<listitem>
+	  <para>
+	    All Mandos servers are tried repeatedly until a password
+	    is received.  This value specifies, in seconds, how long
+	    between each successive try <emphasis>for the same
+	    server</emphasis>.  The default is 10 seconds.
+	  </para>
+	</listitem>
+      </varlistentry>
       
       <varlistentry>
 	<term><option>--debug</option></term>
@@ -371,9 +389,9 @@
       server could be found and the password received from it could be
       successfully decrypted and output on standard output.  The
       program will exit with a non-zero exit status only if a critical
-      error occurs.  Otherwise, it will forever connect to new
-      <application>Mandos</application> servers as they appear, trying
-      to get a decryptable password and print it.
+      error occurs.  Otherwise, it will forever connect to any
+      discovered <application>Mandos</application> servers, trying to
+      get a decryptable password and print it.
     </para>
   </refsect1>
   
@@ -518,6 +536,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>cryptsetup</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>crypttab</refentrytitle>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2010-09-26 18:32:58 +0000
+++ plugins.d/password-prompt.c	2011-07-27 17:58:27 +0000
@@ -22,32 +22,37 @@
  * Contact the authors at <mandos@fukt.bsnet.se>.
  */
 
-#define _GNU_SOURCE		/* getline() */
+#define _GNU_SOURCE		/* getline(), asprintf() */
 
-#include <termios.h> 		/* struct termios, tcsetattr(),
+#include <termios.h>		/* struct termios, tcsetattr(),
 				   TCSAFLUSH, tcgetattr(), ECHO */
 #include <unistd.h>		/* struct termios, tcsetattr(),
 				   STDIN_FILENO, TCSAFLUSH,
-				   tcgetattr(), ECHO */
+				   tcgetattr(), ECHO, readlink() */
 #include <signal.h>		/* sig_atomic_t, raise(), struct
 				   sigaction, sigemptyset(),
 				   sigaction(), sigaddset(), SIGINT,
 				   SIGQUIT, SIGHUP, SIGTERM,
 				   raise() */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
-#include <sys/types.h>		/* ssize_t */
+#include <sys/types.h>		/* ssize_t, struct dirent, pid_t,
+				   ssize_t, open() */
 #include <stdlib.h>		/* EXIT_SUCCESS, EXIT_FAILURE,
-				   getenv() */
+				   getenv(), free() */
+#include <dirent.h>		/* scandir(), alphasort() */
 #include <stdio.h>		/* fprintf(), stderr, getline(),
-				   stdin, feof(), fputc()
-				*/
+				   stdin, feof(), fputc(), vfprintf(),
+				   vasprintf() */
 #include <errno.h>		/* errno, EBADF, ENOTTY, EINVAL,
 				   EFAULT, EFBIG, EIO, ENOSPC, EINTR
 				*/
 #include <error.h>		/* error() */
 #include <iso646.h>		/* or, not */
 #include <stdbool.h>		/* bool, false, true */
-#include <string.h> 		/* strlen, rindex */
+#include <inttypes.h>		/* strtoumax() */
+#include <sys/stat.h>		/* struct stat, lstat(), open() */
+#include <string.h>		/* strlen, rindex, memcmp, strerror()
+				 */
 #include <argp.h>		/* struct argp_option, struct
 				   argp_state, struct argp,
 				   argp_parse(), error_t,
@@ -55,6 +60,8 @@
 				   ARGP_ERR_UNKNOWN */
 #include <sysexits.h>		/* EX_SOFTWARE, EX_OSERR,
 				   EX_UNAVAILABLE, EX_IOERR, EX_OK */
+#include <fcntl.h>		/* open() */
+#include <stdarg.h>		/* va_list, va_start(), ... */
 
 volatile sig_atomic_t quit_now = 0;
 int signal_received;
@@ -62,6 +69,32 @@
 const char *argp_program_version = "password-prompt " VERSION;
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
+/* Needed for conflict resolution */
+const char plymouth_name[] = "plymouthd";
+
+/* Function to use when printing errors */
+void error_plus(int status, int errnum, const char *formatstring,
+		...){
+  va_list ap;
+  char *text;
+  int ret;
+  
+  va_start(ap, formatstring);
+  ret = vasprintf(&text, formatstring, ap);
+  if (ret == -1){
+    fprintf(stderr, "Mandos plugin %s: ",
+	    program_invocation_short_name);
+    vfprintf(stderr, formatstring, ap);
+    fprintf(stderr, ": ");
+    fprintf(stderr, "%s\n", strerror(errnum));
+    error(status, errno, "vasprintf while printing error");
+    return;
+  }
+  fprintf(stderr, "Mandos plugin ");
+  error(status, errnum, "%s", text);
+  free(text);
+}
+
 static void termination_handler(int signum){
   if(quit_now){
     return;
@@ -70,6 +103,122 @@
   signal_received = signum;
 }
 
+bool conflict_detection(void){
+
+  /* plymouth conflicts with password-prompt since both want to read
+     from the terminal.  Password-prompt will exit if it detects
+     plymouth since plymouth performs the same functionality.
+   */
+  int is_plymouth(const struct dirent *proc_entry){
+    int ret;
+    int cl_fd;
+    {
+      uintmax_t maxvalue;
+      char *tmp;
+      errno = 0;
+      maxvalue = strtoumax(proc_entry->d_name, &tmp, 10);
+      
+      if(errno != 0 or *tmp != '\0'
+	 or maxvalue != (uintmax_t)((pid_t)maxvalue)){
+	return 0;
+      }
+    }
+    
+    char *cmdline_filename;
+    ret = asprintf(&cmdline_filename, "/proc/%s/cmdline",
+		   proc_entry->d_name);
+    if(ret == -1){
+      error(0, errno, "asprintf");
+      return 0;
+    }
+    
+    /* Open /proc/<pid>/cmdline */
+    cl_fd = open(cmdline_filename, O_RDONLY);
+    free(cmdline_filename);
+    if(cl_fd == -1){
+      if(errno != ENOENT){
+	error(0, errno, "open");
+      }
+      return 0;
+    }
+    
+    char *cmdline = NULL;
+    {
+      size_t cmdline_len = 0;
+      size_t cmdline_allocated = 0;
+      char *tmp;
+      const size_t blocksize = 1024;
+      ssize_t sret;
+      do {
+	/* Allocate more space? */
+	if(cmdline_len + blocksize + 1 > cmdline_allocated){
+	  tmp = realloc(cmdline, cmdline_allocated + blocksize + 1);
+	  if(tmp == NULL){
+	    error(0, errno, "realloc");
+	    free(cmdline);
+	    close(cl_fd);
+	    return 0;
+	  }
+	  cmdline = tmp;
+	  cmdline_allocated += blocksize;
+	}
+	
+	/* Read data */
+	sret = read(cl_fd, cmdline + cmdline_len,
+		    cmdline_allocated - cmdline_len);
+	if(sret == -1){
+	  error(0, errno, "read");
+	  free(cmdline);
+	  close(cl_fd);
+	  return 0;
+	}
+	cmdline_len += (size_t)sret;
+      } while(sret != 0);
+      ret = close(cl_fd);
+      if(ret == -1){
+	error(0, errno, "close");
+	free(cmdline);
+	return 0;
+      }
+      cmdline[cmdline_len] = '\0'; /* Make sure it is terminated */
+    }
+    /* we now have cmdline */
+    
+    /* get basename */
+    char *cmdline_base = strrchr(cmdline, '/');
+    if(cmdline_base != NULL){
+      cmdline_base += 1;		/* skip the slash */
+    } else {
+      cmdline_base = cmdline;
+    }
+    
+    if(strcmp(cmdline_base, plymouth_name) != 0){
+      if(debug){
+	fprintf(stderr, "\"%s\" is not \"%s\"\n", cmdline_base,
+		plymouth_name);
+      }
+      free(cmdline);
+      return 0;
+    }
+    if(debug){
+      fprintf(stderr, "\"%s\" equals \"%s\"\n", cmdline_base,
+	      plymouth_name);
+    }
+    free(cmdline);
+    return 1;
+  }
+  
+  struct dirent **direntries = NULL;
+  int ret;
+  ret = scandir("/proc", &direntries, is_plymouth, alphasort);
+  if (ret == -1){
+    error(1, errno, "scandir");
+  }
+  free(direntries);
+  return ret > 0;
+}
+
+
 int main(int argc, char **argv){
   ssize_t sret;
   int ret;
@@ -151,6 +300,14 @@
   if(debug){
     fprintf(stderr, "Starting %s\n", argv[0]);
   }
+
+  if (conflict_detection()){
+    if(debug){
+      fprintf(stderr, "Stopping %s because of conflict\n", argv[0]);
+    }
+    return EXIT_FAILURE;
+  }
+  
   if(debug){
     fprintf(stderr, "Storing current terminal attributes\n");
   }
@@ -354,8 +511,8 @@
 	break;
       }
     }
-    /* if(sret == 0), then the only sensible thing to do is to retry to
-       read from stdin */
+    /* if(sret == 0), then the only sensible thing to do is to retry
+       to read from stdin */
     fputc('\n', stderr);
     if(debug and not quit_now){
       /* If quit_now is nonzero, we were interrupted by a signal, and

=== modified file 'plugins.d/password-prompt.xml'
--- plugins.d/password-prompt.xml	2009-10-30 16:23:43 +0000
+++ plugins.d/password-prompt.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "password-prompt">
-<!ENTITY TIMESTAMP "2009-10-30">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -33,6 +33,7 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -292,6 +293,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>
       <citerefentry><refentrytitle>crypttab</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>
       <citerefentry><refentrytitle>mandos-client</refentrytitle>

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2010-09-26 18:32:58 +0000
+++ plugins.d/plymouth.c	2011-07-13 02:24:39 +0000
@@ -1,9 +1,9 @@
 /*  -*- coding: utf-8 -*- */
 /*
- * Usplash - Read a password from usplash and output it
+ * Plymouth - Read a password from Plymouth and output it
  * 
- * Copyright © 2010 Teddy Hogeborn
- * Copyright © 2010 Björn Påhlsson
+ * Copyright © 2010-2011 Teddy Hogeborn
+ * Copyright © 2010-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -36,7 +36,8 @@
 #include <stddef.h>		/* NULL */
 #include <string.h>		/* strchr(), memcmp() */
 #include <stdio.h>		/* asprintf(), perror(), fopen(),
-				   fscanf() */
+				   fscanf(), vasprintf(), fprintf(),
+				   vfprintf() */
 #include <unistd.h>		/* close(), readlink(), read(),
 				   fork(), setsid(), chdir(), dup2(),
 				   STDERR_FILENO, execv(), access() */
@@ -50,6 +51,7 @@
 #include <error.h>		/* error() */
 #include <errno.h>		/* TEMP_FAILURE_RETRY */
 #include <argz.h>		/* argz_count(), argz_extract() */
+#include <stdarg.h>		/* va_list, va_start(), ... */
 
 sig_atomic_t interrupted_by_signal = 0;
 const char plymouth_pid[] = "/dev/.initramfs/plymouth.pid";
@@ -70,27 +72,52 @@
   interrupted_by_signal = 1;
 }
 
+/* Function to use when printing errors */
+void error_plus(int status, int errnum, const char *formatstring,
+		...){
+  va_list ap;
+  char *text;
+  int ret;
+  
+  va_start(ap, formatstring);
+  ret = vasprintf(&text, formatstring, ap);
+  if (ret == -1){
+    fprintf(stderr, "Mandos plugin %s: ",
+	    program_invocation_short_name);
+    vfprintf(stderr, formatstring, ap);
+    fprintf(stderr, ": ");
+    fprintf(stderr, "%s\n", strerror(errnum));
+    error(status, errno, "vasprintf while printing error");
+    return;
+  }
+  fprintf(stderr, "Mandos plugin ");
+  error(status, errnum, "%s", text);
+  free(text);
+}
+
 /* Create prompt string */
 char *makeprompt(void){
   int ret = 0;
   char *prompt;
   const char *const cryptsource = getenv("cryptsource");
   const char *const crypttarget = getenv("crypttarget");
-  const char prompt_start[] = "Enter passphrase to unlock the disk";
+  const char prompt_start[] = "Unlocking the disk";
+  const char prompt_end[] = "Enter passphrase";
   
   if(cryptsource == NULL){
     if(crypttarget == NULL){
-      ret = asprintf(&prompt, "%s: ", prompt_start);
+      ret = asprintf(&prompt, "%s\n%s", prompt_start, prompt_end);
     } else {
-      ret = asprintf(&prompt, "%s (%s): ", prompt_start,
-		     crypttarget);
+      ret = asprintf(&prompt, "%s (%s)\n%s", prompt_start,
+		     crypttarget, prompt_end);
     }
   } else {
     if(crypttarget == NULL){
-      ret = asprintf(&prompt, "%s %s: ", prompt_start, cryptsource);
+      ret = asprintf(&prompt, "%s %s\n%s", prompt_start, cryptsource,
+		     prompt_end);
     } else {
-      ret = asprintf(&prompt, "%s %s (%s): ", prompt_start,
-		     cryptsource, crypttarget);
+      ret = asprintf(&prompt, "%s %s (%s)\n%s", prompt_start,
+		     cryptsource, crypttarget, prompt_end);
     }
   }
   if(ret == -1){
@@ -107,18 +134,18 @@
 bool become_a_daemon(void){
   int ret = setuid(geteuid());
   if(ret == -1){
-    error(0, errno, "setuid");
+    error_plus(0, errno, "setuid");
   }
     
   setsid();
   ret = chdir("/");
   if(ret == -1){
-    error(0, errno, "chdir");
+    error_plus(0, errno, "chdir");
     return false;
   }
   ret = dup2(STDERR_FILENO, STDOUT_FILENO); /* replace our stdout */
   if(ret == -1){
-    error(0, errno, "dup2");
+    error_plus(0, errno, "dup2");
     return false;
   }
   return true;
@@ -132,7 +159,7 @@
   pid_t pid;
   pid = fork();
   if(pid == -1){
-    error(0, errno, "fork");
+    error_plus(0, errno, "fork");
     return false;
   }
   if(pid == 0){
@@ -142,24 +169,24 @@
 	_exit(EX_OSERR);
       }
     }
-
+    
     char **new_argv = NULL;
-    char *tmp;
+    char **tmp;
     int i = 0;
-    for (; argv[i]!=(char *)NULL; i++){
+    for (; argv[i]!=NULL; i++){
       tmp = realloc(new_argv, sizeof(const char *) * ((size_t)i + 1));
       if (tmp == NULL){
-	error(0, errno, "realloc");
+	error_plus(0, errno, "realloc");
 	free(new_argv);
 	_exit(EX_OSERR);
       }
-      new_argv = (char **)tmp;
+      new_argv = tmp;
       new_argv[i] = strdup(argv[i]);
     }
-    new_argv[i] = (char *) NULL;
+    new_argv[i] = NULL;
     
     execv(path, (char *const *)new_argv);
-    error(0, errno, "execv");
+    error_plus(0, errno, "execv");
     _exit(EXIT_FAILURE);
   }
   if(pid_return != NULL){
@@ -174,7 +201,7 @@
     return false;
   }
   if(ret == -1){
-    error(0, errno, "waitpid");
+    error_plus(0, errno, "waitpid");
     return false;
   }
   if(WIFEXITED(status) and (WEXITSTATUS(status) == 0)){
@@ -196,11 +223,11 @@
       return 0;
     }
   }
-  char exe_target[sizeof(plymouth_path)];
+  char exe_target[sizeof(plymouthd_path)];
   char *exe_link;
   ret = asprintf(&exe_link, "/proc/%s/exe", proc_entry->d_name);
   if(ret == -1){
-    error(0, errno, "asprintf");
+    error_plus(0, errno, "asprintf");
     return 0;
   }
   
@@ -209,7 +236,7 @@
   if(ret == -1){
     free(exe_link);
     if(errno != ENOENT){
-      error(0, errno, "lstat");
+      error_plus(0, errno, "lstat");
     }
     return 0;
   }
@@ -223,9 +250,9 @@
   
   ssize_t sret = readlink(exe_link, exe_target, sizeof(exe_target));
   free(exe_link);
-  if((sret != (ssize_t)sizeof(plymouth_path)-1) or
-      (memcmp(plymouth_path, exe_target,
-	      sizeof(plymouth_path)-1) != 0)){
+  if((sret != (ssize_t)sizeof(plymouthd_path)-1) or
+      (memcmp(plymouthd_path, exe_target,
+	      sizeof(plymouthd_path)-1) != 0)){
     return 0;
   }
   return 1;
@@ -243,9 +270,20 @@
     fclose(pidfile);
   }
   if(maxvalue == 0){
-    struct dirent **direntries;
+    struct dirent **direntries = NULL;
     ret = scandir("/proc", &direntries, is_plymouth, alphasort);
-    sscanf(direntries[0]->d_name, "%" SCNuMAX, &maxvalue);
+    if (ret == -1){
+      error_plus(0, errno, "scandir");
+    }
+    if (ret > 0){
+      ret = sscanf(direntries[0]->d_name, "%" SCNuMAX, &maxvalue);
+      if (ret < 0){
+	error_plus(0, errno, "sscanf");
+      }
+    }
+    /* scandir might preallocate for this variable (man page unclear).
+       even if ret == 0, therefore we need to free it. */
+    free(direntries);
   }
   pid_t pid;
   pid = (pid_t)maxvalue;
@@ -265,7 +303,7 @@
   ret = asprintf(&cmdline_filename, "/proc/%" PRIuMAX "/cmdline",
 		 (uintmax_t)pid);
   if(ret == -1){
-    error(0, errno, "asprintf");
+    error_plus(0, errno, "asprintf");
     return NULL;
   }
   
@@ -273,7 +311,7 @@
   cl_fd = open(cmdline_filename, O_RDONLY);
   free(cmdline_filename);
   if(cl_fd == -1){
-    error(0, errno, "open");
+    error_plus(0, errno, "open");
     return NULL;
   }
   
@@ -287,7 +325,7 @@
     if(cmdline_len + blocksize > cmdline_allocated){
       tmp = realloc(cmdline, cmdline_allocated + blocksize);
       if(tmp == NULL){
-	error(0, errno, "realloc");
+	error_plus(0, errno, "realloc");
 	free(cmdline);
 	close(cl_fd);
 	return NULL;
@@ -300,7 +338,7 @@
     sret = read(cl_fd, cmdline + cmdline_len,
 		cmdline_allocated - cmdline_len);
     if(sret == -1){
-      error(0, errno, "read");
+      error_plus(0, errno, "read");
       free(cmdline);
       close(cl_fd);
       return NULL;
@@ -309,7 +347,7 @@
   } while(sret != 0);
   ret = close(cl_fd);
   if(ret == -1){
-    error(0, errno, "close");
+    error_plus(0, errno, "close");
     free(cmdline);
     return NULL;
   }
@@ -318,7 +356,7 @@
   char **argv = malloc((argz_count(cmdline, cmdline_len) + 1)
 		       * sizeof(char *)); /* Get number of args */
   if(argv == NULL){
-    error(0, errno, "argv = malloc()");
+    error_plus(0, errno, "argv = malloc()");
     free(cmdline);
     return NULL;
   }
@@ -351,16 +389,16 @@
 	*sig != 0; sig++){
       ret = sigaddset(&new_action.sa_mask, *sig);
       if(ret == -1){
-	error(EX_OSERR, errno, "sigaddset");
+	error_plus(EX_OSERR, errno, "sigaddset");
       }
       ret = sigaction(*sig, NULL, &old_action);
       if(ret == -1){
-	error(EX_OSERR, errno, "sigaction");
+	error_plus(EX_OSERR, errno, "sigaction");
       }
       if(old_action.sa_handler != SIG_IGN){
 	ret = sigaction(*sig, &new_action, NULL);
 	if(ret == -1){
-	  error(EX_OSERR, errno, "sigaction");
+	  error_plus(EX_OSERR, errno, "sigaction");
 	}
       }
     }
@@ -385,7 +423,7 @@
   ret = asprintf(&prompt_arg, "--prompt=%s", prompt);
   free(prompt);
   if(ret == -1){
-    error(EX_OSERR, errno, "asprintf");
+    error_plus(EX_OSERR, errno, "asprintf");
   }
   
   /* plymouth ask-for-password --prompt="$prompt" */
@@ -407,7 +445,7 @@
   const char **plymouthd_argv;
   pid_t pid = get_pid();
   if(pid == 0){
-    error(0, 0, "plymouthd pid not found");
+    error_plus(0, 0, "plymouthd pid not found");
     plymouthd_argv = plymouthd_default_argv;
   } else {
     plymouthd_argv = getargv(pid);

=== modified file 'plugins.d/plymouth.xml'
--- plugins.d/plymouth.xml	2010-09-26 18:32:58 +0000
+++ plugins.d/plymouth.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plymouth">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -32,6 +32,7 @@
     </authorgroup>
     <copyright>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -260,6 +261,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>crypttab</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>plugin-runner</refentrytitle>

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2010-10-07 17:46:56 +0000
+++ plugins.d/splashy.c	2011-07-13 02:24:39 +0000
@@ -2,8 +2,8 @@
 /*
  * Splashy - Read a password from splashy and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -29,7 +29,8 @@
 				   SIG_IGN, kill(), SIGKILL */
 #include <stddef.h>		/* NULL */
 #include <stdlib.h>		/* getenv() */
-#include <stdio.h>		/* asprintf() */
+#include <stdio.h>		/* asprintf(), vasprintf(), vprintf(),
+				   fprintf() */
 #include <stdlib.h>		/* EXIT_FAILURE, free(),
 				   EXIT_SUCCESS */
 #include <sys/types.h>		/* pid_t, DIR, struct dirent,
@@ -42,7 +43,7 @@
 				   sleep(), dup2() STDERR_FILENO,
 				   STDOUT_FILENO, _exit(),
 				   pause() */
-#include <string.h>		/* memcmp() */
+#include <string.h>		/* memcmp(), strerror() */
 #include <errno.h>		/* errno, EACCES, ENOTDIR, ELOOP,
 				   ENOENT, ENAMETOOLONG, EMFILE,
 				   ENFILE, ENOMEM, ENOEXEC, EINVAL,
@@ -54,10 +55,35 @@
 				   WEXITSTATUS() */
 #include <sysexits.h>		/* EX_OSERR, EX_OSFILE,
 				   EX_UNAVAILABLE */
+#include <stdarg.h>		/* va_list, va_start(), ... */
 
 sig_atomic_t interrupted_by_signal = 0;
 int signal_received;
 
+/* Function to use when printing errors */
+void error_plus(int status, int errnum, const char *formatstring,
+		...){
+  va_list ap;
+  char *text;
+  int ret;
+  
+  va_start(ap, formatstring);
+  ret = vasprintf(&text, formatstring, ap);
+  if (ret == -1){
+    fprintf(stderr, "Mandos plugin %s: ",
+	    program_invocation_short_name);
+    vfprintf(stderr, formatstring, ap);
+    fprintf(stderr, ": ");
+    fprintf(stderr, "%s\n", strerror(errnum));
+    error(status, errno, "vasprintf while printing error");
+    return;
+  }
+  fprintf(stderr, "Mandos plugin ");
+  error(status, errnum, "%s", text);
+  free(text);
+}
+
+
 static void termination_handler(int signum){
   if(interrupted_by_signal){
     return;
@@ -110,7 +136,7 @@
     proc_dir = opendir("/proc");
     if(proc_dir == NULL){
       int e = errno;
-      error(0, errno, "opendir");
+      error_plus(0, errno, "opendir");
       switch(e){
       case EACCES:
       case ENOTDIR:
@@ -152,7 +178,7 @@
 	char *exe_link;
 	ret = asprintf(&exe_link, "/proc/%s/exe", proc_ent->d_name);
 	if(ret == -1){
-	  error(0, errno, "asprintf");
+	  error_plus(0, errno, "asprintf");
 	  exitstatus = EX_OSERR;
 	  goto failure;
 	}
@@ -166,7 +192,7 @@
 	    continue;
 	  }
 	  int e = errno;
-	  error(0, errno, "lstat");
+	  error_plus(0, errno, "lstat");
 	  free(exe_link);
 	  switch(e){
 	  case EACCES:
@@ -214,60 +240,60 @@
     sigemptyset(&new_action.sa_mask);
     ret = sigaddset(&new_action.sa_mask, SIGINT);
     if(ret == -1){
-      error(0, errno, "sigaddset");
+      error_plus(0, errno, "sigaddset");
       exitstatus = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGHUP);
     if(ret == -1){
-      error(0, errno, "sigaddset");
+      error_plus(0, errno, "sigaddset");
       exitstatus = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGTERM);
     if(ret == -1){
-      error(0, errno, "sigaddset");
+      error_plus(0, errno, "sigaddset");
       exitstatus = EX_OSERR;
       goto failure;
     }
     ret = sigaction(SIGINT, NULL, &old_action);
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
       exitstatus = EX_OSERR;
       goto failure;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGINT, &new_action, NULL);
       if(ret == -1){
-	error(0, errno, "sigaction");
+	error_plus(0, errno, "sigaction");
 	exitstatus = EX_OSERR;
 	goto failure;
       }
     }
     ret = sigaction(SIGHUP, NULL, &old_action);
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
       exitstatus = EX_OSERR;
       goto failure;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGHUP, &new_action, NULL);
       if(ret == -1){
-	error(0, errno, "sigaction");
+	error_plus(0, errno, "sigaction");
 	exitstatus = EX_OSERR;
 	goto failure;
       }
     }
     ret = sigaction(SIGTERM, NULL, &old_action);
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
       exitstatus = EX_OSERR;
       goto failure;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGTERM, &new_action, NULL);
       if(ret == -1){
-	error(0, errno, "sigaction");
+	error_plus(0, errno, "sigaction");
 	exitstatus = EX_OSERR;
 	goto failure;
       }
@@ -284,7 +310,7 @@
     goto failure;
   }
   if(splashy_command_pid == -1){
-    error(0, errno, "fork");
+    error_plus(0, errno, "fork");
     exitstatus = EX_OSERR;
     goto failure;
   }
@@ -294,7 +320,7 @@
       const char splashy_command[] = "/sbin/splashy_update";
       execl(splashy_command, splashy_command, prompt, (char *)NULL);
       int e = errno;
-      error(0, errno, "execl");
+      error_plus(0, errno, "execl");
       switch(e){
       case EACCES:
       case ENOENT:
@@ -344,7 +370,7 @@
       goto failure;
     }
     if(ret == -1){
-      error(0, errno, "waitpid");
+      error_plus(0, errno, "waitpid");
       if(errno == ECHILD){
 	splashy_command_pid = 0;
       }
@@ -382,27 +408,27 @@
 	 the real user ID (_mandos) */
       ret = setuid(geteuid());
       if(ret == -1){
-	error(0, errno, "setuid");
+	error_plus(0, errno, "setuid");
       }
       
       setsid();
       ret = chdir("/");
       if(ret == -1){
-	error(0, errno, "chdir");
+	error_plus(0, errno, "chdir");
       }
 /*       if(fork() != 0){ */
 /* 	_exit(EXIT_SUCCESS); */
 /*       } */
       ret = dup2(STDERR_FILENO, STDOUT_FILENO); /* replace stdout */
       if(ret == -1){
-	error(0, errno, "dup2");
+	error_plus(0, errno, "dup2");
 	_exit(EX_OSERR);
       }
       
       execl("/sbin/splashy", "/sbin/splashy", "boot", (char *)NULL);
       {
 	int e = errno;
-	error(0, errno, "execl");
+	error_plus(0, errno, "execl");
 	switch(e){
 	case EACCES:
 	case ENOENT:
@@ -428,13 +454,13 @@
     ret = (int)TEMP_FAILURE_RETRY(sigaction(signal_received,
 					    &signal_action, NULL));
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
     }
     do {
       ret = raise(signal_received);
     } while(ret != 0 and errno == EINTR);
     if(ret != 0){
-      error(0, errno, "raise");
+      error_plus(0, errno, "raise");
       abort();
     }
     TEMP_FAILURE_RETRY(pause());

=== modified file 'plugins.d/splashy.xml'
--- plugins.d/splashy.xml	2009-01-04 21:54:55 +0000
+++ plugins.d/splashy.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "splashy">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -33,6 +33,7 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -263,6 +264,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>crypttab</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>plugin-runner</refentrytitle>

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2010-09-26 18:32:58 +0000
+++ plugins.d/usplash.c	2011-07-13 02:24:39 +0000
@@ -2,8 +2,8 @@
 /*
  * Usplash - Read a password from usplash and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -35,8 +35,9 @@
 #include <sys/types.h>		/* size_t, ssize_t, pid_t, DIR, struct
 				   dirent */
 #include <stddef.h>		/* NULL */
-#include <string.h>		/* strlen(), memcmp() */
-#include <stdio.h>		/* asprintf()*/
+#include <string.h>		/* strlen(), memcmp(), strerror() */
+#include <stdio.h>		/* asprintf(), vasprintf(), vprintf(),
+				   fprintf() */
 #include <unistd.h>		/* close(), write(), readlink(),
 				   read(), STDOUT_FILENO, sleep(),
 				   fork(), setuid(), geteuid(),
@@ -50,11 +51,35 @@
 #include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK */
 #include <sysexits.h>		/* EX_OSERR, EX_UNAVAILABLE */
 #include <argz.h>		/* argz_count(), argz_extract() */
+#include <stdarg.h>		/* va_list, va_start(), ... */
 
 sig_atomic_t interrupted_by_signal = 0;
 int signal_received;
 const char usplash_name[] = "/sbin/usplash";
 
+/* Function to use when printing errors */
+void error_plus(int status, int errnum, const char *formatstring,
+		...){
+  va_list ap;
+  char *text;
+  int ret;
+  
+  va_start(ap, formatstring);
+  ret = vasprintf(&text, formatstring, ap);
+  if (ret == -1){
+    fprintf(stderr, "Mandos plugin %s: ",
+	    program_invocation_short_name);
+    vfprintf(stderr, formatstring, ap);
+    fprintf(stderr, ": ");
+    fprintf(stderr, "%s\n", strerror(errnum));
+    error(status, errno, "vasprintf while printing error");
+    return;
+  }
+  fprintf(stderr, "Mandos plugin ");
+  error(status, errnum, "%s", text);
+  free(text);
+}
+
 static void termination_handler(int signum){
   if(interrupted_by_signal){
     return;
@@ -155,7 +180,7 @@
   size_t cmdline_len = 0;
   DIR *proc_dir = opendir("/proc");
   if(proc_dir == NULL){
-    error(0, errno, "opendir");
+    error_plus(0, errno, "opendir");
     return -1;
   }
   errno = 0;
@@ -183,7 +208,7 @@
       char *exe_link;
       ret = asprintf(&exe_link, "/proc/%s/exe", proc_ent->d_name);
       if(ret == -1){
-	error(0, errno, "asprintf");
+	error_plus(0, errno, "asprintf");
 	goto fail_find_usplash;
       }
       
@@ -195,7 +220,7 @@
 	  free(exe_link);
 	  continue;
 	}
-	error(0, errno, "lstat");
+	error_plus(0, errno, "lstat");
 	free(exe_link);
 	goto fail_find_usplash;
       }
@@ -226,13 +251,13 @@
 	ret = asprintf(&cmdline_filename, "/proc/%s/cmdline",
 		       proc_ent->d_name);
 	if(ret == -1){
-	  error(0, errno, "asprintf");
+	  error_plus(0, errno, "asprintf");
 	  goto fail_find_usplash;
 	}
 	cl_fd = open(cmdline_filename, O_RDONLY);
 	free(cmdline_filename);
 	if(cl_fd == -1){
-	  error(0, errno, "open");
+	  error_plus(0, errno, "open");
 	  goto fail_find_usplash;
 	}
       }
@@ -244,7 +269,7 @@
 	if(cmdline_len + blocksize > cmdline_allocated){
 	  tmp = realloc(cmdline, cmdline_allocated + blocksize);
 	  if(tmp == NULL){
-	    error(0, errno, "realloc");
+	    error_plus(0, errno, "realloc");
 	    close(cl_fd);
 	    goto fail_find_usplash;
 	  }
@@ -255,7 +280,7 @@
 	sret = read(cl_fd, cmdline + cmdline_len,
 		    cmdline_allocated - cmdline_len);
 	if(sret == -1){
-	  error(0, errno, "read");
+	  error_plus(0, errno, "read");
 	  close(cl_fd);
 	  goto fail_find_usplash;
 	}
@@ -263,14 +288,14 @@
       } while(sret != 0);
       ret = close(cl_fd);
       if(ret == -1){
-	error(0, errno, "close");
+	error_plus(0, errno, "close");
 	goto fail_find_usplash;
       }
     }
     /* Close directory */
     ret = closedir(proc_dir);
     if(ret == -1){
-      error(0, errno, "closedir");
+      error_plus(0, errno, "closedir");
       goto fail_find_usplash;
     }
     /* Success */
@@ -325,26 +350,26 @@
     sigemptyset(&new_action.sa_mask);
     ret = sigaddset(&new_action.sa_mask, SIGINT);
     if(ret == -1){
-      error(0, errno, "sigaddset");
+      error_plus(0, errno, "sigaddset");
       status = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGHUP);
     if(ret == -1){
-      error(0, errno, "sigaddset");
+      error_plus(0, errno, "sigaddset");
       status = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGTERM);
     if(ret == -1){
-      error(0, errno, "sigaddset");
+      error_plus(0, errno, "sigaddset");
       status = EX_OSERR;
       goto failure;
     }
     ret = sigaction(SIGINT, NULL, &old_action);
     if(ret == -1){
       if(errno != EINTR){
-	error(0, errno, "sigaction");
+	error_plus(0, errno, "sigaction");
 	status = EX_OSERR;
       }
       goto failure;
@@ -353,7 +378,7 @@
       ret = sigaction(SIGINT, &new_action, NULL);
       if(ret == -1){
 	if(errno != EINTR){
-	  error(0, errno, "sigaction");
+	  error_plus(0, errno, "sigaction");
 	  status = EX_OSERR;
 	}
 	goto failure;
@@ -362,7 +387,7 @@
     ret = sigaction(SIGHUP, NULL, &old_action);
     if(ret == -1){
       if(errno != EINTR){
-	error(0, errno, "sigaction");
+	error_plus(0, errno, "sigaction");
 	status = EX_OSERR;
       }
       goto failure;
@@ -371,7 +396,7 @@
       ret = sigaction(SIGHUP, &new_action, NULL);
       if(ret == -1){
 	if(errno != EINTR){
-	  error(0, errno, "sigaction");
+	  error_plus(0, errno, "sigaction");
 	  status = EX_OSERR;
 	}
 	goto failure;
@@ -380,7 +405,7 @@
     ret = sigaction(SIGTERM, NULL, &old_action);
     if(ret == -1){
       if(errno != EINTR){
-	error(0, errno, "sigaction");
+	error_plus(0, errno, "sigaction");
 	status = EX_OSERR;
       }
       goto failure;
@@ -389,7 +414,7 @@
       ret = sigaction(SIGTERM, &new_action, NULL);
       if(ret == -1){
 	if(errno != EINTR){
-	  error(0, errno, "sigaction");
+	  error_plus(0, errno, "sigaction");
 	  status = EX_OSERR;
 	}
 	goto failure;
@@ -401,7 +426,7 @@
   /* Write command to FIFO */
   if(not usplash_write(&fifo_fd, "TIMEOUT", "0")){
     if(errno != EINTR){
-      error(0, errno, "usplash_write");
+      error_plus(0, errno, "usplash_write");
       status = EX_OSERR;
     }
     goto failure;
@@ -413,7 +438,7 @@
   
   if(not usplash_write(&fifo_fd, "INPUTQUIET", prompt)){
     if(errno != EINTR){
-      error(0, errno, "usplash_write");
+      error_plus(0, errno, "usplash_write");
       status = EX_OSERR;
     }
     goto failure;
@@ -431,7 +456,7 @@
   outfifo_fd = open("/dev/.initramfs/usplash_outfifo", O_RDONLY);
   if(outfifo_fd == -1){
     if(errno != EINTR){
-      error(0, errno, "open");
+      error_plus(0, errno, "open");
       status = EX_OSERR;
     }
     goto failure;
@@ -450,7 +475,7 @@
       char *tmp = realloc(buf, buf_allocated + blocksize);
       if(tmp == NULL){
 	if(errno != EINTR){
-	  error(0, errno, "realloc");
+	  error_plus(0, errno, "realloc");
 	  status = EX_OSERR;
 	}
 	goto failure;
@@ -462,7 +487,7 @@
 		buf_allocated - buf_len);
     if(sret == -1){
       if(errno != EINTR){
-	error(0, errno, "read");
+	error_plus(0, errno, "read");
 	status = EX_OSERR;
       }
       TEMP_FAILURE_RETRY(close(outfifo_fd));
@@ -477,7 +502,7 @@
   ret = close(outfifo_fd);
   if(ret == -1){
     if(errno != EINTR){
-      error(0, errno, "close");
+      error_plus(0, errno, "close");
       status = EX_OSERR;
     }
     goto failure;
@@ -490,7 +515,7 @@
   
   if(not usplash_write(&fifo_fd, "TIMEOUT", "15")){
     if(errno != EINTR){
-      error(0, errno, "usplash_write");
+      error_plus(0, errno, "usplash_write");
       status = EX_OSERR;
     }
     goto failure;
@@ -503,7 +528,7 @@
   ret = close(fifo_fd);
   if(ret == -1){
     if(errno != EINTR){
-      error(0, errno, "close");
+      error_plus(0, errno, "close");
       status = EX_OSERR;
     }
     goto failure;
@@ -517,7 +542,7 @@
       sret = write(STDOUT_FILENO, buf + written, buf_len - written);
       if(sret == -1){
 	if(errno != EINTR){
-	  error(0, errno, "write");
+	  error_plus(0, errno, "write");
 	  status = EX_OSERR;
 	}
 	goto failure;
@@ -554,7 +579,7 @@
   if(fifo_fd != -1){
     ret = (int)TEMP_FAILURE_RETRY(close(fifo_fd));
     if(ret == -1 and errno != EINTR){
-      error(0, errno, "close");
+      error_plus(0, errno, "close");
     }
     fifo_fd = -1;
   }
@@ -563,7 +588,7 @@
   if(outfifo_fd != -1){
     ret = (int)TEMP_FAILURE_RETRY(close(outfifo_fd));
     if(ret == -1){
-      error(0, errno, "close");
+      error_plus(0, errno, "close");
     }
   }
   
@@ -571,7 +596,7 @@
   char **cmdline_argv = malloc((argz_count(cmdline, cmdline_len) + 1)
 			       * sizeof(char *)); /* Count args */
   if(cmdline_argv == NULL){
-    error(0, errno, "malloc");
+    error_plus(0, errno, "malloc");
     return status;
   }
   argz_extract(cmdline, cmdline_len, cmdline_argv); /* Create argv */
@@ -592,13 +617,13 @@
        the real user ID (_mandos) */
     ret = setuid(geteuid());
     if(ret == -1){
-      error(0, errno, "setuid");
+      error_plus(0, errno, "setuid");
     }
     
     setsid();
     ret = chdir("/");
     if(ret == -1){
-      error(0, errno, "chdir");
+      error_plus(0, errno, "chdir");
       _exit(EX_OSERR);
     }
 /*     if(fork() != 0){ */
@@ -606,13 +631,13 @@
 /*     } */
     ret = dup2(STDERR_FILENO, STDOUT_FILENO); /* replace our stdout */
     if(ret == -1){
-      error(0, errno, "dup2");
+      error_plus(0, errno, "dup2");
       _exit(EX_OSERR);
     }
     
     execv(usplash_name, cmdline_argv);
     if(not interrupted_by_signal){
-      error(0, errno, "execv");
+      error_plus(0, errno, "execv");
     }
     free(cmdline);
     free(cmdline_argv);
@@ -623,7 +648,7 @@
   sleep(2);
   if(not usplash_write(&fifo_fd, "PULSATE", NULL)){
     if(errno != EINTR){
-      error(0, errno, "usplash_write");
+      error_plus(0, errno, "usplash_write");
     }
   }
   
@@ -631,7 +656,7 @@
   if(fifo_fd != -1){
     ret = (int)TEMP_FAILURE_RETRY(close(fifo_fd));
     if(ret == -1 and errno != EINTR){
-      error(0, errno, "close");
+      error_plus(0, errno, "close");
     }
     fifo_fd = -1;
   }
@@ -642,13 +667,13 @@
     ret = (int)TEMP_FAILURE_RETRY(sigaction(signal_received,
 					    &signal_action, NULL));
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
     }
     do {
       ret = raise(signal_received);
     } while(ret != 0 and errno == EINTR);
     if(ret != 0){
-      error(0, errno, "raise");
+      error_plus(0, errno, "raise");
       abort();
     }
     TEMP_FAILURE_RETRY(pause());

=== modified file 'plugins.d/usplash.xml'
--- plugins.d/usplash.xml	2009-01-04 21:54:55 +0000
+++ plugins.d/usplash.xml	2011-08-08 21:12:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "usplash">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2011-08-08">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -33,6 +33,7 @@
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -277,6 +278,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>crypttab</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>fifo</refentrytitle>

